//#include <sstream>
#include "stdafx.h"
#include "DataLoader.h"
#include "Table.h"

using namespace std;

void DataLoader::descriptorIdentity(bool descriptorLocationInLoop)
{
	int descriptorTag = readByte(); //dochazi ke cteni - je treba zvysit a snizit pocitadla !!!
	counterByte++;
	numberOfNotLoadedByte--;
	infoLength--;
	oneDescriptor.setTag(descriptorTag);
	questionAtEndTsPacket();
	switch (descriptorTag)
	{
	case DN_NETWORK_NAME:
		loadNetworkNameDescriptor();
		if (descriptorLocationInLoop)
		{
			loopDescriptors.push_back(oneDescriptor);
			return;
		}
		tableDescriptors.push_back(oneDescriptor);
		break;
	case DN_SERVICE_LIST:
		loadServiceListDescriptor();
		if (descriptorLocationInLoop)
		{
			loopDescriptors.push_back(oneDescriptor);
			return;
		}
		tableDescriptors.push_back(oneDescriptor);
		break;
	case DN_BOUQUET_NAME:
		loadBouquetNameDesctiptor();
		if (descriptorLocationInLoop)
		{
			loopDescriptors.push_back(oneDescriptor);
			return;
		}
		tableDescriptors.push_back(oneDescriptor);
		break;
	case DN_SERVICE:
		loadServiceDescriptor();
		if (descriptorLocationInLoop)
		{
			loopDescriptors.push_back(oneDescriptor);
			return;
		}
		tableDescriptors.push_back(oneDescriptor);
		break;
	case DN_SHORT_EVENT:
		loadShortEventDescriptor();
		if (descriptorLocationInLoop)
		{
			loopDescriptors.push_back(oneDescriptor);
			return;
		}
		tableDescriptors.push_back(oneDescriptor);
		break;
	case DN_EXTENDED_EVENT:
		loadExtendedEventDescriptor();
		if (descriptorLocationInLoop)
		{
			loopDescriptors.push_back(oneDescriptor);
			return;
		}
		tableDescriptors.push_back(oneDescriptor);
		break;
	case DN_COMPONENT:
		loadComponentDescriptor();
		if (descriptorLocationInLoop)
		{
			loopDescriptors.push_back(oneDescriptor);
			return;
		}
		tableDescriptors.push_back(oneDescriptor);
		break;
	case DN_CONTENT:
		loadContentDescriptor();
		if (descriptorLocationInLoop)
		{
			loopDescriptors.push_back(oneDescriptor);
			return;
		}
		tableDescriptors.push_back(oneDescriptor);
		break;
	case DN_TELETEXT:
		loadTeletextDescriptor();
		if (descriptorLocationInLoop)
		{
			loopDescriptors.push_back(oneDescriptor);
			return;
		}
		tableDescriptors.push_back(oneDescriptor);
		break;
	case DN_TERRESTRIAL_DELIVERY_SYSTEM:
		loadTerrestrialDeliverySystemDescriptor();
		if (descriptorLocationInLoop)
		{
			loopDescriptors.push_back(oneDescriptor);
			return;
		}
		tableDescriptors.push_back(oneDescriptor);
		break;
	case DN_FREQUENCY_LIST:
		loadFrequencyListDescriptor();
		if (descriptorLocationInLoop)
		{
			loopDescriptors.push_back(oneDescriptor);
			return;
		}
		tableDescriptors.push_back(oneDescriptor);
		break;
	case DN_APPLICATION_SIGNALLING:
		loadApplicationSignallingDescriptor();
		if (descriptorLocationInLoop)
		{
			loopDescriptors.push_back(oneDescriptor);
			return;
		}
		tableDescriptors.push_back(oneDescriptor);
		break;
	case DN_LOCAL_TIME_OFFSET:
		loadLocalTimeOffsetDescriptor();
		if (descriptorLocationInLoop)
		{
			loopDescriptors.push_back(oneDescriptor);	//nemelo by se sem nikdy skocit protoze descriptorLocationInLoop bymel byt vzdy false
			return;
		}
		tableDescriptors.push_back(oneDescriptor);
		break;
	default:
		loadRawDataDescriptor();
		if (descriptorLocationInLoop)
		{
			loopDescriptors.push_back(oneDescriptor);
			return;
		}
		tableDescriptors.push_back(oneDescriptor);
	}
}

void DataLoader::loadNetworkNameDescriptor()
{
	int descriptorLength = readByte();
	counterByte++;
	numberOfNotLoadedByte--;
	infoLength--;
	oneDescriptor.setLength(descriptorLength);
	questionAtEndTsPacket();
	string tempString;
	while (descriptorLength != 0)
	{
		//ptat se na diakritiku
		int tempChar = readByte();
		if (tempChar != 0xC2 && tempChar != 0xCA && tempChar != 0xCF && tempChar != 0x8A)
		{
			tempString.push_back((char)tempChar);
		}
		counterByte++;
		numberOfNotLoadedByte--;
		infoLength--;
		descriptorLength--;
		questionAtEndTsPacket();
	}
	oneDescriptor.setNetworkName(tempString);
}

void DataLoader::loadServiceListDescriptor()
{
	int descriptorLength = readByte();
	counterByte++;
	numberOfNotLoadedByte--;
	infoLength--;
	oneDescriptor.setLength(descriptorLength);
	questionAtEndTsPacket();
	vector<int> tempVector, tempVector1;
	while (descriptorLength != 0)
	{
		tempVector.push_back(readByte());
		counterByte++;
		numberOfNotLoadedByte--;
		infoLength--;
		descriptorLength--;
		questionAtEndTsPacket();
		tempVector1.push_back(readByte());
		counterByte++;
		numberOfNotLoadedByte--;
		infoLength--;
		descriptorLength--;
		questionAtEndTsPacket();
	}
	oneDescriptor.setServiceID(tempVector);
	oneDescriptor.setServiceType(tempVector1);
}

void DataLoader::loadBouquetNameDesctiptor()
{
	int descriptorLength = readByte();
	counterByte++;
	numberOfNotLoadedByte--;
	infoLength--;
	oneDescriptor.setLength(descriptorLength);
	questionAtEndTsPacket();
	string tempString;
	while (descriptorLength != 0)
	{
		int tempChar = readByte();
		if (tempChar != 0xC2 && tempChar != 0xCA && tempChar != 0xCF && tempChar != 0x8A)
		{
			tempString.push_back((char)tempChar);
		}
		counterByte++;
		numberOfNotLoadedByte--;
		infoLength--;
		descriptorLength--;
		questionAtEndTsPacket();
	}
	oneDescriptor.setBouquetName(tempString);
}

void DataLoader::loadServiceDescriptor()
{
	int descriptorLength = readByte();
	counterByte++;
	numberOfNotLoadedByte--;
	infoLength--;
	oneDescriptor.setLength(descriptorLength);
	questionAtEndTsPacket();

	vector<int> tempVector;
	tempVector.push_back(readByte());
	oneDescriptor.setServiceType(tempVector);
	counterByte++;
	numberOfNotLoadedByte--;
	infoLength--;
	descriptorLength--;
	questionAtEndTsPacket();
	tempVector.reserve(0);

	int length = readByte();
	counterByte++;
	numberOfNotLoadedByte--;
	infoLength--;
	descriptorLength--;
	questionAtEndTsPacket();

	string tempString;
	for (int m=0;m<length;m++)
	{
		int tempChar = readByte();
		if (tempChar != 0xC2 && tempChar != 0xCA && tempChar != 0xCF && tempChar != 0x8A)
		{
			tempString.push_back((char)tempChar);
		}
		counterByte++;
		numberOfNotLoadedByte--;
		infoLength--;
		descriptorLength--;
		questionAtEndTsPacket();
	}
	oneDescriptor.setServiceProviderName(tempString);
	tempString.resize(0);

	length = readByte();
	counterByte++;
	numberOfNotLoadedByte--;
	infoLength--;
	descriptorLength--;
	questionAtEndTsPacket();
	if (length != descriptorLength){return;}//overeni spravne delky
	for (int m=0;m<length;m++)
	{
		int tempChar = readByte();
		if (tempChar != 0xC2 && tempChar != 0xCA && tempChar != 0xCF && tempChar != 0x8A)
		{
			tempString.push_back((char)tempChar);//tempVector.push_back(readByte());
		}
		counterByte++;
		numberOfNotLoadedByte--;
		infoLength--;
		questionAtEndTsPacket();
	}
	oneDescriptor.setServiceName(tempString);
}

void DataLoader::loadShortEventDescriptor()
{
	int descriptorLength = readByte();
	counterByte++;
	numberOfNotLoadedByte--;
	infoLength--;
	oneDescriptor.setLength(descriptorLength);
	questionAtEndTsPacket();

	vector<int> tempVector;
	vector<vector <int>> tempVVector;

	string tempString;
	vector<string> tempVectorString;
	for (int m=0;m<3;m++)
	{
		int tempChar = readByte();
		if (tempChar != 0xC2 && tempChar != 0xCA && tempChar != 0xCF && tempChar != 0x8A)
		{
			tempString.push_back((char)tempChar);
		}
		counterByte++;
		numberOfNotLoadedByte--;
		infoLength--;
		descriptorLength--;
		questionAtEndTsPacket();
	}
	tempVectorString.push_back(tempString);
	tempString.resize(0);
	oneDescriptor.setLanguageCode(tempVectorString);
	tempVectorString.resize(0);

	tempVector.resize(0);
	tempVVector.resize(0);

	int length = readByte();
	counterByte++;
	numberOfNotLoadedByte--;
	infoLength--;
	descriptorLength--;
	questionAtEndTsPacket();

	for (int m=0;m<length;m++)
	{
		int tempChar = readByte();
		if (tempChar != 0xC2 && tempChar != 0xCA && tempChar != 0xCF && tempChar != 0x8A)
		{
			tempString.push_back((char)tempChar);
		}
		counterByte++;
		numberOfNotLoadedByte--;
		infoLength--;
		descriptorLength--;
		questionAtEndTsPacket();
	}
	oneDescriptor.setEventName(tempString);
	tempString.resize(0);
	tempVector.resize(0);

	length = readByte();
	counterByte++;
	numberOfNotLoadedByte--;
	infoLength--;
	descriptorLength--;
	questionAtEndTsPacket();
	if (length != descriptorLength){return;} //overeni spravne delky
	for (int m=0;m<length;m++)
	{
		int tempChar = readByte();
		if (tempChar != 0xC2 && tempChar != 0xCA && tempChar != 0xCF && tempChar != 0x8A)
		{
			tempString.push_back((char)tempChar);
		}
		counterByte++;
		numberOfNotLoadedByte--;
		infoLength--;
		questionAtEndTsPacket();
	}
	oneDescriptor.setText(tempString);
}

void DataLoader::loadExtendedEventDescriptor()
{
	int descriptorLength = readByte();
	counterByte++;
	numberOfNotLoadedByte--;
	infoLength--;
	fgetpos(fr, &synchronizedPosition);
	oneDescriptor.setLength(descriptorLength);
	questionAtEndTsPacket();

	int byteBuff = readByte();
	counterByte++;
	numberOfNotLoadedByte--;
	infoLength--;
	descriptorLength--;
	questionAtEndTsPacket();
	oneDescriptor.setDescriptorNumber(binaryShift(byteBuff,1,4));
	oneDescriptor.setLastDescriptorNUmber(binaryShift(byteBuff,5,8));
	//vector<int> tempVector, tempVector1;
	//vector<vector<int>> tempVVector, tempVVector1;
	string tempString;
	vector<string> tempVectorString, tempVectorString1;
	for (int m=0;m<3;m++)
	{
		int tempChar = readByte();
		if (tempChar != 0xC2 && tempChar != 0xCA && tempChar != 0xCF && tempChar != 0x8A)
		{
			tempString.push_back((char)tempChar);//tempVector.push_back(readByte());
		}
		counterByte++;
		numberOfNotLoadedByte--;
		infoLength--;
		descriptorLength--;
		questionAtEndTsPacket();
	}
	tempVectorString.push_back(tempString);
	oneDescriptor.setLanguageCode(tempVectorString);
	tempString.resize(0);
	tempVectorString.resize(0);


	//tempVector.resize(0);
	//tempVVector.resize(0);

	int length = readByte();
	counterByte++;
	numberOfNotLoadedByte--;
	infoLength--;
	descriptorLength--;
	questionAtEndTsPacket();

	while(length != 0)
	{
		int length1 = readByte();
		counterByte++;
		numberOfNotLoadedByte--;
		infoLength--;
		descriptorLength--;
		length--;
		questionAtEndTsPacket();
		for (int n=0;n<length1;n++)
		{
			int tempChar = readByte();
			if (tempChar != 0xC2 && tempChar != 0xCA && tempChar != 0xCF && tempChar != 0x8A)
			{
				tempString.push_back((char)tempChar);//tempVector.push_back(readByte());
			}
			counterByte++;
			numberOfNotLoadedByte--;
			infoLength--;
			descriptorLength--;
			length--;
			questionAtEndTsPacket();
		}
		tempVectorString.push_back(tempString);
		tempString.resize(0);

		int length2 = readByte();
		counterByte++;
		numberOfNotLoadedByte--;
		infoLength--;
		descriptorLength--;
		length--;
		questionAtEndTsPacket();
		for (int n=0;n<length2;n++)
		{
			int tempChar = readByte();
			if (tempChar != 0xC2 && tempChar != 0xCA && tempChar != 0xCF && tempChar != 0x8A)
			{
				tempString.push_back((char)tempChar);//tempVector.push_back(readByte());
			}
			counterByte++;
			numberOfNotLoadedByte--;
			infoLength--;
			descriptorLength--;
			length--;
			questionAtEndTsPacket();
		}
		tempVectorString1.push_back(tempString);
		tempString.resize(0);
	}
	oneDescriptor.setItemDescription(tempVectorString);
	tempVectorString.resize(0);
	oneDescriptor.setItem(tempVectorString1);
	tempVectorString1.resize(0);

	length = readByte();
	counterByte++;
	numberOfNotLoadedByte--;
	infoLength--;
	descriptorLength--;
	questionAtEndTsPacket();
	if (length != descriptorLength){return;}

	for (int m=0;m<length;m++)
	{
		int tempChar = readByte();
		if (tempChar != 0xC2 && tempChar != 0xCA && tempChar != 0xCF && tempChar != 0x8A)
		{
			tempString.push_back((char)tempChar);//tempVector.push_back(readByte());
		}
		counterByte++;
		numberOfNotLoadedByte--;
		infoLength--;
		questionAtEndTsPacket();
	}
	oneDescriptor.setText(tempString);
	tempString.resize(0);
}

void DataLoader::loadComponentDescriptor()
{
	int descriptorLength = readByte();
	counterByte++;
	numberOfNotLoadedByte--;
	infoLength--;
	oneDescriptor.setLength(descriptorLength);
	questionAtEndTsPacket();

	int byteBuff = readByte();
	counterByte++;
	numberOfNotLoadedByte--;
	infoLength--;
	descriptorLength--;
	questionAtEndTsPacket();
	oneDescriptor.setStreamContent(binaryShift(byteBuff,5,8));
	oneDescriptor.setComponentType(readByte());
	counterByte++;
	numberOfNotLoadedByte--;
	infoLength--;
	descriptorLength--;
	questionAtEndTsPacket();
	oneDescriptor.setComponentTag(readByte());
	counterByte++;
	numberOfNotLoadedByte--;
	infoLength--;
	descriptorLength--;
	questionAtEndTsPacket();
	vector<int> tempVector;
	vector<vector<int>> tempVVector;
	string tempString;
	for (int m=0;m<3;m++)
	{
		int tempChar = readByte();
		if (tempChar != 0xC2 && tempChar != 0xCA && tempChar != 0xCF && tempChar != 0x8A)
		{
			tempString.push_back((char)tempChar);
		}
		counterByte++;
		numberOfNotLoadedByte--;
		infoLength--;
		descriptorLength--;
		questionAtEndTsPacket();
	}
	vector<string> tempVectorString;
	tempVectorString.push_back(tempString);
	tempString.resize(0);
	oneDescriptor.setLanguageCode(tempVectorString);

	tempVector.resize(0);
	while(descriptorLength != 0)
	{
		int tempChar = readByte();
		if (tempChar != 0xC2 && tempChar != 0xCA && tempChar != 0xCF && tempChar != 0x8A)
		{
			tempString.push_back((char)tempChar);
		}
		counterByte++;
		numberOfNotLoadedByte--;
		infoLength--;
		descriptorLength--;
		questionAtEndTsPacket();
	}
	oneDescriptor.setText(tempString);
}

void DataLoader::loadContentDescriptor()
{
	int descriptorLength = readByte();
	counterByte++;
	numberOfNotLoadedByte--;
	infoLength--;
	oneDescriptor.setLength(descriptorLength);
	questionAtEndTsPacket();
	vector<int> tempVector, tempVector1, tempVector2;

	for (int m=0;m<descriptorLength;m++)
	{
		int byteBuff = readByte();
		counterByte++;
		numberOfNotLoadedByte--;
		infoLength--;
		descriptorLength--;
		questionAtEndTsPacket();
		tempVector.push_back(binaryShift(byteBuff,1,4));
		tempVector1.push_back(binaryShift(byteBuff,5,8));
		tempVector2.push_back(readByte());
		counterByte++;
		numberOfNotLoadedByte--;
		infoLength--;
		descriptorLength--;
		questionAtEndTsPacket();
	}
	oneDescriptor.setContentNible1(tempVector);
	oneDescriptor.setContentNible2(tempVector1);
	oneDescriptor.setUserByte(tempVector2);
}

void DataLoader::loadTeletextDescriptor()
{
	int descriptorLength = readByte();
	counterByte++;
	numberOfNotLoadedByte--;
	infoLength--;
	oneDescriptor.setLength(descriptorLength);
	questionAtEndTsPacket();
	vector<int> tempVector, tempVector1, tempVector2;
	vector<vector<int>> tempVVector;
	string tempString;
	vector<string> tempVectorString;
	for (int m=0;m<descriptorLength;m++)
	{
		for (int n=0;n<3;n++)
		{
			int tempChar = readByte();
			if (tempChar != 0xC2 && tempChar != 0xCA && tempChar != 0xCF && tempChar != 0x8A)
			{
				tempString.push_back((char)tempChar);//tempVector.push_back(readByte());
			}
			counterByte++;
			numberOfNotLoadedByte--;
			infoLength--;
			descriptorLength--;
			questionAtEndTsPacket();
		}
		tempVectorString.push_back(tempString);
		tempVector.resize(0);

		int byteBuff = readByte();
		counterByte++;
		numberOfNotLoadedByte--;
		infoLength--;
		descriptorLength--;
		questionAtEndTsPacket();
		tempVector.push_back(binaryShift(byteBuff,1,5));
		tempVector1.push_back(binaryShift(byteBuff,6,8));
		tempVector2.push_back(readByte());
		counterByte++;
		numberOfNotLoadedByte--;
		infoLength--;
		descriptorLength--;
		questionAtEndTsPacket();
	}
	oneDescriptor.setLanguageCode(tempVectorString);
	oneDescriptor.setTeletextType(tempVector);
	oneDescriptor.setTeletextMagazineNumber(tempVector1);
	oneDescriptor.setTeletextPageNumber(tempVector2);
}

void DataLoader::loadTerrestrialDeliverySystemDescriptor()
{
	int descriptorLength = readByte();
	counterByte++;
	numberOfNotLoadedByte--;
	infoLength--;
	oneDescriptor.setLength(descriptorLength);
	questionAtEndTsPacket();

	int byteBuff, byteBuff1, byteBuff2;
	byteBuff = readByte();
	counterByte++;
	numberOfNotLoadedByte--;
	infoLength--;
	questionAtEndTsPacket();
	byteBuff1 = readByte();
	counterByte++;
	numberOfNotLoadedByte--;
	infoLength--;
	questionAtEndTsPacket();
	byteBuff2 = readByte();
	counterByte++;
	numberOfNotLoadedByte--;
	infoLength--;
	questionAtEndTsPacket();
	vector<int> tempVector;
	tempVector.push_back(byteBuff*0x1000000+byteBuff1*0x10000+byteBuff2*0x100+readByte());
	oneDescriptor.setCentreFrequency(tempVector);
	counterByte++;
	numberOfNotLoadedByte--;
	infoLength--;
	questionAtEndTsPacket();

	byteBuff = readByte();
	counterByte++;
	numberOfNotLoadedByte--;
	infoLength--;
	questionAtEndTsPacket();
	oneDescriptor.setBandwidth(binaryShift(byteBuff,1,3));
	oneDescriptor.setPriority(binaryShift(byteBuff,4,4));
	oneDescriptor.setTimeSlicing(binaryShift(byteBuff,5,5));
	oneDescriptor.setMpeFec(binaryShift(byteBuff,6,6));
	byteBuff = readByte();
	counterByte++;
	numberOfNotLoadedByte--;
	infoLength--;
	questionAtEndTsPacket();
	oneDescriptor.setConstellation(binaryShift(byteBuff,1,2));
	oneDescriptor.setHierarchyInformation(binaryShift(byteBuff,3,5));
	oneDescriptor.setCodeRateHP(binaryShift(byteBuff,6,8));
	byteBuff = readByte();
	counterByte++;
	numberOfNotLoadedByte--;
	infoLength--;
	questionAtEndTsPacket();
	oneDescriptor.setCodeRateLP(binaryShift(byteBuff,1,3));
	oneDescriptor.setGuardInterval(binaryShift(byteBuff,4,5));
	oneDescriptor.setTransmissionMode(binaryShift(byteBuff,6,7));
	oneDescriptor.setOtherFrequency(binaryShift(byteBuff,8,8));
	readByte();
	counterByte++;
	numberOfNotLoadedByte--;
	infoLength--;
	questionAtEndTsPacket();
	readByte();
	counterByte++;
	numberOfNotLoadedByte--;
	infoLength--;
	questionAtEndTsPacket();
	readByte();
	counterByte++;
	numberOfNotLoadedByte--;
	infoLength--;
	questionAtEndTsPacket();
	readByte();
	counterByte++;
	numberOfNotLoadedByte--;
	infoLength--;
	questionAtEndTsPacket();
}

void DataLoader::loadFrequencyListDescriptor()
{
	int descriptorLength = readByte();
	counterByte++;
	numberOfNotLoadedByte--;
	infoLength--;
	oneDescriptor.setLength(descriptorLength);
	questionAtEndTsPacket();

	fgetpos(fr, &synchronizedPosition);

	int byteBuff, byteBuff1, byteBuff2;
	byteBuff = readByte();
	counterByte++;
	numberOfNotLoadedByte--;
	infoLength--;
	descriptorLength--;
	questionAtEndTsPacket();
	oneDescriptor.setCodingType(binaryShift(byteBuff,7,8));
	vector<int> tempVector;
	while (descriptorLength != 0)
	{
		byteBuff = readByte();
		counterByte++;
		numberOfNotLoadedByte--;
		infoLength--;
		descriptorLength--;
		questionAtEndTsPacket();
		byteBuff1 = readByte();
		counterByte++;
		numberOfNotLoadedByte--;
		infoLength--;
		descriptorLength--;
		questionAtEndTsPacket();
		byteBuff2 = readByte();
		counterByte++;
		numberOfNotLoadedByte--;
		infoLength--;
		descriptorLength--;
		questionAtEndTsPacket();
		tempVector.push_back(byteBuff*0x1000000+byteBuff1*0x10000+byteBuff2*0x100+readByte());
		counterByte++;
		numberOfNotLoadedByte--;
		infoLength--;
		descriptorLength--;
		questionAtEndTsPacket();
	}
	oneDescriptor.setCentreFrequency(tempVector);
}

void DataLoader::loadApplicationSignallingDescriptor()
{
	int descriptorLength = readByte();
	counterByte++;
	numberOfNotLoadedByte--;
	infoLength--;
	oneDescriptor.setLength(descriptorLength);
	questionAtEndTsPacket();
	vector<int> tempVector, tempVector1;
	for (int m=0;m<descriptorLength;m++)
	{
		int byteBuff = readByte();
		counterByte++;
		numberOfNotLoadedByte--;
		infoLength--;
		descriptorLength--;
		questionAtEndTsPacket();
		tempVector.push_back(binaryShift(byteBuff,2,8)*0x100+readByte());
		counterByte++;
		numberOfNotLoadedByte--;
		infoLength--;
		descriptorLength--;
		questionAtEndTsPacket();
		tempVector1.push_back(binaryShift(readByte(),4,8));
		counterByte++;
		numberOfNotLoadedByte--;
		infoLength--;
		descriptorLength--;
		questionAtEndTsPacket();
	}
	oneDescriptor.setApplicationType(tempVector);
	oneDescriptor.setAitVersionNumber(tempVector1);
}

void DataLoader::loadLocalTimeOffsetDescriptor()
{
	int descriptorLength = readByte();
	counterByte++;
	numberOfNotLoadedByte--;
	infoLength--;
	oneDescriptor.setLength(descriptorLength);
	questionAtEndTsPacket();

	/*vector<int> tempVectorCountryRegionId;
	vector<int> tempVectorLocalTimeOffsetPolarity;

	vector<int> tempVectorLocalTimeOffsetHour;
	vector<int> tempVectorLocalTimeOffsetMinute;

	vector<int> tempVectorTimeToChangeYear;
	vector<int> tempVectorTimeToChangeMonth;
	vector<int> tempVectorTimeToChangeDay;
	vector<int> tempVectorTimeToChangeHour;
	vector<int> tempVectorTimeToChangeMinute;
	vector<int> tempVectorTimeToChangeSecond;

	vector<int> tempVectorNextTimeOffsetHour;
	vector<int> tempVectorNextTimeOffsetMinute;*/
	vector<CountryLoop> countryLoops;

	for (int m=0;m<descriptorLength;m++)
	{
		string tempString;
		//vector<string> tempVectorString;
		//country code
		for (int m=0;m<3;m++)
		{
			int tempChar = readByte();
			if (tempChar != 0xC2 && tempChar != 0xCA && tempChar != 0xCF && tempChar != 0x8A)
			{
				tempString.push_back((char)tempChar);
			}
			counterByte++;
			numberOfNotLoadedByte--;
			infoLength--;
			descriptorLength--;
			questionAtEndTsPacket();
		}
		CountryLoop oneCountryLoop;
		oneCountryLoop.languageCode = tempString;
		//tempVectorString.push_back(tempString);
		//oneDescriptor.setLanguageCode(tempVectorString);
		tempString.resize(0);
		//tempVectorString.resize(0);
		
		//country region ID
		int byteBuff = readByte();
		counterByte++;
		numberOfNotLoadedByte--;
		infoLength--;
		descriptorLength--;
		questionAtEndTsPacket();
		oneCountryLoop.countryRegionId = binaryShift(byteBuff,1,6); //tempVectorCountryRegionId.push_back(binaryShift(byteBuff,1,6));
		//local time offset polarity
		oneCountryLoop.localTimeOffsetPolarity = (binaryShift(byteBuff,8,8))==1 ? true : false; //tempVectorLocalTimeOffsetPolarity.push_back(binaryShift(byteBuff,8,8));
		//local time ofset
			//hour
		oneCountryLoop.localTimeOffsetHour = readByte(); //tempVectorLocalTimeOffsetHour.push_back(readByte());
		counterByte++;
		numberOfNotLoadedByte--;
		infoLength--;
		descriptorLength--;
		questionAtEndTsPacket();
			//minute
		oneCountryLoop.localTimeOffsetMinute = readByte(); //tempVectorLocalTimeOffsetMinute.push_back(readByte());
		counterByte++;
		numberOfNotLoadedByte--;
		infoLength--;
		descriptorLength--;
		questionAtEndTsPacket();
		//time to change
			//MJD number
		byteBuff = readByte();
		counterByte++;
		numberOfNotLoadedByte--;
		infoLength--;
		descriptorLength--;
		questionAtEndTsPacket();
		int MJD = byteBuff*0x100+readByte();
		counterByte++;
		numberOfNotLoadedByte--;
		infoLength--;
		descriptorLength--;
		questionAtEndTsPacket();
			//day
		int Yi =  int((MJD-15078.2)/365.25);
		int Mi =  int((MJD-14956.1-int(Yi*365.25))/30.6001);
		oneCountryLoop.TimeToChangeDay = MJD-14956-int(Yi*365.25)-int(Mi*30.6001); //tempVectorTimeToChangeDay.push_back(MJD-14956-int(Yi*365.25)-int(Mi*30.6001));
			//month
		int K=0;
		if((Mi == 14)||(Mi == 15)){K=1;}
		oneCountryLoop.TimeToChangeMonth = (Mi-1-K*12); //tempVectorTimeToChangeMonth.push_back(Mi-1-K*12);
			//year
		int y;
		if((Yi+K-100) >= 0){y = 2000 + (Yi+K-100);}
		else{y = 1900 + (Yi+K-100);}
		oneCountryLoop.TimeToChangeYear = y; //tempVectorTimeToChangeYear.push_back(y);
		//	//day of week
		//---.push_back(((MJD+2)%7)+1);
			//hour
		oneCountryLoop.TimeToChangeHour = readByte(); //tempVectorTimeToChangeHour.push_back(readByte());
		counterByte++;
		numberOfNotLoadedByte--;
		infoLength--;
		descriptorLength--;
		questionAtEndTsPacket();
			//minute
		oneCountryLoop.TimeToChangeMinute = readByte(); //tempVectorTimeToChangeMinute.push_back(readByte());
		counterByte++;
		numberOfNotLoadedByte--;
		infoLength--;
		descriptorLength--;
		questionAtEndTsPacket();
			//second
		oneCountryLoop.TimeToChangeSecond = readByte(); //tempVectorTimeToChangeSecond.push_back(readByte());
		counterByte++;
		numberOfNotLoadedByte--;
		infoLength--;
		descriptorLength--;
		questionAtEndTsPacket();
		//next time offset
			//hour
		oneCountryLoop.nextTimeOffsetHour = readByte(); //tempVectorNextTimeOffsetHour.push_back(readByte());
		counterByte++;
		numberOfNotLoadedByte--;
		infoLength--;
		descriptorLength--;
		questionAtEndTsPacket();
			//minute
		oneCountryLoop.nextTimeOffsetMinute = readByte(); //tempVectorNextTimeOffsetMinute.push_back(readByte());
		counterByte++;
		numberOfNotLoadedByte--;
		infoLength--;
		descriptorLength--;
		questionAtEndTsPacket();

		countryLoops.push_back(oneCountryLoop);
	}
	oneDescriptor.setCountryLoops(countryLoops);
}

void DataLoader::loadRawDataDescriptor()
{
	int descriptorLength = readByte();
	counterByte++;
	numberOfNotLoadedByte--;
	infoLength--;
	oneDescriptor.setLength(descriptorLength);
	questionAtEndTsPacket();
	string tempString;
	//char buffer[20];
	while (descriptorLength != 0)
	{
		/*itoa(readByte(), buffer, 16);
		stringstream ss;
		string s;
		ss<<buffer;
		ss>>s;
		tempString = tempString + s + "  ";*/
		tempString.push_back(readByte());
		counterByte++;
		numberOfNotLoadedByte--;
		infoLength--;
		descriptorLength--;
		questionAtEndTsPacket();
	}
	oneDescriptor.setRawData(tempString);
}
