#ifndef EXCEPTIONS_H
#define EXCEPTIONS_H

#include <stdexcept>

//EXCEPTIONS pro dataLoader

class CannotOpenFileException : public std::runtime_error {
public:
	CannotOpenFileException(std::string msg) : std::runtime_error(msg){};
};

class ReadException : public std::runtime_error {
public:
	ReadException(std::string msg) : std::runtime_error(msg){};
};

class SynchronizationException : public std::runtime_error {
public:
	SynchronizationException(std::string msg) : std::runtime_error(msg){};
};

class ScrambledException : public std::runtime_error {
public:
	ScrambledException(std::string msg) : std::runtime_error(msg){};
};

class AdaptionFieldException : public std::runtime_error {
public:
	AdaptionFieldException(std::string msg) : std::runtime_error(msg){};
};

class BadTableIDException : public std::runtime_error {
public:
	BadTableIDException(std::string msg) : std::runtime_error(msg){};
};

class ReadDataOutsideTsPacketException : public std::runtime_error {
public:
	ReadDataOutsideTsPacketException(std::string msg) : std::runtime_error(msg){};
};

class TooLongTableException : public std::runtime_error {
public:
	TooLongTableException(std::string msg) : std::runtime_error(msg){};
};

class LostTsPacketException : public std::runtime_error {
public:
	LostTsPacketException(std::string msg) : std::runtime_error(msg){};
};

class BadInformationAboutLengthDataException : public std::runtime_error {
public:
	BadInformationAboutLengthDataException(std::string msg) : std::runtime_error(msg){};
};

//

//EXCEPTIONS pro GUI

class BadSettingCardException : public std::runtime_error {
public:
	BadSettingCardException(std::string msg) : std::runtime_error(msg){};
};

class MissingDllException : public std::runtime_error {
public:
	MissingDllException(std::string msg) : std::runtime_error(msg){};
};

//

#endif
