﻿#pragma once

#include <iostream>
#include <stdio.h>
#include <conio.h>
#include <string.h>
#include <stdlib.h>
#include <vector>
#include <msclr/marshal.h>
#include <msclr/marshal_cppstd.h>

#include "DataLoader.h"
#include "Table.h"
//#include "CardDriver.h" //neinkludovat protoze uz pridano do properties/common properties/framework and references/add new references ->CardDriver

using namespace msclr::interop;

namespace Analyzator {

	using namespace System;
	using namespace System::ComponentModel;
	using namespace System::Collections;
	using namespace System::Windows::Forms;
	using namespace System::Data;
	using namespace System::Drawing;
	using namespace CardDriver;

	/// <summary>
	/// Summary for Form1
	
	/// </summary>
	public ref class SiAnalyzator : public System::Windows::Forms::Form
	{
	private: DataLoader* loadedData;
	private: TablesContainer* container;// = loadedData->getData(); - řešeno samostatně kvuli nízké rychlosti vyčítaní dat přes metodu getData()
	private: System::Windows::Forms::Label^  label1;
	private: System::Windows::Forms::Button^  buttonScanBandwidth;
	private: System::Windows::Forms::TabPage^  tabPageFrequence;

	private: System::Windows::Forms::Label^  labelFrekvencePopis;
	private: System::Windows::Forms::ListBox^  listBoxLockedFrequency;
	private: System::ComponentModel::BackgroundWorker^  backgroundWorkerTuneCard;

	public:
		SiAnalyzator(void)
		{
			InitializeComponent();
			//
			//TODO: Add the constructor code here
			loadedData = NULL;
			container = NULL;
			//
		}

	protected:
		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		~SiAnalyzator()
		{
			if (components)
			{
				delete components;
			}
		}

	private: System::Windows::Forms::Button^  buttonOpenFile;
	protected: 
	private: System::Windows::Forms::OpenFileDialog^  openFileDialog1;
	private: System::Windows::Forms::Button^  buttonAnalyze;
	private: System::Windows::Forms::StatusStrip^  statusStrip1;
	private: System::Windows::Forms::ToolStripStatusLabel^  statusBar;
	private: System::Windows::Forms::GroupBox^  groupBox1;
	private: System::Windows::Forms::Label^  VnumbTsPacket;
	private: System::Windows::Forms::Label^  VnumbLostTsPacket;
	private: System::Windows::Forms::Label^  VnumbErrTsPacket;
	private: System::Windows::Forms::Label^  numbLostTsPacket;
	private: System::Windows::Forms::Label^  numbErrTsPacket;
	private: System::Windows::Forms::Label^  numbTsPacket;
	private: System::Windows::Forms::ListBox^  listBoxPat;
	private: System::Windows::Forms::TabControl^  tabControlMain;
	private: System::Windows::Forms::TabPage^  tabPagePat;
	private: System::Windows::Forms::TabPage^  tabPagePmt;
	private: System::Windows::Forms::Label^  labelMultiplexNit;
	private: System::Windows::Forms::TabControl^  tabControlNit;
	private: System::Windows::Forms::TabPage^  tabPageNitActual;
	private: System::Windows::Forms::TabPage^  tabPageNitOther;
	private: System::Windows::Forms::TabPage^  tabPagelSdt;
	private: System::Windows::Forms::Label^  labelMultiplexSdt;
	private: System::Windows::Forms::TabControl^  tabControlSdt;
	private: System::Windows::Forms::TabPage^  tabPageSdtActual;
	private: System::Windows::Forms::TabPage^  tabPageSdtOther;
	private: System::Windows::Forms::TabPage^  tabPageBat;
	private: System::Windows::Forms::TabPage^  tabPageEit;
	private: System::Windows::Forms::Label^  labelMultiplexEit;
	private: System::Windows::Forms::TabControl^  tabControlEit;
	private: System::Windows::Forms::TabPage^  tabPageEitActual;
	private: System::Windows::Forms::TabPage^  tabPageEitOther;
	private: System::Windows::Forms::TabPage^  tabPageTdtTot;
	private: System::Windows::Forms::TabPage^  tabContolResultAnalyze;
	private: System::Windows::Forms::Label^  labelVysilaniEitActual;
	private: System::Windows::Forms::TabControl^  tabControlEitActualP;
	private: System::Windows::Forms::TabPage^  tabPageEitActualP;
	private: System::Windows::Forms::Label^  labelVysilaniEitOther;
	private: System::Windows::Forms::TabControl^  tabControlEitOther;
	private: System::Windows::Forms::TabPage^  tabPageEitOtherP;
	private: System::Windows::Forms::TabPage^  tabPageEitOtherEpg;
	private: System::Windows::Forms::Label^  labelPatPopis;
	private: System::Windows::Forms::GroupBox^  groupBoxNumberOfAnalyzeTables;
	private: System::Windows::Forms::Label^  labelNumberOfEitActualP;
	private: System::Windows::Forms::Label^  labelNumberOfBat;
	private: System::Windows::Forms::Label^  labelNumberOfSdtOther;
	private: System::Windows::Forms::Label^  labelNumberOfSdtActual;
	private: System::Windows::Forms::Label^  labelNumberOfCat;
	private: System::Windows::Forms::Label^  labelNumberOfNitOther;
	private: System::Windows::Forms::Label^  labelNumberOfNitActual;
	private: System::Windows::Forms::Label^  labelNUmberOfPmt;
	private: System::Windows::Forms::Label^  labelNumberOfPat;
	private: System::Windows::Forms::Label^  labelNumberOfTdt;
	private: System::Windows::Forms::Label^  labelNumberOfEitOtherS;
	private: System::Windows::Forms::Label^  labelNumberOfEitOtherP;
	private: System::Windows::Forms::Label^  labelNumberOfEitActualS;
	private: System::Windows::Forms::GroupBox^  groupBoxNumberOfNotAnalyzeTables;
	private: System::Windows::Forms::Label^  labelNumberOfTsdt;
	private: System::Windows::Forms::Label^  labelNumberOfSt;
	private: System::Windows::Forms::Label^  labelNUmberOfTot;
	private: System::Windows::Forms::Label^  labelNumberOfRst;
	private: System::Windows::Forms::Label^  labelNumberOfCit;
	private: System::Windows::Forms::Label^  labelNumberOfMetaData;
	private: System::Windows::Forms::Label^  labelNumberOfRnt;
	private: System::Windows::Forms::Label^  labelNumberOfSyncNetwork;
	private: System::Windows::Forms::Label^  labelPmtsPopis;
	private: System::Windows::Forms::ListBox^  listBoxNitActual;
	private: System::Windows::Forms::Label^  labelNitPopis;
	private: System::Windows::Forms::ListBox^  listBoxNitOther;
	private: System::Windows::Forms::ListBox^  listBoxSdtActual;
	private: System::Windows::Forms::Label^  labelSdtPopis;
	private: System::Windows::Forms::ListBox^  listBoxSdtOther;
	private: System::Windows::Forms::ListBox^  listBoxBat;
	private: System::Windows::Forms::Label^  labelBatPopis;
	private: System::Windows::Forms::ListBox^  listBoxEitActualP;
	private: System::Windows::Forms::Label^  labelEitPopis;
	private: System::Windows::Forms::ListBox^  listBoxEitOtherP;
	private: System::Windows::Forms::ListBox^  listBoxEitOtherEpg;
	private: System::Windows::Forms::ListBox^  listBoxTdtTot;
	private: System::Windows::Forms::Label^  labelTdtPopis;
	private: System::Windows::Forms::Label^  labelNumberOfSit;
	private: System::Windows::Forms::Label^  labelNumberOfDit;
	private: System::Windows::Forms::Label^  labelNumberOfMeasurement;
	private: System::Windows::Forms::Label^  labelVNumberOfTdt;
	private: System::Windows::Forms::Label^  labelVNumberOfEitOtherS;
	private: System::Windows::Forms::Label^  labelVNumberOfEitOtherP;
	private: System::Windows::Forms::Label^  labelVNumberOfEitActualS;
	private: System::Windows::Forms::Label^  labelVNumberOfEitActualP;
	private: System::Windows::Forms::Label^  labelVNumberOfBat;
	private: System::Windows::Forms::Label^  labelVNumberOfSdtOther;
	private: System::Windows::Forms::Label^  labelVNumberOfSdtActual;
	private: System::Windows::Forms::Label^  labelVNumberOfNitOther;
	private: System::Windows::Forms::Label^  labelVNumberOfNitActual;
	private: System::Windows::Forms::Label^  labelVNumberOfPmt;
	private: System::Windows::Forms::Label^  labelVNumberOfPat;
	private: System::Windows::Forms::Label^  labelVNumberOfSit;
	private: System::Windows::Forms::Label^  labelVNumberOfDit;
	private: System::Windows::Forms::Label^  labelVNumberOfMeasurement;
	private: System::Windows::Forms::Label^  labelVNumberOfMetaData;
	private: System::Windows::Forms::Label^  labelVNumberOfRnt;
	private: System::Windows::Forms::Label^  labelVNumberOfSyncNetwork;
	private: System::Windows::Forms::Label^  labelVNumberOfSt;
	private: System::Windows::Forms::Label^  labelVNumberOfTot;
	private: System::Windows::Forms::Label^  labelVNumberOfRst;
	private: System::Windows::Forms::Label^  labelVNumberOfCit;
	private: System::Windows::Forms::Label^  labelVNumberOfTsdt;
	private: System::Windows::Forms::Label^  labelVNumberOfCat;
	private: System::Windows::Forms::TabPage^  tabPageNit;
	private: System::ComponentModel::BackgroundWorker^  backgroundWorkerAnalyze;
	private: System::Windows::Forms::ListBox^  listBoxPmt;
	private: System::Windows::Forms::TabPage^  tabPageEitActualEpg;
	private: System::Windows::Forms::ListBox^  listBoxEitActualEpg;
	private: System::Windows::Forms::ComboBox^  comboBoxEitActual;
	private: System::Windows::Forms::ComboBox^  comboBoxSdtActual;
	private: System::Windows::Forms::ComboBox^  comboBoxSdtOther;
	private: System::Windows::Forms::ComboBox^  comboBoxEitOther;
	private: System::Windows::Forms::ComboBox^  comboBoxPmt;
	private: System::Windows::Forms::Label^  labelProgramPmt;
	private: System::Windows::Forms::Label^  labelProgramSdtActual;
	private: System::Windows::Forms::Label^  labelProgramSdtOther;
	private: System::Windows::Forms::Label^  labelProgramEitActual;
	private: System::Windows::Forms::Label^  labelProgramEitOther;
	private: System::Windows::Forms::RadioButton^  radioButtonFile;
	private: System::Windows::Forms::GroupBox^  groupBoxZdrojDat;
	private: System::Windows::Forms::RadioButton^  radioButtonCard;
	private: System::Windows::Forms::Label^  labelFrequency;
	private: System::Windows::Forms::GroupBox^  groupBoxOpenFile;
	private: System::Windows::Forms::GroupBox^  groupBox2;
	private: System::Windows::Forms::TextBox^  textBoxDuration;
	private: System::Windows::Forms::TextBox^  textBoxFrequencyMHz;
	private: System::Windows::Forms::Label^  labelDuration;
	private: System::Windows::Forms::Label^  labelBandwidth;
	private: System::Windows::Forms::ComboBox^  comboBoxBandwidth;
	private: System::ComponentModel::BackgroundWorker^  backgroundWorkerLoadCardData;
	private:
		/// <summary>
		/// Required designer variable.
		/// </summary>
		System::ComponentModel::Container ^components;
#pragma region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		void InitializeComponent(void)
		{
			this->buttonOpenFile = (gcnew System::Windows::Forms::Button());
			this->openFileDialog1 = (gcnew System::Windows::Forms::OpenFileDialog());
			this->buttonAnalyze = (gcnew System::Windows::Forms::Button());
			this->statusStrip1 = (gcnew System::Windows::Forms::StatusStrip());
			this->statusBar = (gcnew System::Windows::Forms::ToolStripStatusLabel());
			this->groupBox1 = (gcnew System::Windows::Forms::GroupBox());
			this->VnumbLostTsPacket = (gcnew System::Windows::Forms::Label());
			this->VnumbErrTsPacket = (gcnew System::Windows::Forms::Label());
			this->numbLostTsPacket = (gcnew System::Windows::Forms::Label());
			this->numbErrTsPacket = (gcnew System::Windows::Forms::Label());
			this->numbTsPacket = (gcnew System::Windows::Forms::Label());
			this->VnumbTsPacket = (gcnew System::Windows::Forms::Label());
			this->listBoxPat = (gcnew System::Windows::Forms::ListBox());
			this->tabControlMain = (gcnew System::Windows::Forms::TabControl());
			this->tabPagePat = (gcnew System::Windows::Forms::TabPage());
			this->labelPatPopis = (gcnew System::Windows::Forms::Label());
			this->tabPagePmt = (gcnew System::Windows::Forms::TabPage());
			this->labelPmtsPopis = (gcnew System::Windows::Forms::Label());
			this->labelProgramPmt = (gcnew System::Windows::Forms::Label());
			this->comboBoxPmt = (gcnew System::Windows::Forms::ComboBox());
			this->listBoxPmt = (gcnew System::Windows::Forms::ListBox());
			this->tabPageNit = (gcnew System::Windows::Forms::TabPage());
			this->labelNitPopis = (gcnew System::Windows::Forms::Label());
			this->labelMultiplexNit = (gcnew System::Windows::Forms::Label());
			this->tabControlNit = (gcnew System::Windows::Forms::TabControl());
			this->tabPageNitActual = (gcnew System::Windows::Forms::TabPage());
			this->listBoxNitActual = (gcnew System::Windows::Forms::ListBox());
			this->tabPageNitOther = (gcnew System::Windows::Forms::TabPage());
			this->listBoxNitOther = (gcnew System::Windows::Forms::ListBox());
			this->tabPagelSdt = (gcnew System::Windows::Forms::TabPage());
			this->labelSdtPopis = (gcnew System::Windows::Forms::Label());
			this->labelMultiplexSdt = (gcnew System::Windows::Forms::Label());
			this->tabControlSdt = (gcnew System::Windows::Forms::TabControl());
			this->tabPageSdtActual = (gcnew System::Windows::Forms::TabPage());
			this->labelProgramSdtActual = (gcnew System::Windows::Forms::Label());
			this->comboBoxSdtActual = (gcnew System::Windows::Forms::ComboBox());
			this->listBoxSdtActual = (gcnew System::Windows::Forms::ListBox());
			this->tabPageSdtOther = (gcnew System::Windows::Forms::TabPage());
			this->labelProgramSdtOther = (gcnew System::Windows::Forms::Label());
			this->comboBoxSdtOther = (gcnew System::Windows::Forms::ComboBox());
			this->listBoxSdtOther = (gcnew System::Windows::Forms::ListBox());
			this->tabPageBat = (gcnew System::Windows::Forms::TabPage());
			this->labelBatPopis = (gcnew System::Windows::Forms::Label());
			this->listBoxBat = (gcnew System::Windows::Forms::ListBox());
			this->tabPageEit = (gcnew System::Windows::Forms::TabPage());
			this->labelEitPopis = (gcnew System::Windows::Forms::Label());
			this->labelMultiplexEit = (gcnew System::Windows::Forms::Label());
			this->tabControlEit = (gcnew System::Windows::Forms::TabControl());
			this->tabPageEitActual = (gcnew System::Windows::Forms::TabPage());
			this->labelProgramEitActual = (gcnew System::Windows::Forms::Label());
			this->comboBoxEitActual = (gcnew System::Windows::Forms::ComboBox());
			this->labelVysilaniEitActual = (gcnew System::Windows::Forms::Label());
			this->tabControlEitActualP = (gcnew System::Windows::Forms::TabControl());
			this->tabPageEitActualP = (gcnew System::Windows::Forms::TabPage());
			this->listBoxEitActualP = (gcnew System::Windows::Forms::ListBox());
			this->tabPageEitActualEpg = (gcnew System::Windows::Forms::TabPage());
			this->listBoxEitActualEpg = (gcnew System::Windows::Forms::ListBox());
			this->tabPageEitOther = (gcnew System::Windows::Forms::TabPage());
			this->labelProgramEitOther = (gcnew System::Windows::Forms::Label());
			this->comboBoxEitOther = (gcnew System::Windows::Forms::ComboBox());
			this->labelVysilaniEitOther = (gcnew System::Windows::Forms::Label());
			this->tabControlEitOther = (gcnew System::Windows::Forms::TabControl());
			this->tabPageEitOtherP = (gcnew System::Windows::Forms::TabPage());
			this->listBoxEitOtherP = (gcnew System::Windows::Forms::ListBox());
			this->tabPageEitOtherEpg = (gcnew System::Windows::Forms::TabPage());
			this->listBoxEitOtherEpg = (gcnew System::Windows::Forms::ListBox());
			this->tabPageTdtTot = (gcnew System::Windows::Forms::TabPage());
			this->label1 = (gcnew System::Windows::Forms::Label());
			this->labelTdtPopis = (gcnew System::Windows::Forms::Label());
			this->listBoxTdtTot = (gcnew System::Windows::Forms::ListBox());
			this->tabContolResultAnalyze = (gcnew System::Windows::Forms::TabPage());
			this->groupBoxNumberOfNotAnalyzeTables = (gcnew System::Windows::Forms::GroupBox());
			this->labelVNumberOfSit = (gcnew System::Windows::Forms::Label());
			this->labelNumberOfSit = (gcnew System::Windows::Forms::Label());
			this->labelVNumberOfDit = (gcnew System::Windows::Forms::Label());
			this->labelNumberOfDit = (gcnew System::Windows::Forms::Label());
			this->labelVNumberOfMeasurement = (gcnew System::Windows::Forms::Label());
			this->labelNumberOfMeasurement = (gcnew System::Windows::Forms::Label());
			this->labelVNumberOfMetaData = (gcnew System::Windows::Forms::Label());
			this->labelNumberOfMetaData = (gcnew System::Windows::Forms::Label());
			this->labelVNumberOfRnt = (gcnew System::Windows::Forms::Label());
			this->labelNumberOfRnt = (gcnew System::Windows::Forms::Label());
			this->labelVNumberOfSyncNetwork = (gcnew System::Windows::Forms::Label());
			this->labelNumberOfSyncNetwork = (gcnew System::Windows::Forms::Label());
			this->labelVNumberOfSt = (gcnew System::Windows::Forms::Label());
			this->labelNumberOfSt = (gcnew System::Windows::Forms::Label());
			this->labelVNumberOfRst = (gcnew System::Windows::Forms::Label());
			this->labelNumberOfRst = (gcnew System::Windows::Forms::Label());
			this->labelVNumberOfCit = (gcnew System::Windows::Forms::Label());
			this->labelVNumberOfTsdt = (gcnew System::Windows::Forms::Label());
			this->labelNumberOfCit = (gcnew System::Windows::Forms::Label());
			this->labelVNumberOfCat = (gcnew System::Windows::Forms::Label());
			this->labelNumberOfTsdt = (gcnew System::Windows::Forms::Label());
			this->labelNumberOfCat = (gcnew System::Windows::Forms::Label());
			this->groupBoxNumberOfAnalyzeTables = (gcnew System::Windows::Forms::GroupBox());
			this->labelVNumberOfTdt = (gcnew System::Windows::Forms::Label());
			this->labelVNumberOfEitOtherS = (gcnew System::Windows::Forms::Label());
			this->labelVNumberOfEitOtherP = (gcnew System::Windows::Forms::Label());
			this->labelVNumberOfEitActualS = (gcnew System::Windows::Forms::Label());
			this->labelVNumberOfEitActualP = (gcnew System::Windows::Forms::Label());
			this->labelVNumberOfBat = (gcnew System::Windows::Forms::Label());
			this->labelVNumberOfSdtOther = (gcnew System::Windows::Forms::Label());
			this->labelVNumberOfSdtActual = (gcnew System::Windows::Forms::Label());
			this->labelVNumberOfNitOther = (gcnew System::Windows::Forms::Label());
			this->labelVNumberOfNitActual = (gcnew System::Windows::Forms::Label());
			this->labelVNumberOfPmt = (gcnew System::Windows::Forms::Label());
			this->labelVNumberOfPat = (gcnew System::Windows::Forms::Label());
			this->labelNumberOfTdt = (gcnew System::Windows::Forms::Label());
			this->labelNumberOfEitOtherS = (gcnew System::Windows::Forms::Label());
			this->labelNUmberOfTot = (gcnew System::Windows::Forms::Label());
			this->labelVNumberOfTot = (gcnew System::Windows::Forms::Label());
			this->labelNumberOfEitOtherP = (gcnew System::Windows::Forms::Label());
			this->labelNumberOfEitActualS = (gcnew System::Windows::Forms::Label());
			this->labelNumberOfEitActualP = (gcnew System::Windows::Forms::Label());
			this->labelNumberOfBat = (gcnew System::Windows::Forms::Label());
			this->labelNumberOfSdtOther = (gcnew System::Windows::Forms::Label());
			this->labelNumberOfSdtActual = (gcnew System::Windows::Forms::Label());
			this->labelNumberOfNitOther = (gcnew System::Windows::Forms::Label());
			this->labelNumberOfNitActual = (gcnew System::Windows::Forms::Label());
			this->labelNUmberOfPmt = (gcnew System::Windows::Forms::Label());
			this->labelNumberOfPat = (gcnew System::Windows::Forms::Label());
			this->tabPageFrequence = (gcnew System::Windows::Forms::TabPage());
			this->labelFrekvencePopis = (gcnew System::Windows::Forms::Label());
			this->listBoxLockedFrequency = (gcnew System::Windows::Forms::ListBox());
			this->backgroundWorkerAnalyze = (gcnew System::ComponentModel::BackgroundWorker());
			this->radioButtonFile = (gcnew System::Windows::Forms::RadioButton());
			this->groupBoxZdrojDat = (gcnew System::Windows::Forms::GroupBox());
			this->radioButtonCard = (gcnew System::Windows::Forms::RadioButton());
			this->labelFrequency = (gcnew System::Windows::Forms::Label());
			this->groupBoxOpenFile = (gcnew System::Windows::Forms::GroupBox());
			this->groupBox2 = (gcnew System::Windows::Forms::GroupBox());
			this->buttonScanBandwidth = (gcnew System::Windows::Forms::Button());
			this->comboBoxBandwidth = (gcnew System::Windows::Forms::ComboBox());
			this->textBoxDuration = (gcnew System::Windows::Forms::TextBox());
			this->textBoxFrequencyMHz = (gcnew System::Windows::Forms::TextBox());
			this->labelDuration = (gcnew System::Windows::Forms::Label());
			this->labelBandwidth = (gcnew System::Windows::Forms::Label());
			this->backgroundWorkerLoadCardData = (gcnew System::ComponentModel::BackgroundWorker());
			this->backgroundWorkerTuneCard = (gcnew System::ComponentModel::BackgroundWorker());
			this->statusStrip1->SuspendLayout();
			this->groupBox1->SuspendLayout();
			this->tabControlMain->SuspendLayout();
			this->tabPagePat->SuspendLayout();
			this->tabPagePmt->SuspendLayout();
			this->tabPageNit->SuspendLayout();
			this->tabControlNit->SuspendLayout();
			this->tabPageNitActual->SuspendLayout();
			this->tabPageNitOther->SuspendLayout();
			this->tabPagelSdt->SuspendLayout();
			this->tabControlSdt->SuspendLayout();
			this->tabPageSdtActual->SuspendLayout();
			this->tabPageSdtOther->SuspendLayout();
			this->tabPageBat->SuspendLayout();
			this->tabPageEit->SuspendLayout();
			this->tabControlEit->SuspendLayout();
			this->tabPageEitActual->SuspendLayout();
			this->tabControlEitActualP->SuspendLayout();
			this->tabPageEitActualP->SuspendLayout();
			this->tabPageEitActualEpg->SuspendLayout();
			this->tabPageEitOther->SuspendLayout();
			this->tabControlEitOther->SuspendLayout();
			this->tabPageEitOtherP->SuspendLayout();
			this->tabPageEitOtherEpg->SuspendLayout();
			this->tabPageTdtTot->SuspendLayout();
			this->tabContolResultAnalyze->SuspendLayout();
			this->groupBoxNumberOfNotAnalyzeTables->SuspendLayout();
			this->groupBoxNumberOfAnalyzeTables->SuspendLayout();
			this->tabPageFrequence->SuspendLayout();
			this->groupBoxZdrojDat->SuspendLayout();
			this->groupBoxOpenFile->SuspendLayout();
			this->groupBox2->SuspendLayout();
			this->SuspendLayout();
			// 
			// buttonOpenFile
			// 
			this->buttonOpenFile->Location = System::Drawing::Point(6, 19);
			this->buttonOpenFile->Name = L"buttonOpenFile";
			this->buttonOpenFile->Size = System::Drawing::Size(155, 28);
			this->buttonOpenFile->TabIndex = 0;
			this->buttonOpenFile->Text = L"Otevřít soubor";
			this->buttonOpenFile->UseVisualStyleBackColor = true;
			this->buttonOpenFile->Click += gcnew System::EventHandler(this, &SiAnalyzator::openFile);
			// 
			// openFileDialog1
			// 
			this->openFileDialog1->FileName = L"empty";
			// 
			// buttonAnalyze
			// 
			this->buttonAnalyze->Enabled = false;
			this->buttonAnalyze->Location = System::Drawing::Point(7, 291);
			this->buttonAnalyze->Name = L"buttonAnalyze";
			this->buttonAnalyze->Size = System::Drawing::Size(169, 46);
			this->buttonAnalyze->TabIndex = 3;
			this->buttonAnalyze->Text = L"Analyzovat data";
			this->buttonAnalyze->UseVisualStyleBackColor = true;
			this->buttonAnalyze->Click += gcnew System::EventHandler(this, &SiAnalyzator::startAnalyze);
			// 
			// statusStrip1
			// 
			this->statusStrip1->Items->AddRange(gcnew cli::array< System::Windows::Forms::ToolStripItem^  >(1) {this->statusBar});
			this->statusStrip1->Location = System::Drawing::Point(0, 420);
			this->statusStrip1->Name = L"statusStrip1";
			this->statusStrip1->Size = System::Drawing::Size(827, 22);
			this->statusStrip1->TabIndex = 4;
			this->statusStrip1->Text = L"statusStrip1";
			// 
			// statusBar
			// 
			this->statusBar->Name = L"statusBar";
			this->statusBar->Size = System::Drawing::Size(53, 17);
			this->statusBar->Text = L"Připraven";
			// 
			// groupBox1
			// 
			this->groupBox1->Controls->Add(this->VnumbLostTsPacket);
			this->groupBox1->Controls->Add(this->VnumbErrTsPacket);
			this->groupBox1->Controls->Add(this->numbLostTsPacket);
			this->groupBox1->Controls->Add(this->numbErrTsPacket);
			this->groupBox1->Controls->Add(this->numbTsPacket);
			this->groupBox1->Controls->Add(this->VnumbTsPacket);
			this->groupBox1->Location = System::Drawing::Point(418, 6);
			this->groupBox1->Name = L"groupBox1";
			this->groupBox1->Size = System::Drawing::Size(200, 108);
			this->groupBox1->TabIndex = 5;
			this->groupBox1->TabStop = false;
			this->groupBox1->Text = L"Počet analyzovaných TS paketů";
			// 
			// VnumbLostTsPacket
			// 
			this->VnumbLostTsPacket->AutoSize = true;
			this->VnumbLostTsPacket->Location = System::Drawing::Point(65, 77);
			this->VnumbLostTsPacket->Name = L"VnumbLostTsPacket";
			this->VnumbLostTsPacket->Size = System::Drawing::Size(22, 13);
			this->VnumbLostTsPacket->TabIndex = 5;
			this->VnumbLostTsPacket->Text = L"  ---";
			// 
			// VnumbErrTsPacket
			// 
			this->VnumbErrTsPacket->AutoSize = true;
			this->VnumbErrTsPacket->Location = System::Drawing::Point(65, 51);
			this->VnumbErrTsPacket->Name = L"VnumbErrTsPacket";
			this->VnumbErrTsPacket->Size = System::Drawing::Size(22, 13);
			this->VnumbErrTsPacket->TabIndex = 4;
			this->VnumbErrTsPacket->Text = L"  ---";
			// 
			// numbLostTsPacket
			// 
			this->numbLostTsPacket->AutoSize = true;
			this->numbLostTsPacket->Location = System::Drawing::Point(6, 77);
			this->numbLostTsPacket->Name = L"numbLostTsPacket";
			this->numbLostTsPacket->Size = System::Drawing::Size(53, 13);
			this->numbLostTsPacket->TabIndex = 3;
			this->numbLostTsPacket->Text = L"Ztracené:";
			// 
			// numbErrTsPacket
			// 
			this->numbErrTsPacket->AutoSize = true;
			this->numbErrTsPacket->Location = System::Drawing::Point(6, 51);
			this->numbErrTsPacket->Name = L"numbErrTsPacket";
			this->numbErrTsPacket->Size = System::Drawing::Size(46, 13);
			this->numbErrTsPacket->TabIndex = 2;
			this->numbErrTsPacket->Text = L"Chybné:";
			// 
			// numbTsPacket
			// 
			this->numbTsPacket->AutoSize = true;
			this->numbTsPacket->Location = System::Drawing::Point(6, 25);
			this->numbTsPacket->Name = L"numbTsPacket";
			this->numbTsPacket->Size = System::Drawing::Size(45, 13);
			this->numbTsPacket->TabIndex = 1;
			this->numbTsPacket->Text = L"Celkem:";
			// 
			// VnumbTsPacket
			// 
			this->VnumbTsPacket->AutoSize = true;
			this->VnumbTsPacket->Location = System::Drawing::Point(65, 25);
			this->VnumbTsPacket->Name = L"VnumbTsPacket";
			this->VnumbTsPacket->Size = System::Drawing::Size(22, 13);
			this->VnumbTsPacket->TabIndex = 0;
			this->VnumbTsPacket->Text = L"  ---";
			// 
			// listBoxPat
			// 
			this->listBoxPat->Anchor = static_cast<System::Windows::Forms::AnchorStyles>((((System::Windows::Forms::AnchorStyles::Top | System::Windows::Forms::AnchorStyles::Bottom) 
				| System::Windows::Forms::AnchorStyles::Left) 
				| System::Windows::Forms::AnchorStyles::Right));
			this->listBoxPat->ColumnWidth = 10;
			this->listBoxPat->FormattingEnabled = true;
			this->listBoxPat->Location = System::Drawing::Point(3, 19);
			this->listBoxPat->Name = L"listBoxPat";
			this->listBoxPat->Size = System::Drawing::Size(618, 342);
			this->listBoxPat->TabIndex = 10;
			// 
			// tabControlMain
			// 
			this->tabControlMain->Anchor = static_cast<System::Windows::Forms::AnchorStyles>((((System::Windows::Forms::AnchorStyles::Top | System::Windows::Forms::AnchorStyles::Bottom) 
				| System::Windows::Forms::AnchorStyles::Left) 
				| System::Windows::Forms::AnchorStyles::Right));
			this->tabControlMain->Controls->Add(this->tabPagePat);
			this->tabControlMain->Controls->Add(this->tabPagePmt);
			this->tabControlMain->Controls->Add(this->tabPageNit);
			this->tabControlMain->Controls->Add(this->tabPagelSdt);
			this->tabControlMain->Controls->Add(this->tabPageBat);
			this->tabControlMain->Controls->Add(this->tabPageEit);
			this->tabControlMain->Controls->Add(this->tabPageTdtTot);
			this->tabControlMain->Controls->Add(this->tabContolResultAnalyze);
			this->tabControlMain->Controls->Add(this->tabPageFrequence);
			this->tabControlMain->Location = System::Drawing::Point(183, 12);
			this->tabControlMain->Name = L"tabControlMain";
			this->tabControlMain->SelectedIndex = 0;
			this->tabControlMain->Size = System::Drawing::Size(632, 401);
			this->tabControlMain->TabIndex = 11;
			// 
			// tabPagePat
			// 
			this->tabPagePat->Controls->Add(this->labelPatPopis);
			this->tabPagePat->Controls->Add(this->listBoxPat);
			this->tabPagePat->Location = System::Drawing::Point(4, 22);
			this->tabPagePat->Name = L"tabPagePat";
			this->tabPagePat->Padding = System::Windows::Forms::Padding(3);
			this->tabPagePat->Size = System::Drawing::Size(624, 375);
			this->tabPagePat->TabIndex = 0;
			this->tabPagePat->Text = L"PAT";
			this->tabPagePat->UseVisualStyleBackColor = true;
			// 
			// labelPatPopis
			// 
			this->labelPatPopis->AutoSize = true;
			this->labelPatPopis->Location = System::Drawing::Point(3, 3);
			this->labelPatPopis->Name = L"labelPatPopis";
			this->labelPatPopis->Size = System::Drawing::Size(331, 13);
			this->labelPatPopis->TabIndex = 0;
			this->labelPatPopis->Text = L"PAT - definována standardem DVB - slouží k rozklíčování multiplexu";
			// 
			// tabPagePmt
			// 
			this->tabPagePmt->Controls->Add(this->labelPmtsPopis);
			this->tabPagePmt->Controls->Add(this->labelProgramPmt);
			this->tabPagePmt->Controls->Add(this->comboBoxPmt);
			this->tabPagePmt->Controls->Add(this->listBoxPmt);
			this->tabPagePmt->Location = System::Drawing::Point(4, 22);
			this->tabPagePmt->Name = L"tabPagePmt";
			this->tabPagePmt->Padding = System::Windows::Forms::Padding(3);
			this->tabPagePmt->Size = System::Drawing::Size(624, 375);
			this->tabPagePmt->TabIndex = 1;
			this->tabPagePmt->Text = L"PMT";
			this->tabPagePmt->UseVisualStyleBackColor = true;
			// 
			// labelPmtsPopis
			// 
			this->labelPmtsPopis->AutoSize = true;
			this->labelPmtsPopis->Location = System::Drawing::Point(3, 3);
			this->labelPmtsPopis->Name = L"labelPmtsPopis";
			this->labelPmtsPopis->Size = System::Drawing::Size(529, 13);
			this->labelPmtsPopis->TabIndex = 0;
			this->labelPmtsPopis->Text = L"PMT - definována standardem DVB - nese informace o  PID elementárních streamů kaž" 
				L"dého programu (služby)";
			// 
			// labelProgramPmt
			// 
			this->labelProgramPmt->Anchor = static_cast<System::Windows::Forms::AnchorStyles>((System::Windows::Forms::AnchorStyles::Top | System::Windows::Forms::AnchorStyles::Right));
			this->labelProgramPmt->AutoSize = true;
			this->labelProgramPmt->Location = System::Drawing::Point(366, 23);
			this->labelProgramPmt->Name = L"labelProgramPmt";
			this->labelProgramPmt->Size = System::Drawing::Size(49, 13);
			this->labelProgramPmt->TabIndex = 17;
			this->labelProgramPmt->Text = L"Program:";
			// 
			// comboBoxPmt
			// 
			this->comboBoxPmt->Anchor = static_cast<System::Windows::Forms::AnchorStyles>((System::Windows::Forms::AnchorStyles::Top | System::Windows::Forms::AnchorStyles::Right));
			this->comboBoxPmt->DropDownStyle = System::Windows::Forms::ComboBoxStyle::DropDownList;
			this->comboBoxPmt->FormattingEnabled = true;
			this->comboBoxPmt->Location = System::Drawing::Point(421, 20);
			this->comboBoxPmt->Name = L"comboBoxPmt";
			this->comboBoxPmt->Size = System::Drawing::Size(200, 21);
			this->comboBoxPmt->TabIndex = 16;
			this->comboBoxPmt->SelectedIndexChanged += gcnew System::EventHandler(this, &SiAnalyzator::PmtServiceChange);
			// 
			// listBoxPmt
			// 
			this->listBoxPmt->Anchor = static_cast<System::Windows::Forms::AnchorStyles>((((System::Windows::Forms::AnchorStyles::Top | System::Windows::Forms::AnchorStyles::Bottom) 
				| System::Windows::Forms::AnchorStyles::Left) 
				| System::Windows::Forms::AnchorStyles::Right));
			this->listBoxPmt->ColumnWidth = 10;
			this->listBoxPmt->FormattingEnabled = true;
			this->listBoxPmt->Location = System::Drawing::Point(3, 44);
			this->listBoxPmt->Name = L"listBoxPmt";
			this->listBoxPmt->Size = System::Drawing::Size(618, 316);
			this->listBoxPmt->TabIndex = 11;
			// 
			// tabPageNit
			// 
			this->tabPageNit->Controls->Add(this->labelNitPopis);
			this->tabPageNit->Controls->Add(this->labelMultiplexNit);
			this->tabPageNit->Controls->Add(this->tabControlNit);
			this->tabPageNit->ImeMode = System::Windows::Forms::ImeMode::NoControl;
			this->tabPageNit->Location = System::Drawing::Point(4, 22);
			this->tabPageNit->Name = L"tabPageNit";
			this->tabPageNit->Padding = System::Windows::Forms::Padding(3);
			this->tabPageNit->Size = System::Drawing::Size(624, 375);
			this->tabPageNit->TabIndex = 2;
			this->tabPageNit->Text = L"NIT";
			this->tabPageNit->UseVisualStyleBackColor = true;
			// 
			// labelNitPopis
			// 
			this->labelNitPopis->AutoSize = true;
			this->labelNitPopis->Location = System::Drawing::Point(3, 3);
			this->labelNitPopis->Name = L"labelNitPopis";
			this->labelNitPopis->Size = System::Drawing::Size(435, 13);
			this->labelNitPopis->TabIndex = 0;
			this->labelNitPopis->Text = L"NIT - definována standardem MPEG - obsahuje informace o vysílací síti daného mult" 
				L"iplexu";
			// 
			// labelMultiplexNit
			// 
			this->labelMultiplexNit->AutoSize = true;
			this->labelMultiplexNit->Location = System::Drawing::Point(3, 24);
			this->labelMultiplexNit->Name = L"labelMultiplexNit";
			this->labelMultiplexNit->Size = System::Drawing::Size(51, 13);
			this->labelMultiplexNit->TabIndex = 4;
			this->labelMultiplexNit->Text = L"Multiplex:";
			// 
			// tabControlNit
			// 
			this->tabControlNit->Anchor = static_cast<System::Windows::Forms::AnchorStyles>((((System::Windows::Forms::AnchorStyles::Top | System::Windows::Forms::AnchorStyles::Bottom) 
				| System::Windows::Forms::AnchorStyles::Left) 
				| System::Windows::Forms::AnchorStyles::Right));
			this->tabControlNit->Controls->Add(this->tabPageNitActual);
			this->tabControlNit->Controls->Add(this->tabPageNitOther);
			this->tabControlNit->Location = System::Drawing::Point(3, 40);
			this->tabControlNit->Name = L"tabControlNit";
			this->tabControlNit->SelectedIndex = 0;
			this->tabControlNit->Size = System::Drawing::Size(621, 332);
			this->tabControlNit->TabIndex = 3;
			// 
			// tabPageNitActual
			// 
			this->tabPageNitActual->CausesValidation = false;
			this->tabPageNitActual->Controls->Add(this->listBoxNitActual);
			this->tabPageNitActual->Location = System::Drawing::Point(4, 22);
			this->tabPageNitActual->Name = L"tabPageNitActual";
			this->tabPageNitActual->Padding = System::Windows::Forms::Padding(3);
			this->tabPageNitActual->Size = System::Drawing::Size(613, 306);
			this->tabPageNitActual->TabIndex = 0;
			this->tabPageNitActual->Text = L"Tento";
			this->tabPageNitActual->UseVisualStyleBackColor = true;
			// 
			// listBoxNitActual
			// 
			this->listBoxNitActual->Anchor = static_cast<System::Windows::Forms::AnchorStyles>((((System::Windows::Forms::AnchorStyles::Top | System::Windows::Forms::AnchorStyles::Bottom) 
				| System::Windows::Forms::AnchorStyles::Left) 
				| System::Windows::Forms::AnchorStyles::Right));
			this->listBoxNitActual->ColumnWidth = 10;
			this->listBoxNitActual->FormattingEnabled = true;
			this->listBoxNitActual->Location = System::Drawing::Point(3, 6);
			this->listBoxNitActual->Name = L"listBoxNitActual";
			this->listBoxNitActual->Size = System::Drawing::Size(607, 290);
			this->listBoxNitActual->TabIndex = 12;
			// 
			// tabPageNitOther
			// 
			this->tabPageNitOther->Controls->Add(this->listBoxNitOther);
			this->tabPageNitOther->Location = System::Drawing::Point(4, 22);
			this->tabPageNitOther->Name = L"tabPageNitOther";
			this->tabPageNitOther->Padding = System::Windows::Forms::Padding(3);
			this->tabPageNitOther->Size = System::Drawing::Size(613, 306);
			this->tabPageNitOther->TabIndex = 1;
			this->tabPageNitOther->Text = L"Jiný";
			this->tabPageNitOther->UseVisualStyleBackColor = true;
			// 
			// listBoxNitOther
			// 
			this->listBoxNitOther->Anchor = static_cast<System::Windows::Forms::AnchorStyles>((((System::Windows::Forms::AnchorStyles::Top | System::Windows::Forms::AnchorStyles::Bottom) 
				| System::Windows::Forms::AnchorStyles::Left) 
				| System::Windows::Forms::AnchorStyles::Right));
			this->listBoxNitOther->ColumnWidth = 10;
			this->listBoxNitOther->FormattingEnabled = true;
			this->listBoxNitOther->Location = System::Drawing::Point(3, 6);
			this->listBoxNitOther->Name = L"listBoxNitOther";
			this->listBoxNitOther->Size = System::Drawing::Size(607, 290);
			this->listBoxNitOther->TabIndex = 13;
			// 
			// tabPagelSdt
			// 
			this->tabPagelSdt->Controls->Add(this->labelSdtPopis);
			this->tabPagelSdt->Controls->Add(this->labelMultiplexSdt);
			this->tabPagelSdt->Controls->Add(this->tabControlSdt);
			this->tabPagelSdt->Location = System::Drawing::Point(4, 22);
			this->tabPagelSdt->Name = L"tabPagelSdt";
			this->tabPagelSdt->Padding = System::Windows::Forms::Padding(3);
			this->tabPagelSdt->Size = System::Drawing::Size(624, 375);
			this->tabPagelSdt->TabIndex = 3;
			this->tabPagelSdt->Text = L"SDT";
			this->tabPagelSdt->UseVisualStyleBackColor = true;
			// 
			// labelSdtPopis
			// 
			this->labelSdtPopis->AutoSize = true;
			this->labelSdtPopis->Location = System::Drawing::Point(3, 3);
			this->labelSdtPopis->Name = L"labelSdtPopis";
			this->labelSdtPopis->Size = System::Drawing::Size(458, 13);
			this->labelSdtPopis->TabIndex = 0;
			this->labelSdtPopis->Text = L"SDT - definována standardem MPEG - obsahuje informace o poskytovateli a názvech p" 
				L"rogramů";
			// 
			// labelMultiplexSdt
			// 
			this->labelMultiplexSdt->AutoSize = true;
			this->labelMultiplexSdt->Location = System::Drawing::Point(3, 24);
			this->labelMultiplexSdt->Name = L"labelMultiplexSdt";
			this->labelMultiplexSdt->Size = System::Drawing::Size(51, 13);
			this->labelMultiplexSdt->TabIndex = 4;
			this->labelMultiplexSdt->Text = L"Multiplex:";
			// 
			// tabControlSdt
			// 
			this->tabControlSdt->Anchor = static_cast<System::Windows::Forms::AnchorStyles>((((System::Windows::Forms::AnchorStyles::Top | System::Windows::Forms::AnchorStyles::Bottom) 
				| System::Windows::Forms::AnchorStyles::Left) 
				| System::Windows::Forms::AnchorStyles::Right));
			this->tabControlSdt->Controls->Add(this->tabPageSdtActual);
			this->tabControlSdt->Controls->Add(this->tabPageSdtOther);
			this->tabControlSdt->Location = System::Drawing::Point(3, 40);
			this->tabControlSdt->Name = L"tabControlSdt";
			this->tabControlSdt->SelectedIndex = 0;
			this->tabControlSdt->Size = System::Drawing::Size(618, 332);
			this->tabControlSdt->TabIndex = 3;
			// 
			// tabPageSdtActual
			// 
			this->tabPageSdtActual->Controls->Add(this->labelProgramSdtActual);
			this->tabPageSdtActual->Controls->Add(this->comboBoxSdtActual);
			this->tabPageSdtActual->Controls->Add(this->listBoxSdtActual);
			this->tabPageSdtActual->Location = System::Drawing::Point(4, 22);
			this->tabPageSdtActual->Name = L"tabPageSdtActual";
			this->tabPageSdtActual->Padding = System::Windows::Forms::Padding(3);
			this->tabPageSdtActual->Size = System::Drawing::Size(610, 306);
			this->tabPageSdtActual->TabIndex = 0;
			this->tabPageSdtActual->Text = L"Tento";
			this->tabPageSdtActual->UseVisualStyleBackColor = true;
			// 
			// labelProgramSdtActual
			// 
			this->labelProgramSdtActual->Anchor = static_cast<System::Windows::Forms::AnchorStyles>((System::Windows::Forms::AnchorStyles::Top | System::Windows::Forms::AnchorStyles::Right));
			this->labelProgramSdtActual->AutoSize = true;
			this->labelProgramSdtActual->Location = System::Drawing::Point(349, 9);
			this->labelProgramSdtActual->Name = L"labelProgramSdtActual";
			this->labelProgramSdtActual->Size = System::Drawing::Size(49, 13);
			this->labelProgramSdtActual->TabIndex = 18;
			this->labelProgramSdtActual->Text = L"Program:";
			// 
			// comboBoxSdtActual
			// 
			this->comboBoxSdtActual->Anchor = static_cast<System::Windows::Forms::AnchorStyles>((System::Windows::Forms::AnchorStyles::Top | System::Windows::Forms::AnchorStyles::Right));
			this->comboBoxSdtActual->DropDownStyle = System::Windows::Forms::ComboBoxStyle::DropDownList;
			this->comboBoxSdtActual->FormattingEnabled = true;
			this->comboBoxSdtActual->Location = System::Drawing::Point(407, 6);
			this->comboBoxSdtActual->Name = L"comboBoxSdtActual";
			this->comboBoxSdtActual->Size = System::Drawing::Size(200, 21);
			this->comboBoxSdtActual->TabIndex = 15;
			this->comboBoxSdtActual->SelectedIndexChanged += gcnew System::EventHandler(this, &SiAnalyzator::SdtActualServiceChange);
			// 
			// listBoxSdtActual
			// 
			this->listBoxSdtActual->Anchor = static_cast<System::Windows::Forms::AnchorStyles>((((System::Windows::Forms::AnchorStyles::Top | System::Windows::Forms::AnchorStyles::Bottom) 
				| System::Windows::Forms::AnchorStyles::Left) 
				| System::Windows::Forms::AnchorStyles::Right));
			this->listBoxSdtActual->ColumnWidth = 10;
			this->listBoxSdtActual->FormattingEnabled = true;
			this->listBoxSdtActual->Location = System::Drawing::Point(3, 33);
			this->listBoxSdtActual->Name = L"listBoxSdtActual";
			this->listBoxSdtActual->Size = System::Drawing::Size(604, 264);
			this->listBoxSdtActual->TabIndex = 14;
			// 
			// tabPageSdtOther
			// 
			this->tabPageSdtOther->Controls->Add(this->labelProgramSdtOther);
			this->tabPageSdtOther->Controls->Add(this->comboBoxSdtOther);
			this->tabPageSdtOther->Controls->Add(this->listBoxSdtOther);
			this->tabPageSdtOther->Location = System::Drawing::Point(4, 22);
			this->tabPageSdtOther->Name = L"tabPageSdtOther";
			this->tabPageSdtOther->Padding = System::Windows::Forms::Padding(3);
			this->tabPageSdtOther->Size = System::Drawing::Size(610, 306);
			this->tabPageSdtOther->TabIndex = 1;
			this->tabPageSdtOther->Text = L"Jiný";
			this->tabPageSdtOther->UseVisualStyleBackColor = true;
			// 
			// labelProgramSdtOther
			// 
			this->labelProgramSdtOther->Anchor = static_cast<System::Windows::Forms::AnchorStyles>((System::Windows::Forms::AnchorStyles::Top | System::Windows::Forms::AnchorStyles::Right));
			this->labelProgramSdtOther->AutoSize = true;
			this->labelProgramSdtOther->Location = System::Drawing::Point(349, 9);
			this->labelProgramSdtOther->Name = L"labelProgramSdtOther";
			this->labelProgramSdtOther->Size = System::Drawing::Size(49, 13);
			this->labelProgramSdtOther->TabIndex = 19;
			this->labelProgramSdtOther->Text = L"Program:";
			// 
			// comboBoxSdtOther
			// 
			this->comboBoxSdtOther->Anchor = static_cast<System::Windows::Forms::AnchorStyles>((System::Windows::Forms::AnchorStyles::Top | System::Windows::Forms::AnchorStyles::Right));
			this->comboBoxSdtOther->DropDownStyle = System::Windows::Forms::ComboBoxStyle::DropDownList;
			this->comboBoxSdtOther->FormattingEnabled = true;
			this->comboBoxSdtOther->Location = System::Drawing::Point(407, 6);
			this->comboBoxSdtOther->Name = L"comboBoxSdtOther";
			this->comboBoxSdtOther->Size = System::Drawing::Size(200, 21);
			this->comboBoxSdtOther->TabIndex = 16;
			this->comboBoxSdtOther->SelectedIndexChanged += gcnew System::EventHandler(this, &SiAnalyzator::SdtOtherServiceChange);
			// 
			// listBoxSdtOther
			// 
			this->listBoxSdtOther->Anchor = static_cast<System::Windows::Forms::AnchorStyles>((((System::Windows::Forms::AnchorStyles::Top | System::Windows::Forms::AnchorStyles::Bottom) 
				| System::Windows::Forms::AnchorStyles::Left) 
				| System::Windows::Forms::AnchorStyles::Right));
			this->listBoxSdtOther->ColumnWidth = 10;
			this->listBoxSdtOther->FormattingEnabled = true;
			this->listBoxSdtOther->Location = System::Drawing::Point(3, 33);
			this->listBoxSdtOther->Name = L"listBoxSdtOther";
			this->listBoxSdtOther->Size = System::Drawing::Size(604, 264);
			this->listBoxSdtOther->TabIndex = 14;
			// 
			// tabPageBat
			// 
			this->tabPageBat->Controls->Add(this->labelBatPopis);
			this->tabPageBat->Controls->Add(this->listBoxBat);
			this->tabPageBat->Location = System::Drawing::Point(4, 22);
			this->tabPageBat->Name = L"tabPageBat";
			this->tabPageBat->Padding = System::Windows::Forms::Padding(3);
			this->tabPageBat->Size = System::Drawing::Size(624, 375);
			this->tabPageBat->TabIndex = 4;
			this->tabPageBat->Text = L"BAT";
			this->tabPageBat->UseVisualStyleBackColor = true;
			// 
			// labelBatPopis
			// 
			this->labelBatPopis->AutoSize = true;
			this->labelBatPopis->Location = System::Drawing::Point(3, 3);
			this->labelBatPopis->Name = L"labelBatPopis";
			this->labelBatPopis->Size = System::Drawing::Size(498, 13);
			this->labelBatPopis->TabIndex = 0;
			this->labelBatPopis->Text = L"BAT - definována standardem MPEG - sdružovací tabulka programů (např. programy se" 
				L" stejným žánrem)";
			// 
			// listBoxBat
			// 
			this->listBoxBat->Anchor = static_cast<System::Windows::Forms::AnchorStyles>((((System::Windows::Forms::AnchorStyles::Top | System::Windows::Forms::AnchorStyles::Bottom) 
				| System::Windows::Forms::AnchorStyles::Left) 
				| System::Windows::Forms::AnchorStyles::Right));
			this->listBoxBat->ColumnWidth = 10;
			this->listBoxBat->FormattingEnabled = true;
			this->listBoxBat->Location = System::Drawing::Point(3, 19);
			this->listBoxBat->Name = L"listBoxBat";
			this->listBoxBat->Size = System::Drawing::Size(618, 342);
			this->listBoxBat->TabIndex = 14;
			// 
			// tabPageEit
			// 
			this->tabPageEit->Controls->Add(this->labelEitPopis);
			this->tabPageEit->Controls->Add(this->labelMultiplexEit);
			this->tabPageEit->Controls->Add(this->tabControlEit);
			this->tabPageEit->Location = System::Drawing::Point(4, 22);
			this->tabPageEit->Name = L"tabPageEit";
			this->tabPageEit->Padding = System::Windows::Forms::Padding(3);
			this->tabPageEit->Size = System::Drawing::Size(624, 375);
			this->tabPageEit->TabIndex = 5;
			this->tabPageEit->Text = L"EIT";
			this->tabPageEit->UseVisualStyleBackColor = true;
			// 
			// labelEitPopis
			// 
			this->labelEitPopis->AutoSize = true;
			this->labelEitPopis->Location = System::Drawing::Point(3, 3);
			this->labelEitPopis->Name = L"labelEitPopis";
			this->labelEitPopis->Size = System::Drawing::Size(367, 13);
			this->labelEitPopis->TabIndex = 0;
			this->labelEitPopis->Text = L"EIT - definována standardem MPEG - obsahuje informace o obsahu vysílání";
			// 
			// labelMultiplexEit
			// 
			this->labelMultiplexEit->AutoSize = true;
			this->labelMultiplexEit->Location = System::Drawing::Point(3, 24);
			this->labelMultiplexEit->Name = L"labelMultiplexEit";
			this->labelMultiplexEit->Size = System::Drawing::Size(51, 13);
			this->labelMultiplexEit->TabIndex = 6;
			this->labelMultiplexEit->Text = L"Multiplex:";
			// 
			// tabControlEit
			// 
			this->tabControlEit->Anchor = static_cast<System::Windows::Forms::AnchorStyles>((((System::Windows::Forms::AnchorStyles::Top | System::Windows::Forms::AnchorStyles::Bottom) 
				| System::Windows::Forms::AnchorStyles::Left) 
				| System::Windows::Forms::AnchorStyles::Right));
			this->tabControlEit->Controls->Add(this->tabPageEitActual);
			this->tabControlEit->Controls->Add(this->tabPageEitOther);
			this->tabControlEit->Location = System::Drawing::Point(3, 40);
			this->tabControlEit->Name = L"tabControlEit";
			this->tabControlEit->SelectedIndex = 0;
			this->tabControlEit->Size = System::Drawing::Size(618, 332);
			this->tabControlEit->TabIndex = 5;
			// 
			// tabPageEitActual
			// 
			this->tabPageEitActual->Controls->Add(this->labelProgramEitActual);
			this->tabPageEitActual->Controls->Add(this->comboBoxEitActual);
			this->tabPageEitActual->Controls->Add(this->labelVysilaniEitActual);
			this->tabPageEitActual->Controls->Add(this->tabControlEitActualP);
			this->tabPageEitActual->Location = System::Drawing::Point(4, 22);
			this->tabPageEitActual->Name = L"tabPageEitActual";
			this->tabPageEitActual->Padding = System::Windows::Forms::Padding(3);
			this->tabPageEitActual->Size = System::Drawing::Size(610, 306);
			this->tabPageEitActual->TabIndex = 0;
			this->tabPageEitActual->Text = L"Tento";
			this->tabPageEitActual->UseVisualStyleBackColor = true;
			// 
			// labelProgramEitActual
			// 
			this->labelProgramEitActual->Anchor = static_cast<System::Windows::Forms::AnchorStyles>((System::Windows::Forms::AnchorStyles::Top | System::Windows::Forms::AnchorStyles::Right));
			this->labelProgramEitActual->AutoSize = true;
			this->labelProgramEitActual->Location = System::Drawing::Point(349, 12);
			this->labelProgramEitActual->Name = L"labelProgramEitActual";
			this->labelProgramEitActual->Size = System::Drawing::Size(49, 13);
			this->labelProgramEitActual->TabIndex = 19;
			this->labelProgramEitActual->Text = L"Program:";
			// 
			// comboBoxEitActual
			// 
			this->comboBoxEitActual->Anchor = static_cast<System::Windows::Forms::AnchorStyles>((System::Windows::Forms::AnchorStyles::Top | System::Windows::Forms::AnchorStyles::Right));
			this->comboBoxEitActual->DropDownStyle = System::Windows::Forms::ComboBoxStyle::DropDownList;
			this->comboBoxEitActual->FormattingEnabled = true;
			this->comboBoxEitActual->Location = System::Drawing::Point(404, 9);
			this->comboBoxEitActual->Name = L"comboBoxEitActual";
			this->comboBoxEitActual->Size = System::Drawing::Size(200, 21);
			this->comboBoxEitActual->TabIndex = 8;
			this->comboBoxEitActual->SelectedIndexChanged += gcnew System::EventHandler(this, &SiAnalyzator::EitActualServiceChange);
			// 
			// labelVysilaniEitActual
			// 
			this->labelVysilaniEitActual->AutoSize = true;
			this->labelVysilaniEitActual->Location = System::Drawing::Point(6, 9);
			this->labelVysilaniEitActual->Name = L"labelVysilaniEitActual";
			this->labelVysilaniEitActual->Size = System::Drawing::Size(49, 13);
			this->labelVysilaniEitActual->TabIndex = 7;
			this->labelVysilaniEitActual->Text = L"Vysílání:";
			// 
			// tabControlEitActualP
			// 
			this->tabControlEitActualP->Anchor = static_cast<System::Windows::Forms::AnchorStyles>((((System::Windows::Forms::AnchorStyles::Top | System::Windows::Forms::AnchorStyles::Bottom) 
				| System::Windows::Forms::AnchorStyles::Left) 
				| System::Windows::Forms::AnchorStyles::Right));
			this->tabControlEitActualP->Controls->Add(this->tabPageEitActualP);
			this->tabControlEitActualP->Controls->Add(this->tabPageEitActualEpg);
			this->tabControlEitActualP->Location = System::Drawing::Point(3, 25);
			this->tabControlEitActualP->Name = L"tabControlEitActualP";
			this->tabControlEitActualP->SelectedIndex = 0;
			this->tabControlEitActualP->Size = System::Drawing::Size(604, 278);
			this->tabControlEitActualP->TabIndex = 0;
			// 
			// tabPageEitActualP
			// 
			this->tabPageEitActualP->Controls->Add(this->listBoxEitActualP);
			this->tabPageEitActualP->Location = System::Drawing::Point(4, 22);
			this->tabPageEitActualP->Name = L"tabPageEitActualP";
			this->tabPageEitActualP->Padding = System::Windows::Forms::Padding(3);
			this->tabPageEitActualP->Size = System::Drawing::Size(596, 252);
			this->tabPageEitActualP->TabIndex = 0;
			this->tabPageEitActualP->Text = L"Aktuální";
			this->tabPageEitActualP->UseVisualStyleBackColor = true;
			// 
			// listBoxEitActualP
			// 
			this->listBoxEitActualP->Anchor = static_cast<System::Windows::Forms::AnchorStyles>((((System::Windows::Forms::AnchorStyles::Top | System::Windows::Forms::AnchorStyles::Bottom) 
				| System::Windows::Forms::AnchorStyles::Left) 
				| System::Windows::Forms::AnchorStyles::Right));
			this->listBoxEitActualP->ColumnWidth = 10;
			this->listBoxEitActualP->FormattingEnabled = true;
			this->listBoxEitActualP->HorizontalScrollbar = true;
			this->listBoxEitActualP->Location = System::Drawing::Point(3, 6);
			this->listBoxEitActualP->Name = L"listBoxEitActualP";
			this->listBoxEitActualP->Size = System::Drawing::Size(590, 238);
			this->listBoxEitActualP->TabIndex = 14;
			// 
			// tabPageEitActualEpg
			// 
			this->tabPageEitActualEpg->Controls->Add(this->listBoxEitActualEpg);
			this->tabPageEitActualEpg->Location = System::Drawing::Point(4, 22);
			this->tabPageEitActualEpg->Name = L"tabPageEitActualEpg";
			this->tabPageEitActualEpg->Padding = System::Windows::Forms::Padding(3);
			this->tabPageEitActualEpg->Size = System::Drawing::Size(596, 252);
			this->tabPageEitActualEpg->TabIndex = 2;
			this->tabPageEitActualEpg->Text = L"EPG";
			this->tabPageEitActualEpg->UseVisualStyleBackColor = true;
			// 
			// listBoxEitActualEpg
			// 
			this->listBoxEitActualEpg->Anchor = static_cast<System::Windows::Forms::AnchorStyles>((((System::Windows::Forms::AnchorStyles::Top | System::Windows::Forms::AnchorStyles::Bottom) 
				| System::Windows::Forms::AnchorStyles::Left) 
				| System::Windows::Forms::AnchorStyles::Right));
			this->listBoxEitActualEpg->ColumnWidth = 10;
			this->listBoxEitActualEpg->FormattingEnabled = true;
			this->listBoxEitActualEpg->HorizontalScrollbar = true;
			this->listBoxEitActualEpg->Location = System::Drawing::Point(3, 6);
			this->listBoxEitActualEpg->Name = L"listBoxEitActualEpg";
			this->listBoxEitActualEpg->Size = System::Drawing::Size(590, 238);
			this->listBoxEitActualEpg->TabIndex = 15;
			// 
			// tabPageEitOther
			// 
			this->tabPageEitOther->Controls->Add(this->labelProgramEitOther);
			this->tabPageEitOther->Controls->Add(this->comboBoxEitOther);
			this->tabPageEitOther->Controls->Add(this->labelVysilaniEitOther);
			this->tabPageEitOther->Controls->Add(this->tabControlEitOther);
			this->tabPageEitOther->Location = System::Drawing::Point(4, 22);
			this->tabPageEitOther->Name = L"tabPageEitOther";
			this->tabPageEitOther->Padding = System::Windows::Forms::Padding(3);
			this->tabPageEitOther->Size = System::Drawing::Size(610, 306);
			this->tabPageEitOther->TabIndex = 1;
			this->tabPageEitOther->Text = L"Jiný";
			this->tabPageEitOther->UseVisualStyleBackColor = true;
			// 
			// labelProgramEitOther
			// 
			this->labelProgramEitOther->Anchor = static_cast<System::Windows::Forms::AnchorStyles>((System::Windows::Forms::AnchorStyles::Top | System::Windows::Forms::AnchorStyles::Right));
			this->labelProgramEitOther->AutoSize = true;
			this->labelProgramEitOther->Location = System::Drawing::Point(349, 12);
			this->labelProgramEitOther->Name = L"labelProgramEitOther";
			this->labelProgramEitOther->Size = System::Drawing::Size(49, 13);
			this->labelProgramEitOther->TabIndex = 20;
			this->labelProgramEitOther->Text = L"Program:";
			// 
			// comboBoxEitOther
			// 
			this->comboBoxEitOther->Anchor = static_cast<System::Windows::Forms::AnchorStyles>((System::Windows::Forms::AnchorStyles::Top | System::Windows::Forms::AnchorStyles::Right));
			this->comboBoxEitOther->DropDownStyle = System::Windows::Forms::ComboBoxStyle::DropDownList;
			this->comboBoxEitOther->FormattingEnabled = true;
			this->comboBoxEitOther->Location = System::Drawing::Point(404, 9);
			this->comboBoxEitOther->Name = L"comboBoxEitOther";
			this->comboBoxEitOther->Size = System::Drawing::Size(200, 21);
			this->comboBoxEitOther->TabIndex = 9;
			this->comboBoxEitOther->SelectedIndexChanged += gcnew System::EventHandler(this, &SiAnalyzator::EitOtherServiceChange);
			// 
			// labelVysilaniEitOther
			// 
			this->labelVysilaniEitOther->AutoSize = true;
			this->labelVysilaniEitOther->Location = System::Drawing::Point(6, 9);
			this->labelVysilaniEitOther->Name = L"labelVysilaniEitOther";
			this->labelVysilaniEitOther->Size = System::Drawing::Size(49, 13);
			this->labelVysilaniEitOther->TabIndex = 9;
			this->labelVysilaniEitOther->Text = L"Vysílání:";
			// 
			// tabControlEitOther
			// 
			this->tabControlEitOther->Anchor = static_cast<System::Windows::Forms::AnchorStyles>((((System::Windows::Forms::AnchorStyles::Top | System::Windows::Forms::AnchorStyles::Bottom) 
				| System::Windows::Forms::AnchorStyles::Left) 
				| System::Windows::Forms::AnchorStyles::Right));
			this->tabControlEitOther->Controls->Add(this->tabPageEitOtherP);
			this->tabControlEitOther->Controls->Add(this->tabPageEitOtherEpg);
			this->tabControlEitOther->Location = System::Drawing::Point(3, 25);
			this->tabControlEitOther->Name = L"tabControlEitOther";
			this->tabControlEitOther->SelectedIndex = 0;
			this->tabControlEitOther->Size = System::Drawing::Size(604, 278);
			this->tabControlEitOther->TabIndex = 8;
			// 
			// tabPageEitOtherP
			// 
			this->tabPageEitOtherP->Controls->Add(this->listBoxEitOtherP);
			this->tabPageEitOtherP->Location = System::Drawing::Point(4, 22);
			this->tabPageEitOtherP->Name = L"tabPageEitOtherP";
			this->tabPageEitOtherP->Padding = System::Windows::Forms::Padding(3);
			this->tabPageEitOtherP->Size = System::Drawing::Size(596, 252);
			this->tabPageEitOtherP->TabIndex = 0;
			this->tabPageEitOtherP->Text = L"Aktuální";
			this->tabPageEitOtherP->UseVisualStyleBackColor = true;
			// 
			// listBoxEitOtherP
			// 
			this->listBoxEitOtherP->Anchor = static_cast<System::Windows::Forms::AnchorStyles>((((System::Windows::Forms::AnchorStyles::Top | System::Windows::Forms::AnchorStyles::Bottom) 
				| System::Windows::Forms::AnchorStyles::Left) 
				| System::Windows::Forms::AnchorStyles::Right));
			this->listBoxEitOtherP->ColumnWidth = 10;
			this->listBoxEitOtherP->FormattingEnabled = true;
			this->listBoxEitOtherP->HorizontalScrollbar = true;
			this->listBoxEitOtherP->Location = System::Drawing::Point(3, 6);
			this->listBoxEitOtherP->Name = L"listBoxEitOtherP";
			this->listBoxEitOtherP->Size = System::Drawing::Size(590, 238);
			this->listBoxEitOtherP->TabIndex = 15;
			// 
			// tabPageEitOtherEpg
			// 
			this->tabPageEitOtherEpg->Controls->Add(this->listBoxEitOtherEpg);
			this->tabPageEitOtherEpg->Location = System::Drawing::Point(4, 22);
			this->tabPageEitOtherEpg->Name = L"tabPageEitOtherEpg";
			this->tabPageEitOtherEpg->Padding = System::Windows::Forms::Padding(3);
			this->tabPageEitOtherEpg->Size = System::Drawing::Size(596, 252);
			this->tabPageEitOtherEpg->TabIndex = 1;
			this->tabPageEitOtherEpg->Text = L"EPG";
			this->tabPageEitOtherEpg->UseVisualStyleBackColor = true;
			// 
			// listBoxEitOtherEpg
			// 
			this->listBoxEitOtherEpg->Anchor = static_cast<System::Windows::Forms::AnchorStyles>((((System::Windows::Forms::AnchorStyles::Top | System::Windows::Forms::AnchorStyles::Bottom) 
				| System::Windows::Forms::AnchorStyles::Left) 
				| System::Windows::Forms::AnchorStyles::Right));
			this->listBoxEitOtherEpg->ColumnWidth = 10;
			this->listBoxEitOtherEpg->FormattingEnabled = true;
			this->listBoxEitOtherEpg->HorizontalScrollbar = true;
			this->listBoxEitOtherEpg->Location = System::Drawing::Point(3, 6);
			this->listBoxEitOtherEpg->Name = L"listBoxEitOtherEpg";
			this->listBoxEitOtherEpg->Size = System::Drawing::Size(590, 225);
			this->listBoxEitOtherEpg->TabIndex = 15;
			// 
			// tabPageTdtTot
			// 
			this->tabPageTdtTot->Controls->Add(this->label1);
			this->tabPageTdtTot->Controls->Add(this->labelTdtPopis);
			this->tabPageTdtTot->Controls->Add(this->listBoxTdtTot);
			this->tabPageTdtTot->Location = System::Drawing::Point(4, 22);
			this->tabPageTdtTot->Name = L"tabPageTdtTot";
			this->tabPageTdtTot->Padding = System::Windows::Forms::Padding(3);
			this->tabPageTdtTot->Size = System::Drawing::Size(624, 375);
			this->tabPageTdtTot->TabIndex = 6;
			this->tabPageTdtTot->Text = L"TDT/TOT";
			this->tabPageTdtTot->UseVisualStyleBackColor = true;
			// 
			// label1
			// 
			this->label1->AutoSize = true;
			this->label1->Location = System::Drawing::Point(3, 16);
			this->label1->Name = L"label1";
			this->label1->Size = System::Drawing::Size(554, 13);
			this->label1->TabIndex = 16;
			this->label1->Text = L"TOT - definována standardem MPEG - obsahuje informace o UTC čase,  a změnách SEČ " 
				L"(UTC+1) a SELČ (UTC+2)";
			// 
			// labelTdtPopis
			// 
			this->labelTdtPopis->AutoSize = true;
			this->labelTdtPopis->Location = System::Drawing::Point(3, 3);
			this->labelTdtPopis->Name = L"labelTdtPopis";
			this->labelTdtPopis->Size = System::Drawing::Size(515, 13);
			this->labelTdtPopis->TabIndex = 0;
			this->labelTdtPopis->Text = L"TDT - definována standardem MPEG - obsahuje informace o UTC čase dekodovaném z an" 
				L"alyzovaných dat";
			// 
			// listBoxTdtTot
			// 
			this->listBoxTdtTot->Anchor = static_cast<System::Windows::Forms::AnchorStyles>((((System::Windows::Forms::AnchorStyles::Top | System::Windows::Forms::AnchorStyles::Bottom) 
				| System::Windows::Forms::AnchorStyles::Left) 
				| System::Windows::Forms::AnchorStyles::Right));
			this->listBoxTdtTot->ColumnWidth = 10;
			this->listBoxTdtTot->FormattingEnabled = true;
			this->listBoxTdtTot->Location = System::Drawing::Point(3, 32);
			this->listBoxTdtTot->Name = L"listBoxTdtTot";
			this->listBoxTdtTot->Size = System::Drawing::Size(618, 329);
			this->listBoxTdtTot->TabIndex = 15;
			// 
			// tabContolResultAnalyze
			// 
			this->tabContolResultAnalyze->Controls->Add(this->groupBoxNumberOfNotAnalyzeTables);
			this->tabContolResultAnalyze->Controls->Add(this->groupBoxNumberOfAnalyzeTables);
			this->tabContolResultAnalyze->Controls->Add(this->groupBox1);
			this->tabContolResultAnalyze->Location = System::Drawing::Point(4, 22);
			this->tabContolResultAnalyze->Name = L"tabContolResultAnalyze";
			this->tabContolResultAnalyze->Padding = System::Windows::Forms::Padding(3);
			this->tabContolResultAnalyze->Size = System::Drawing::Size(624, 375);
			this->tabContolResultAnalyze->TabIndex = 7;
			this->tabContolResultAnalyze->Text = L"Výsledky analýzy";
			this->tabContolResultAnalyze->UseVisualStyleBackColor = true;
			// 
			// groupBoxNumberOfNotAnalyzeTables
			// 
			this->groupBoxNumberOfNotAnalyzeTables->Controls->Add(this->labelVNumberOfSit);
			this->groupBoxNumberOfNotAnalyzeTables->Controls->Add(this->labelNumberOfSit);
			this->groupBoxNumberOfNotAnalyzeTables->Controls->Add(this->labelVNumberOfDit);
			this->groupBoxNumberOfNotAnalyzeTables->Controls->Add(this->labelNumberOfDit);
			this->groupBoxNumberOfNotAnalyzeTables->Controls->Add(this->labelVNumberOfMeasurement);
			this->groupBoxNumberOfNotAnalyzeTables->Controls->Add(this->labelNumberOfMeasurement);
			this->groupBoxNumberOfNotAnalyzeTables->Controls->Add(this->labelVNumberOfMetaData);
			this->groupBoxNumberOfNotAnalyzeTables->Controls->Add(this->labelNumberOfMetaData);
			this->groupBoxNumberOfNotAnalyzeTables->Controls->Add(this->labelVNumberOfRnt);
			this->groupBoxNumberOfNotAnalyzeTables->Controls->Add(this->labelNumberOfRnt);
			this->groupBoxNumberOfNotAnalyzeTables->Controls->Add(this->labelVNumberOfSyncNetwork);
			this->groupBoxNumberOfNotAnalyzeTables->Controls->Add(this->labelNumberOfSyncNetwork);
			this->groupBoxNumberOfNotAnalyzeTables->Controls->Add(this->labelVNumberOfSt);
			this->groupBoxNumberOfNotAnalyzeTables->Controls->Add(this->labelNumberOfSt);
			this->groupBoxNumberOfNotAnalyzeTables->Controls->Add(this->labelVNumberOfRst);
			this->groupBoxNumberOfNotAnalyzeTables->Controls->Add(this->labelNumberOfRst);
			this->groupBoxNumberOfNotAnalyzeTables->Controls->Add(this->labelVNumberOfCit);
			this->groupBoxNumberOfNotAnalyzeTables->Controls->Add(this->labelVNumberOfTsdt);
			this->groupBoxNumberOfNotAnalyzeTables->Controls->Add(this->labelNumberOfCit);
			this->groupBoxNumberOfNotAnalyzeTables->Controls->Add(this->labelVNumberOfCat);
			this->groupBoxNumberOfNotAnalyzeTables->Controls->Add(this->labelNumberOfTsdt);
			this->groupBoxNumberOfNotAnalyzeTables->Controls->Add(this->labelNumberOfCat);
			this->groupBoxNumberOfNotAnalyzeTables->Location = System::Drawing::Point(212, 6);
			this->groupBoxNumberOfNotAnalyzeTables->Name = L"groupBoxNumberOfNotAnalyzeTables";
			this->groupBoxNumberOfNotAnalyzeTables->Size = System::Drawing::Size(200, 312);
			this->groupBoxNumberOfNotAnalyzeTables->TabIndex = 7;
			this->groupBoxNumberOfNotAnalyzeTables->TabStop = false;
			this->groupBoxNumberOfNotAnalyzeTables->Text = L"Počet sekcí ostatních tabulek";
			// 
			// labelVNumberOfSit
			// 
			this->labelVNumberOfSit->AutoSize = true;
			this->labelVNumberOfSit->Location = System::Drawing::Point(138, 288);
			this->labelVNumberOfSit->Name = L"labelVNumberOfSit";
			this->labelVNumberOfSit->Size = System::Drawing::Size(22, 13);
			this->labelVNumberOfSit->TabIndex = 35;
			this->labelVNumberOfSit->Text = L"  ---";
			// 
			// labelNumberOfSit
			// 
			this->labelNumberOfSit->AutoSize = true;
			this->labelNumberOfSit->Location = System::Drawing::Point(6, 288);
			this->labelNumberOfSit->Name = L"labelNumberOfSit";
			this->labelNumberOfSit->Size = System::Drawing::Size(27, 13);
			this->labelNumberOfSit->TabIndex = 15;
			this->labelNumberOfSit->Text = L"SIT:";
			// 
			// labelVNumberOfDit
			// 
			this->labelVNumberOfDit->AutoSize = true;
			this->labelVNumberOfDit->Location = System::Drawing::Point(138, 262);
			this->labelVNumberOfDit->Name = L"labelVNumberOfDit";
			this->labelVNumberOfDit->Size = System::Drawing::Size(22, 13);
			this->labelVNumberOfDit->TabIndex = 34;
			this->labelVNumberOfDit->Text = L"  ---";
			// 
			// labelNumberOfDit
			// 
			this->labelNumberOfDit->AutoSize = true;
			this->labelNumberOfDit->Location = System::Drawing::Point(6, 262);
			this->labelNumberOfDit->Name = L"labelNumberOfDit";
			this->labelNumberOfDit->Size = System::Drawing::Size(28, 13);
			this->labelNumberOfDit->TabIndex = 14;
			this->labelNumberOfDit->Text = L"DIT:";
			// 
			// labelVNumberOfMeasurement
			// 
			this->labelVNumberOfMeasurement->AutoSize = true;
			this->labelVNumberOfMeasurement->Location = System::Drawing::Point(138, 236);
			this->labelVNumberOfMeasurement->Name = L"labelVNumberOfMeasurement";
			this->labelVNumberOfMeasurement->Size = System::Drawing::Size(22, 13);
			this->labelVNumberOfMeasurement->TabIndex = 33;
			this->labelVNumberOfMeasurement->Text = L"  ---";
			// 
			// labelNumberOfMeasurement
			// 
			this->labelNumberOfMeasurement->AutoSize = true;
			this->labelNumberOfMeasurement->Location = System::Drawing::Point(6, 236);
			this->labelNumberOfMeasurement->Name = L"labelNumberOfMeasurement";
			this->labelNumberOfMeasurement->Size = System::Drawing::Size(45, 13);
			this->labelNumberOfMeasurement->TabIndex = 13;
			this->labelNumberOfMeasurement->Text = L"Měření:";
			// 
			// labelVNumberOfMetaData
			// 
			this->labelVNumberOfMetaData->AutoSize = true;
			this->labelVNumberOfMetaData->Location = System::Drawing::Point(138, 210);
			this->labelVNumberOfMetaData->Name = L"labelVNumberOfMetaData";
			this->labelVNumberOfMetaData->Size = System::Drawing::Size(22, 13);
			this->labelVNumberOfMetaData->TabIndex = 32;
			this->labelVNumberOfMetaData->Text = L"  ---";
			// 
			// labelNumberOfMetaData
			// 
			this->labelNumberOfMetaData->AutoSize = true;
			this->labelNumberOfMetaData->Location = System::Drawing::Point(6, 210);
			this->labelNumberOfMetaData->Name = L"labelNumberOfMetaData";
			this->labelNumberOfMetaData->Size = System::Drawing::Size(58, 13);
			this->labelNumberOfMetaData->TabIndex = 12;
			this->labelNumberOfMetaData->Text = L"Meta data:";
			// 
			// labelVNumberOfRnt
			// 
			this->labelVNumberOfRnt->AutoSize = true;
			this->labelVNumberOfRnt->Location = System::Drawing::Point(138, 184);
			this->labelVNumberOfRnt->Name = L"labelVNumberOfRnt";
			this->labelVNumberOfRnt->Size = System::Drawing::Size(22, 13);
			this->labelVNumberOfRnt->TabIndex = 31;
			this->labelVNumberOfRnt->Text = L"  ---";
			// 
			// labelNumberOfRnt
			// 
			this->labelNumberOfRnt->AutoSize = true;
			this->labelNumberOfRnt->Location = System::Drawing::Point(6, 184);
			this->labelNumberOfRnt->Name = L"labelNumberOfRnt";
			this->labelNumberOfRnt->Size = System::Drawing::Size(33, 13);
			this->labelNumberOfRnt->TabIndex = 11;
			this->labelNumberOfRnt->Text = L"RNT:";
			// 
			// labelVNumberOfSyncNetwork
			// 
			this->labelVNumberOfSyncNetwork->AutoSize = true;
			this->labelVNumberOfSyncNetwork->Location = System::Drawing::Point(138, 158);
			this->labelVNumberOfSyncNetwork->Name = L"labelVNumberOfSyncNetwork";
			this->labelVNumberOfSyncNetwork->Size = System::Drawing::Size(22, 13);
			this->labelVNumberOfSyncNetwork->TabIndex = 30;
			this->labelVNumberOfSyncNetwork->Text = L"  ---";
			// 
			// labelNumberOfSyncNetwork
			// 
			this->labelNumberOfSyncNetwork->AutoSize = true;
			this->labelNumberOfSyncNetwork->Location = System::Drawing::Point(6, 158);
			this->labelNumberOfSyncNetwork->Name = L"labelNumberOfSyncNetwork";
			this->labelNumberOfSyncNetwork->Size = System::Drawing::Size(101, 13);
			this->labelNumberOfSyncNetwork->TabIndex = 10;
			this->labelNumberOfSyncNetwork->Text = L"Synchronizace sítě:";
			// 
			// labelVNumberOfSt
			// 
			this->labelVNumberOfSt->AutoSize = true;
			this->labelVNumberOfSt->Location = System::Drawing::Point(138, 132);
			this->labelVNumberOfSt->Name = L"labelVNumberOfSt";
			this->labelVNumberOfSt->Size = System::Drawing::Size(22, 13);
			this->labelVNumberOfSt->TabIndex = 29;
			this->labelVNumberOfSt->Text = L"  ---";
			// 
			// labelNumberOfSt
			// 
			this->labelNumberOfSt->AutoSize = true;
			this->labelNumberOfSt->Location = System::Drawing::Point(6, 132);
			this->labelNumberOfSt->Name = L"labelNumberOfSt";
			this->labelNumberOfSt->Size = System::Drawing::Size(24, 13);
			this->labelNumberOfSt->TabIndex = 9;
			this->labelNumberOfSt->Text = L"ST:";
			// 
			// labelVNumberOfRst
			// 
			this->labelVNumberOfRst->AutoSize = true;
			this->labelVNumberOfRst->Location = System::Drawing::Point(138, 106);
			this->labelVNumberOfRst->Name = L"labelVNumberOfRst";
			this->labelVNumberOfRst->Size = System::Drawing::Size(22, 13);
			this->labelVNumberOfRst->TabIndex = 27;
			this->labelVNumberOfRst->Text = L"  ---";
			// 
			// labelNumberOfRst
			// 
			this->labelNumberOfRst->AutoSize = true;
			this->labelNumberOfRst->Location = System::Drawing::Point(6, 106);
			this->labelNumberOfRst->Name = L"labelNumberOfRst";
			this->labelNumberOfRst->Size = System::Drawing::Size(32, 13);
			this->labelNumberOfRst->TabIndex = 7;
			this->labelNumberOfRst->Text = L"RST:";
			// 
			// labelVNumberOfCit
			// 
			this->labelVNumberOfCit->AutoSize = true;
			this->labelVNumberOfCit->Location = System::Drawing::Point(138, 77);
			this->labelVNumberOfCit->Name = L"labelVNumberOfCit";
			this->labelVNumberOfCit->Size = System::Drawing::Size(22, 13);
			this->labelVNumberOfCit->TabIndex = 26;
			this->labelVNumberOfCit->Text = L"  ---";
			// 
			// labelVNumberOfTsdt
			// 
			this->labelVNumberOfTsdt->AutoSize = true;
			this->labelVNumberOfTsdt->Location = System::Drawing::Point(138, 51);
			this->labelVNumberOfTsdt->Name = L"labelVNumberOfTsdt";
			this->labelVNumberOfTsdt->Size = System::Drawing::Size(22, 13);
			this->labelVNumberOfTsdt->TabIndex = 25;
			this->labelVNumberOfTsdt->Text = L"  ---";
			// 
			// labelNumberOfCit
			// 
			this->labelNumberOfCit->AutoSize = true;
			this->labelNumberOfCit->Location = System::Drawing::Point(6, 77);
			this->labelNumberOfCit->Name = L"labelNumberOfCit";
			this->labelNumberOfCit->Size = System::Drawing::Size(27, 13);
			this->labelNumberOfCit->TabIndex = 6;
			this->labelNumberOfCit->Text = L"CIT:";
			// 
			// labelVNumberOfCat
			// 
			this->labelVNumberOfCat->AutoSize = true;
			this->labelVNumberOfCat->Location = System::Drawing::Point(138, 22);
			this->labelVNumberOfCat->Name = L"labelVNumberOfCat";
			this->labelVNumberOfCat->Size = System::Drawing::Size(22, 13);
			this->labelVNumberOfCat->TabIndex = 24;
			this->labelVNumberOfCat->Text = L"  ---";
			// 
			// labelNumberOfTsdt
			// 
			this->labelNumberOfTsdt->AutoSize = true;
			this->labelNumberOfTsdt->Location = System::Drawing::Point(6, 51);
			this->labelNumberOfTsdt->Name = L"labelNumberOfTsdt";
			this->labelNumberOfTsdt->Size = System::Drawing::Size(39, 13);
			this->labelNumberOfTsdt->TabIndex = 5;
			this->labelNumberOfTsdt->Text = L"TSDT:";
			// 
			// labelNumberOfCat
			// 
			this->labelNumberOfCat->AutoSize = true;
			this->labelNumberOfCat->Location = System::Drawing::Point(6, 25);
			this->labelNumberOfCat->Name = L"labelNumberOfCat";
			this->labelNumberOfCat->Size = System::Drawing::Size(31, 13);
			this->labelNumberOfCat->TabIndex = 4;
			this->labelNumberOfCat->Text = L"CAT:";
			// 
			// groupBoxNumberOfAnalyzeTables
			// 
			this->groupBoxNumberOfAnalyzeTables->Controls->Add(this->labelVNumberOfTdt);
			this->groupBoxNumberOfAnalyzeTables->Controls->Add(this->labelVNumberOfEitOtherS);
			this->groupBoxNumberOfAnalyzeTables->Controls->Add(this->labelVNumberOfEitOtherP);
			this->groupBoxNumberOfAnalyzeTables->Controls->Add(this->labelVNumberOfEitActualS);
			this->groupBoxNumberOfAnalyzeTables->Controls->Add(this->labelVNumberOfEitActualP);
			this->groupBoxNumberOfAnalyzeTables->Controls->Add(this->labelVNumberOfBat);
			this->groupBoxNumberOfAnalyzeTables->Controls->Add(this->labelVNumberOfSdtOther);
			this->groupBoxNumberOfAnalyzeTables->Controls->Add(this->labelVNumberOfSdtActual);
			this->groupBoxNumberOfAnalyzeTables->Controls->Add(this->labelVNumberOfNitOther);
			this->groupBoxNumberOfAnalyzeTables->Controls->Add(this->labelVNumberOfNitActual);
			this->groupBoxNumberOfAnalyzeTables->Controls->Add(this->labelVNumberOfPmt);
			this->groupBoxNumberOfAnalyzeTables->Controls->Add(this->labelVNumberOfPat);
			this->groupBoxNumberOfAnalyzeTables->Controls->Add(this->labelNumberOfTdt);
			this->groupBoxNumberOfAnalyzeTables->Controls->Add(this->labelNumberOfEitOtherS);
			this->groupBoxNumberOfAnalyzeTables->Controls->Add(this->labelNUmberOfTot);
			this->groupBoxNumberOfAnalyzeTables->Controls->Add(this->labelVNumberOfTot);
			this->groupBoxNumberOfAnalyzeTables->Controls->Add(this->labelNumberOfEitOtherP);
			this->groupBoxNumberOfAnalyzeTables->Controls->Add(this->labelNumberOfEitActualS);
			this->groupBoxNumberOfAnalyzeTables->Controls->Add(this->labelNumberOfEitActualP);
			this->groupBoxNumberOfAnalyzeTables->Controls->Add(this->labelNumberOfBat);
			this->groupBoxNumberOfAnalyzeTables->Controls->Add(this->labelNumberOfSdtOther);
			this->groupBoxNumberOfAnalyzeTables->Controls->Add(this->labelNumberOfSdtActual);
			this->groupBoxNumberOfAnalyzeTables->Controls->Add(this->labelNumberOfNitOther);
			this->groupBoxNumberOfAnalyzeTables->Controls->Add(this->labelNumberOfNitActual);
			this->groupBoxNumberOfAnalyzeTables->Controls->Add(this->labelNUmberOfPmt);
			this->groupBoxNumberOfAnalyzeTables->Controls->Add(this->labelNumberOfPat);
			this->groupBoxNumberOfAnalyzeTables->Location = System::Drawing::Point(6, 6);
			this->groupBoxNumberOfAnalyzeTables->Name = L"groupBoxNumberOfAnalyzeTables";
			this->groupBoxNumberOfAnalyzeTables->Size = System::Drawing::Size(200, 362);
			this->groupBoxNumberOfAnalyzeTables->TabIndex = 6;
			this->groupBoxNumberOfAnalyzeTables->TabStop = false;
			this->groupBoxNumberOfAnalyzeTables->Text = L"Počet sekcí analyzovaných tabulek";
			// 
			// labelVNumberOfTdt
			// 
			this->labelVNumberOfTdt->AutoSize = true;
			this->labelVNumberOfTdt->Location = System::Drawing::Point(145, 314);
			this->labelVNumberOfTdt->Name = L"labelVNumberOfTdt";
			this->labelVNumberOfTdt->Size = System::Drawing::Size(22, 13);
			this->labelVNumberOfTdt->TabIndex = 23;
			this->labelVNumberOfTdt->Text = L"  ---";
			// 
			// labelVNumberOfEitOtherS
			// 
			this->labelVNumberOfEitOtherS->AutoSize = true;
			this->labelVNumberOfEitOtherS->Location = System::Drawing::Point(145, 288);
			this->labelVNumberOfEitOtherS->Name = L"labelVNumberOfEitOtherS";
			this->labelVNumberOfEitOtherS->Size = System::Drawing::Size(22, 13);
			this->labelVNumberOfEitOtherS->TabIndex = 22;
			this->labelVNumberOfEitOtherS->Text = L"  ---";
			// 
			// labelVNumberOfEitOtherP
			// 
			this->labelVNumberOfEitOtherP->AutoSize = true;
			this->labelVNumberOfEitOtherP->Location = System::Drawing::Point(145, 262);
			this->labelVNumberOfEitOtherP->Name = L"labelVNumberOfEitOtherP";
			this->labelVNumberOfEitOtherP->Size = System::Drawing::Size(22, 13);
			this->labelVNumberOfEitOtherP->TabIndex = 21;
			this->labelVNumberOfEitOtherP->Text = L"  ---";
			// 
			// labelVNumberOfEitActualS
			// 
			this->labelVNumberOfEitActualS->AutoSize = true;
			this->labelVNumberOfEitActualS->Location = System::Drawing::Point(145, 236);
			this->labelVNumberOfEitActualS->Name = L"labelVNumberOfEitActualS";
			this->labelVNumberOfEitActualS->Size = System::Drawing::Size(22, 13);
			this->labelVNumberOfEitActualS->TabIndex = 20;
			this->labelVNumberOfEitActualS->Text = L"  ---";
			// 
			// labelVNumberOfEitActualP
			// 
			this->labelVNumberOfEitActualP->AutoSize = true;
			this->labelVNumberOfEitActualP->Location = System::Drawing::Point(145, 210);
			this->labelVNumberOfEitActualP->Name = L"labelVNumberOfEitActualP";
			this->labelVNumberOfEitActualP->Size = System::Drawing::Size(22, 13);
			this->labelVNumberOfEitActualP->TabIndex = 19;
			this->labelVNumberOfEitActualP->Text = L"  ---";
			// 
			// labelVNumberOfBat
			// 
			this->labelVNumberOfBat->AutoSize = true;
			this->labelVNumberOfBat->Location = System::Drawing::Point(145, 184);
			this->labelVNumberOfBat->Name = L"labelVNumberOfBat";
			this->labelVNumberOfBat->Size = System::Drawing::Size(22, 13);
			this->labelVNumberOfBat->TabIndex = 18;
			this->labelVNumberOfBat->Text = L"  ---";
			// 
			// labelVNumberOfSdtOther
			// 
			this->labelVNumberOfSdtOther->AutoSize = true;
			this->labelVNumberOfSdtOther->Location = System::Drawing::Point(145, 158);
			this->labelVNumberOfSdtOther->Name = L"labelVNumberOfSdtOther";
			this->labelVNumberOfSdtOther->Size = System::Drawing::Size(22, 13);
			this->labelVNumberOfSdtOther->TabIndex = 17;
			this->labelVNumberOfSdtOther->Text = L"  ---";
			// 
			// labelVNumberOfSdtActual
			// 
			this->labelVNumberOfSdtActual->AutoSize = true;
			this->labelVNumberOfSdtActual->Location = System::Drawing::Point(145, 132);
			this->labelVNumberOfSdtActual->Name = L"labelVNumberOfSdtActual";
			this->labelVNumberOfSdtActual->Size = System::Drawing::Size(22, 13);
			this->labelVNumberOfSdtActual->TabIndex = 16;
			this->labelVNumberOfSdtActual->Text = L"  ---";
			// 
			// labelVNumberOfNitOther
			// 
			this->labelVNumberOfNitOther->AutoSize = true;
			this->labelVNumberOfNitOther->Location = System::Drawing::Point(145, 106);
			this->labelVNumberOfNitOther->Name = L"labelVNumberOfNitOther";
			this->labelVNumberOfNitOther->Size = System::Drawing::Size(22, 13);
			this->labelVNumberOfNitOther->TabIndex = 15;
			this->labelVNumberOfNitOther->Text = L"  ---";
			// 
			// labelVNumberOfNitActual
			// 
			this->labelVNumberOfNitActual->AutoSize = true;
			this->labelVNumberOfNitActual->Location = System::Drawing::Point(145, 77);
			this->labelVNumberOfNitActual->Name = L"labelVNumberOfNitActual";
			this->labelVNumberOfNitActual->Size = System::Drawing::Size(22, 13);
			this->labelVNumberOfNitActual->TabIndex = 14;
			this->labelVNumberOfNitActual->Text = L"  ---";
			// 
			// labelVNumberOfPmt
			// 
			this->labelVNumberOfPmt->AutoSize = true;
			this->labelVNumberOfPmt->Location = System::Drawing::Point(145, 51);
			this->labelVNumberOfPmt->Name = L"labelVNumberOfPmt";
			this->labelVNumberOfPmt->Size = System::Drawing::Size(22, 13);
			this->labelVNumberOfPmt->TabIndex = 13;
			this->labelVNumberOfPmt->Text = L"  ---";
			// 
			// labelVNumberOfPat
			// 
			this->labelVNumberOfPat->AutoSize = true;
			this->labelVNumberOfPat->Location = System::Drawing::Point(145, 25);
			this->labelVNumberOfPat->Name = L"labelVNumberOfPat";
			this->labelVNumberOfPat->Size = System::Drawing::Size(22, 13);
			this->labelVNumberOfPat->TabIndex = 6;
			this->labelVNumberOfPat->Text = L"  ---";
			// 
			// labelNumberOfTdt
			// 
			this->labelNumberOfTdt->AutoSize = true;
			this->labelNumberOfTdt->Location = System::Drawing::Point(6, 314);
			this->labelNumberOfTdt->Name = L"labelNumberOfTdt";
			this->labelNumberOfTdt->Size = System::Drawing::Size(32, 13);
			this->labelNumberOfTdt->TabIndex = 12;
			this->labelNumberOfTdt->Text = L"TDT:";
			// 
			// labelNumberOfEitOtherS
			// 
			this->labelNumberOfEitOtherS->AutoSize = true;
			this->labelNumberOfEitOtherS->Location = System::Drawing::Point(6, 288);
			this->labelNumberOfEitOtherS->Name = L"labelNumberOfEitOtherS";
			this->labelNumberOfEitOtherS->Size = System::Drawing::Size(125, 13);
			this->labelNumberOfEitOtherS->TabIndex = 11;
			this->labelNumberOfEitOtherS->Text = L"EIT plánovaný (jiný mux):";
			// 
			// labelNUmberOfTot
			// 
			this->labelNUmberOfTot->AutoSize = true;
			this->labelNUmberOfTot->Location = System::Drawing::Point(6, 340);
			this->labelNUmberOfTot->Name = L"labelNUmberOfTot";
			this->labelNUmberOfTot->Size = System::Drawing::Size(32, 13);
			this->labelNUmberOfTot->TabIndex = 8;
			this->labelNUmberOfTot->Text = L"TOT:";
			// 
			// labelVNumberOfTot
			// 
			this->labelVNumberOfTot->AutoSize = true;
			this->labelVNumberOfTot->Location = System::Drawing::Point(145, 340);
			this->labelVNumberOfTot->Name = L"labelVNumberOfTot";
			this->labelVNumberOfTot->Size = System::Drawing::Size(22, 13);
			this->labelVNumberOfTot->TabIndex = 28;
			this->labelVNumberOfTot->Text = L"  ---";
			// 
			// labelNumberOfEitOtherP
			// 
			this->labelNumberOfEitOtherP->AutoSize = true;
			this->labelNumberOfEitOtherP->Location = System::Drawing::Point(6, 262);
			this->labelNumberOfEitOtherP->Name = L"labelNumberOfEitOtherP";
			this->labelNumberOfEitOtherP->Size = System::Drawing::Size(115, 13);
			this->labelNumberOfEitOtherP->TabIndex = 10;
			this->labelNumberOfEitOtherP->Text = L"EIT aktuální (jiný mux):";
			// 
			// labelNumberOfEitActualS
			// 
			this->labelNumberOfEitActualS->AutoSize = true;
			this->labelNumberOfEitActualS->Location = System::Drawing::Point(6, 236);
			this->labelNumberOfEitActualS->Name = L"labelNumberOfEitActualS";
			this->labelNumberOfEitActualS->Size = System::Drawing::Size(134, 13);
			this->labelNumberOfEitActualS->TabIndex = 9;
			this->labelNumberOfEitActualS->Text = L"EIT plánovaný (tento mux):";
			// 
			// labelNumberOfEitActualP
			// 
			this->labelNumberOfEitActualP->AutoSize = true;
			this->labelNumberOfEitActualP->Location = System::Drawing::Point(6, 210);
			this->labelNumberOfEitActualP->Name = L"labelNumberOfEitActualP";
			this->labelNumberOfEitActualP->Size = System::Drawing::Size(124, 13);
			this->labelNumberOfEitActualP->TabIndex = 8;
			this->labelNumberOfEitActualP->Text = L"EIT aktuální (tento mux):";
			// 
			// labelNumberOfBat
			// 
			this->labelNumberOfBat->AutoSize = true;
			this->labelNumberOfBat->Location = System::Drawing::Point(6, 184);
			this->labelNumberOfBat->Name = L"labelNumberOfBat";
			this->labelNumberOfBat->Size = System::Drawing::Size(31, 13);
			this->labelNumberOfBat->TabIndex = 7;
			this->labelNumberOfBat->Text = L"BAT:";
			// 
			// labelNumberOfSdtOther
			// 
			this->labelNumberOfSdtOther->AutoSize = true;
			this->labelNumberOfSdtOther->Location = System::Drawing::Point(6, 158);
			this->labelNumberOfSdtOther->Name = L"labelNumberOfSdtOther";
			this->labelNumberOfSdtOther->Size = System::Drawing::Size(78, 13);
			this->labelNumberOfSdtOther->TabIndex = 6;
			this->labelNumberOfSdtOther->Text = L"SDT (jiný mux):";
			// 
			// labelNumberOfSdtActual
			// 
			this->labelNumberOfSdtActual->AutoSize = true;
			this->labelNumberOfSdtActual->Location = System::Drawing::Point(6, 132);
			this->labelNumberOfSdtActual->Name = L"labelNumberOfSdtActual";
			this->labelNumberOfSdtActual->Size = System::Drawing::Size(87, 13);
			this->labelNumberOfSdtActual->TabIndex = 5;
			this->labelNumberOfSdtActual->Text = L"SDT (tento mux):";
			// 
			// labelNumberOfNitOther
			// 
			this->labelNumberOfNitOther->AutoSize = true;
			this->labelNumberOfNitOther->Location = System::Drawing::Point(6, 106);
			this->labelNumberOfNitOther->Name = L"labelNumberOfNitOther";
			this->labelNumberOfNitOther->Size = System::Drawing::Size(74, 13);
			this->labelNumberOfNitOther->TabIndex = 3;
			this->labelNumberOfNitOther->Text = L"NIT (jiný mux):";
			// 
			// labelNumberOfNitActual
			// 
			this->labelNumberOfNitActual->AutoSize = true;
			this->labelNumberOfNitActual->Location = System::Drawing::Point(6, 77);
			this->labelNumberOfNitActual->Name = L"labelNumberOfNitActual";
			this->labelNumberOfNitActual->Size = System::Drawing::Size(83, 13);
			this->labelNumberOfNitActual->TabIndex = 2;
			this->labelNumberOfNitActual->Text = L"NIT (tento mux):";
			// 
			// labelNUmberOfPmt
			// 
			this->labelNUmberOfPmt->AutoSize = true;
			this->labelNUmberOfPmt->Location = System::Drawing::Point(6, 51);
			this->labelNUmberOfPmt->Name = L"labelNUmberOfPmt";
			this->labelNUmberOfPmt->Size = System::Drawing::Size(33, 13);
			this->labelNUmberOfPmt->TabIndex = 1;
			this->labelNUmberOfPmt->Text = L"PMT:";
			// 
			// labelNumberOfPat
			// 
			this->labelNumberOfPat->AutoSize = true;
			this->labelNumberOfPat->Location = System::Drawing::Point(6, 25);
			this->labelNumberOfPat->Name = L"labelNumberOfPat";
			this->labelNumberOfPat->Size = System::Drawing::Size(31, 13);
			this->labelNumberOfPat->TabIndex = 0;
			this->labelNumberOfPat->Text = L"PAT:";
			// 
			// tabPageFrequence
			// 
			this->tabPageFrequence->Controls->Add(this->labelFrekvencePopis);
			this->tabPageFrequence->Controls->Add(this->listBoxLockedFrequency);
			this->tabPageFrequence->Location = System::Drawing::Point(4, 22);
			this->tabPageFrequence->Name = L"tabPageFrequence";
			this->tabPageFrequence->Padding = System::Windows::Forms::Padding(3);
			this->tabPageFrequence->Size = System::Drawing::Size(624, 375);
			this->tabPageFrequence->TabIndex = 8;
			this->tabPageFrequence->Text = L"Frekvence";
			this->tabPageFrequence->UseVisualStyleBackColor = true;
			// 
			// labelFrekvencePopis
			// 
			this->labelFrekvencePopis->AutoSize = true;
			this->labelFrekvencePopis->Location = System::Drawing::Point(3, 3);
			this->labelFrekvencePopis->Name = L"labelFrekvencePopis";
			this->labelFrekvencePopis->Size = System::Drawing::Size(345, 13);
			this->labelFrekvencePopis->TabIndex = 11;
			this->labelFrekvencePopis->Text = L"Po skenování pásma jsou zde vypsány kanály, kde byl zachycen signál";
			// 
			// listBoxLockedFrequency
			// 
			this->listBoxLockedFrequency->Anchor = static_cast<System::Windows::Forms::AnchorStyles>((((System::Windows::Forms::AnchorStyles::Top | System::Windows::Forms::AnchorStyles::Bottom) 
				| System::Windows::Forms::AnchorStyles::Left) 
				| System::Windows::Forms::AnchorStyles::Right));
			this->listBoxLockedFrequency->FormattingEnabled = true;
			this->listBoxLockedFrequency->Location = System::Drawing::Point(3, 19);
			this->listBoxLockedFrequency->Name = L"listBoxLockedFrequency";
			this->listBoxLockedFrequency->Size = System::Drawing::Size(618, 342);
			this->listBoxLockedFrequency->TabIndex = 0;
			// 
			// backgroundWorkerAnalyze
			// 
			this->backgroundWorkerAnalyze->DoWork += gcnew System::ComponentModel::DoWorkEventHandler(this, &SiAnalyzator::backgroundWorkerAnalyze_DoWork);
			this->backgroundWorkerAnalyze->RunWorkerCompleted += gcnew System::ComponentModel::RunWorkerCompletedEventHandler(this, &SiAnalyzator::backgroundWorkerAnalyze_RunWorkerCompleted);
			// 
			// radioButtonFile
			// 
			this->radioButtonFile->AutoSize = true;
			this->radioButtonFile->Checked = true;
			this->radioButtonFile->Location = System::Drawing::Point(6, 19);
			this->radioButtonFile->Name = L"radioButtonFile";
			this->radioButtonFile->Size = System::Drawing::Size(77, 17);
			this->radioButtonFile->TabIndex = 12;
			this->radioButtonFile->TabStop = true;
			this->radioButtonFile->Text = L"ze souboru";
			this->radioButtonFile->UseVisualStyleBackColor = true;
			this->radioButtonFile->Click += gcnew System::EventHandler(this, &SiAnalyzator::checkFile);
			// 
			// groupBoxZdrojDat
			// 
			this->groupBoxZdrojDat->Controls->Add(this->radioButtonCard);
			this->groupBoxZdrojDat->Controls->Add(this->radioButtonFile);
			this->groupBoxZdrojDat->Location = System::Drawing::Point(7, 12);
			this->groupBoxZdrojDat->Name = L"groupBoxZdrojDat";
			this->groupBoxZdrojDat->Size = System::Drawing::Size(169, 71);
			this->groupBoxZdrojDat->TabIndex = 13;
			this->groupBoxZdrojDat->TabStop = false;
			this->groupBoxZdrojDat->Text = L"Zdroj dat:";
			// 
			// radioButtonCard
			// 
			this->radioButtonCard->AutoSize = true;
			this->radioButtonCard->Location = System::Drawing::Point(6, 42);
			this->radioButtonCard->Name = L"radioButtonCard";
			this->radioButtonCard->Size = System::Drawing::Size(125, 17);
			this->radioButtonCard->TabIndex = 13;
			this->radioButtonCard->TabStop = true;
			this->radioButtonCard->Text = L"z TechniSat AirStar 2";
			this->radioButtonCard->UseVisualStyleBackColor = true;
			this->radioButtonCard->Click += gcnew System::EventHandler(this, &SiAnalyzator::checkCard);
			// 
			// labelFrequency
			// 
			this->labelFrequency->AutoSize = true;
			this->labelFrequency->Location = System::Drawing::Point(6, 55);
			this->labelFrequency->Name = L"labelFrequency";
			this->labelFrequency->Size = System::Drawing::Size(92, 13);
			this->labelFrequency->TabIndex = 14;
			this->labelFrequency->Text = L"Frekvence (MHz):";
			// 
			// groupBoxOpenFile
			// 
			this->groupBoxOpenFile->Controls->Add(this->buttonOpenFile);
			this->groupBoxOpenFile->Location = System::Drawing::Point(7, 89);
			this->groupBoxOpenFile->Name = L"groupBoxOpenFile";
			this->groupBoxOpenFile->Size = System::Drawing::Size(169, 55);
			this->groupBoxOpenFile->TabIndex = 15;
			this->groupBoxOpenFile->TabStop = false;
			this->groupBoxOpenFile->Text = L"Soubor:";
			// 
			// groupBox2
			// 
			this->groupBox2->Controls->Add(this->buttonScanBandwidth);
			this->groupBox2->Controls->Add(this->comboBoxBandwidth);
			this->groupBox2->Controls->Add(this->textBoxDuration);
			this->groupBox2->Controls->Add(this->textBoxFrequencyMHz);
			this->groupBox2->Controls->Add(this->labelDuration);
			this->groupBox2->Controls->Add(this->labelBandwidth);
			this->groupBox2->Controls->Add(this->labelFrequency);
			this->groupBox2->Location = System::Drawing::Point(7, 150);
			this->groupBox2->Name = L"groupBox2";
			this->groupBox2->Size = System::Drawing::Size(169, 135);
			this->groupBox2->TabIndex = 16;
			this->groupBox2->TabStop = false;
			this->groupBox2->Text = L"TechniSat AirStar 2:";
			// 
			// buttonScanBandwidth
			// 
			this->buttonScanBandwidth->Enabled = false;
			this->buttonScanBandwidth->Location = System::Drawing::Point(6, 19);
			this->buttonScanBandwidth->Name = L"buttonScanBandwidth";
			this->buttonScanBandwidth->Size = System::Drawing::Size(155, 28);
			this->buttonScanBandwidth->TabIndex = 17;
			this->buttonScanBandwidth->Text = L"Skenovat pásmo";
			this->buttonScanBandwidth->UseVisualStyleBackColor = true;
			this->buttonScanBandwidth->Click += gcnew System::EventHandler(this, &SiAnalyzator::buttonScanBandwidth_Click);
			// 
			// comboBoxBandwidth
			// 
			this->comboBoxBandwidth->DropDownStyle = System::Windows::Forms::ComboBoxStyle::DropDownList;
			this->comboBoxBandwidth->Enabled = false;
			this->comboBoxBandwidth->ForeColor = System::Drawing::SystemColors::WindowText;
			this->comboBoxBandwidth->FormattingEnabled = true;
			this->comboBoxBandwidth->Items->AddRange(gcnew cli::array< System::Object^  >(3) {L"8", L"7", L"6"});
			this->comboBoxBandwidth->Location = System::Drawing::Point(114, 78);
			this->comboBoxBandwidth->Name = L"comboBoxBandwidth";
			this->comboBoxBandwidth->Size = System::Drawing::Size(47, 21);
			this->comboBoxBandwidth->TabIndex = 17;
			// 
			// textBoxDuration
			// 
			this->textBoxDuration->Enabled = false;
			this->textBoxDuration->Location = System::Drawing::Point(114, 104);
			this->textBoxDuration->Name = L"textBoxDuration";
			this->textBoxDuration->Size = System::Drawing::Size(47, 20);
			this->textBoxDuration->TabIndex = 20;
			this->textBoxDuration->Text = L"30";
			this->textBoxDuration->TextAlign = System::Windows::Forms::HorizontalAlignment::Right;
			// 
			// textBoxFrequencyMHz
			// 
			this->textBoxFrequencyMHz->Enabled = false;
			this->textBoxFrequencyMHz->Location = System::Drawing::Point(114, 52);
			this->textBoxFrequencyMHz->Name = L"textBoxFrequencyMHz";
			this->textBoxFrequencyMHz->Size = System::Drawing::Size(47, 20);
			this->textBoxFrequencyMHz->TabIndex = 18;
			this->textBoxFrequencyMHz->TextAlign = System::Windows::Forms::HorizontalAlignment::Right;
			// 
			// labelDuration
			// 
			this->labelDuration->AutoSize = true;
			this->labelDuration->Location = System::Drawing::Point(6, 107);
			this->labelDuration->Name = L"labelDuration";
			this->labelDuration->Size = System::Drawing::Size(90, 13);
			this->labelDuration->TabIndex = 17;
			this->labelDuration->Text = L"Délka analýzy (s):";
			// 
			// labelBandwidth
			// 
			this->labelBandwidth->AutoSize = true;
			this->labelBandwidth->Location = System::Drawing::Point(6, 81);
			this->labelBandwidth->Name = L"labelBandwidth";
			this->labelBandwidth->Size = System::Drawing::Size(102, 13);
			this->labelBandwidth->TabIndex = 16;
			this->labelBandwidth->Text = L"Šířka pásma (MHz):";
			// 
			// backgroundWorkerLoadCardData
			// 
			this->backgroundWorkerLoadCardData->DoWork += gcnew System::ComponentModel::DoWorkEventHandler(this, &SiAnalyzator::backgroundWorkerLoadCardData_DoWork);
			this->backgroundWorkerLoadCardData->RunWorkerCompleted += gcnew System::ComponentModel::RunWorkerCompletedEventHandler(this, &SiAnalyzator::backgroundWorkerLoadCardData_RunWorkerCompleted);
			// 
			// backgroundWorkerTuneCard
			// 
			this->backgroundWorkerTuneCard->DoWork += gcnew System::ComponentModel::DoWorkEventHandler(this, &SiAnalyzator::backgroundWorkerTuneCard_DoWork);
			this->backgroundWorkerTuneCard->RunWorkerCompleted += gcnew System::ComponentModel::RunWorkerCompletedEventHandler(this, &SiAnalyzator::backgroundWorkerTuneCard_RunWorkerCompleted);
			// 
			// Form1
			// 
			this->AutoScaleDimensions = System::Drawing::SizeF(6, 13);
			this->AutoScaleMode = System::Windows::Forms::AutoScaleMode::Font;
			this->ClientSize = System::Drawing::Size(827, 442);
			this->Controls->Add(this->groupBox2);
			this->Controls->Add(this->groupBoxOpenFile);
			this->Controls->Add(this->groupBoxZdrojDat);
			this->Controls->Add(this->tabControlMain);
			this->Controls->Add(this->statusStrip1);
			this->Controls->Add(this->buttonAnalyze);
			this->MinimumSize = System::Drawing::Size(835, 470);
			this->Name = L"Form1";
			this->Text = L"DVB-T SI Analyzátor";
			this->statusStrip1->ResumeLayout(false);
			this->statusStrip1->PerformLayout();
			this->groupBox1->ResumeLayout(false);
			this->groupBox1->PerformLayout();
			this->tabControlMain->ResumeLayout(false);
			this->tabPagePat->ResumeLayout(false);
			this->tabPagePat->PerformLayout();
			this->tabPagePmt->ResumeLayout(false);
			this->tabPagePmt->PerformLayout();
			this->tabPageNit->ResumeLayout(false);
			this->tabPageNit->PerformLayout();
			this->tabControlNit->ResumeLayout(false);
			this->tabPageNitActual->ResumeLayout(false);
			this->tabPageNitOther->ResumeLayout(false);
			this->tabPagelSdt->ResumeLayout(false);
			this->tabPagelSdt->PerformLayout();
			this->tabControlSdt->ResumeLayout(false);
			this->tabPageSdtActual->ResumeLayout(false);
			this->tabPageSdtActual->PerformLayout();
			this->tabPageSdtOther->ResumeLayout(false);
			this->tabPageSdtOther->PerformLayout();
			this->tabPageBat->ResumeLayout(false);
			this->tabPageBat->PerformLayout();
			this->tabPageEit->ResumeLayout(false);
			this->tabPageEit->PerformLayout();
			this->tabControlEit->ResumeLayout(false);
			this->tabPageEitActual->ResumeLayout(false);
			this->tabPageEitActual->PerformLayout();
			this->tabControlEitActualP->ResumeLayout(false);
			this->tabPageEitActualP->ResumeLayout(false);
			this->tabPageEitActualEpg->ResumeLayout(false);
			this->tabPageEitOther->ResumeLayout(false);
			this->tabPageEitOther->PerformLayout();
			this->tabControlEitOther->ResumeLayout(false);
			this->tabPageEitOtherP->ResumeLayout(false);
			this->tabPageEitOtherEpg->ResumeLayout(false);
			this->tabPageTdtTot->ResumeLayout(false);
			this->tabPageTdtTot->PerformLayout();
			this->tabContolResultAnalyze->ResumeLayout(false);
			this->groupBoxNumberOfNotAnalyzeTables->ResumeLayout(false);
			this->groupBoxNumberOfNotAnalyzeTables->PerformLayout();
			this->groupBoxNumberOfAnalyzeTables->ResumeLayout(false);
			this->groupBoxNumberOfAnalyzeTables->PerformLayout();
			this->tabPageFrequence->ResumeLayout(false);
			this->tabPageFrequence->PerformLayout();
			this->groupBoxZdrojDat->ResumeLayout(false);
			this->groupBoxZdrojDat->PerformLayout();
			this->groupBoxOpenFile->ResumeLayout(false);
			this->groupBox2->ResumeLayout(false);
			this->groupBox2->PerformLayout();
			this->ResumeLayout(false);
			this->PerformLayout();

		}
#pragma endregion

private: void settingsEnable(bool settings)
		 {
			 if (settings)
			 {
				 this->radioButtonCard->Enabled = true;
				 this->radioButtonFile->Enabled = true;
				 this->buttonAnalyze->Enabled = true;
				 this->comboBoxPmt->Enabled = true;
				 this->comboBoxSdtActual->Enabled = true;
				 this->comboBoxSdtOther->Enabled = true;
				 this->comboBoxEitActual->Enabled = true;
				 this->comboBoxEitOther->Enabled = true;
				 if (this->radioButtonFile->Checked == true)
				 {
					 this->buttonOpenFile->Enabled = true;
				 }
				 else
				 {
					 this->textBoxFrequencyMHz->Enabled = true;
					 this->comboBoxBandwidth->Enabled = true;
					 this->textBoxDuration->Enabled = true;
					 this->buttonScanBandwidth->Enabled = true;
				 }
			 } 
			 else
			 {
				 this->radioButtonCard->Enabled = false;
				 this->radioButtonFile->Enabled = false;
				 this->buttonOpenFile->Enabled = false;
				 this->buttonAnalyze->Enabled = false;
				 this->comboBoxPmt->Enabled = false;
				 this->comboBoxSdtActual->Enabled = false;
				 this->comboBoxSdtOther->Enabled = false;
				 this->comboBoxEitActual->Enabled = false;
				 this->comboBoxEitOther->Enabled = false;
				 this->textBoxFrequencyMHz->Enabled = false;
				 this->comboBoxBandwidth->Enabled = false;
				 this->textBoxDuration->Enabled = false;
				 this->buttonScanBandwidth->Enabled = false;
			 }
		 }
private: System::Void checkFile(System::Object^  sender, System::EventArgs^  e)
		 {
			 this->buttonOpenFile->Enabled = true;
			 this->textBoxFrequencyMHz->Enabled = false;
			 this->comboBoxBandwidth->Enabled = false;
			 this->textBoxDuration->Enabled = false;
			 this->buttonScanBandwidth->Enabled = false;
			 this->tabPageFrequence->Enabled = false;
			 
			 if (String::Compare(openFileDialog1->FileName,"empty") == 0)
			 {
				 this->buttonAnalyze->Enabled = false;
			 }
			 else
			 {
				 this->buttonAnalyze->Enabled = true;
			 }
		 }
private: System::Void checkCard(System::Object^  sender, System::EventArgs^  e)
		 {
			 this->buttonAnalyze->Enabled = true;
			 this->textBoxFrequencyMHz->Enabled = true;
			 this->comboBoxBandwidth->Enabled = true;
			 this->textBoxDuration->Enabled = true;
			 this->buttonScanBandwidth->Enabled = true;
			 this->tabPageFrequence->Enabled = true;
			 this->buttonOpenFile->Enabled = false;

			 this->comboBoxBandwidth->SelectedIndex = 0;
		 }

private: System::Void startAnalyze(System::Object^  sender, System::EventArgs^  e)
		 {
			if (loadedData != NULL){delete loadedData;}
			if (container != NULL){delete container;}

			if (this->radioButtonFile->Checked == true)	//nastaveno cteni ze souboru
			{
				fileAnalyze();
			}
			else										//nastaveno cteni z karty
			{
				try
				{
					cardAnalyze();
				}
				catch (BadSettingCardException bSCex)
				{
					MessageBox::Show(gcnew String(bSCex.what()), "Nekorektní vstupní hodnoty");
				}
				catch (MissingDllException mDex)
				{
					MessageBox::Show(gcnew String(mDex.what()), "Chyba");
				}
			}
		 }
private: String^ fileName;
private: void fileAnalyze()
		 {
			 settingsEnable(false);

			 std::string fn(marshal_as<std::string>(openFileDialog1->FileName));
			 loadedData = new DataLoader(fn.c_str());
			 container = new TablesContainer;
			 
			 backgroundWorkerAnalyze->WorkerReportsProgress = false;
			 backgroundWorkerAnalyze->WorkerSupportsCancellation = false;
			 backgroundWorkerAnalyze->RunWorkerAsync();
		 }
private: System::Void openFile(System::Object^  sender, System::EventArgs^  e)
		 {
			 this->statusBar->Text = "Otevirání souboru";
			 if (openFileDialog1->ShowDialog() == System::Windows::Forms::DialogResult::OK)
			 {
				 this->statusBar->Text = openFileDialog1->FileName;
				 this->buttonAnalyze->Enabled = true;
			 }
		 }

private: int frequencyMHz, bandwidthMHz, durationS;
private: void cardAnalyze()
		 {
			 checkCardDriver();
			 checkCardFrequency();
			 checkCardBandwidth();
			 checkCardDuration();
			 settingsEnable(false);

			 backgroundWorkerLoadCardData->WorkerReportsProgress = false;
			 backgroundWorkerLoadCardData->WorkerSupportsCancellation = false;
			 backgroundWorkerLoadCardData->RunWorkerAsync();
		 }
private: void checkCardDriver()
		 {
			 FILE* dll;
			 dll = fopen("CardDriver.dll","rb");
			 if (!dll)
			 {
				throw MissingDllException("Tato funkce není dostupná, protože chybí součást cardDriver.dll");
			 }
			 fclose(dll);
		 }
private: void checkCardFrequency()
		 {
			 //frequency
			 if (textBoxFrequencyMHz->Text == "" || System::Convert::ToInt32(textBoxFrequencyMHz->Text) < 474 || System::Convert::ToInt32(textBoxFrequencyMHz->Text) > 858)
			 {
				 throw BadSettingCardException("Frekvence musí byt zadána v rozsahu 474-869 MHz");
			 }
			 frequencyMHz = System::Convert::ToInt32(textBoxFrequencyMHz->Text);
		 }
private: void checkCardBandwidth()
		 {
			 //bandwidth
			 switch (this->comboBoxBandwidth->SelectedIndex)
			 {
			 case 0:
				 bandwidthMHz = 8;
				 break;
			 case 1:
				 bandwidthMHz = 7;
				 break;
			 case 2:
				 bandwidthMHz = 6;
				 break;
			 default:
				 throw BadSettingCardException("Šířka pásma musí být zvolena (6,7 nebo 8 MHz)");
			 }
		 }
private: void checkCardDuration()
		 {
			 //duration
			 if (textBoxDuration->Text == "" || System::Convert::ToInt32(textBoxDuration->Text) < 1 || System::Convert::ToInt32(textBoxDuration->Text) > 180)
			 {
				 throw BadSettingCardException("Délka nahrávky je omezena v rozsahu 1 - 180 s");
			 }
			 durationS = System::Convert::ToInt32(textBoxDuration->Text);
		 }

private: String^ errCardMsg;
private: bool errFlag;
private: System::Void backgroundWorkerLoadCardData_DoWork(System::Object^  sender, System::ComponentModel::DoWorkEventArgs^  e)
		 {
			Class1^ cardDriver = gcnew Class1;
			/*cardDriver->setFrequencyMhz(frequencyMHz);
			cardDriver->setBandwidthMhz(bandwidthMHz);
			cardDriver->setDurationS(durationS);*/
			errFlag = cardDriver->getTunerData(frequencyMHz, bandwidthMHz, durationS);
			if (!errFlag)
			{
				errCardMsg = cardDriver->getErrMessage();
			}
		 }
private: System::Void backgroundWorkerLoadCardData_RunWorkerCompleted(System::Object^  sender, System::ComponentModel::RunWorkerCompletedEventArgs^  e)
		 {
			if (!errFlag)
			{
				if (errCardMsg == "0x90010115")
				{
					MessageBox::Show("Nepodařilo se zachytit signal, číslo chyby: " + errCardMsg, "Chyba"); //specialni handler chyby pro nezachyceni signalu kvuli proladeni
				}
				else
				{
					MessageBox::Show(errCardMsg, "Chyba");
				}
				settingsEnable(true);
				return;
			}

			 this->statusBar->Text = "Analyzuji data...";
			 std::string fn("PIN0.ts");
			 loadedData = new DataLoader(fn.c_str());
			 container = new TablesContainer;

			 backgroundWorkerAnalyze->WorkerReportsProgress = false;
			 backgroundWorkerAnalyze->WorkerSupportsCancellation = false;
			 backgroundWorkerAnalyze->RunWorkerAsync();
		 }

private: bool lockedFlag;
private: System::Void buttonScanBandwidth_Click(System::Object^  sender, System::EventArgs^  e)
		 {
			 try
			 {
				 checkCardDriver();
			 }
			 catch (MissingDllException mDex)
			 {
				 MessageBox::Show(gcnew String(mDex.what()), "Chyba");
				 return;
			 }
			 lockedFlag = false;
			 settingsEnable(false);
			 checkCardBandwidth();
			 this->tabControlMain->SelectedIndex = 8;
			 backgroundWorkerTuneCard->WorkerReportsProgress = false;
			 backgroundWorkerTuneCard->WorkerSupportsCancellation = false;
			 backgroundWorkerTuneCard->RunWorkerAsync();
		 }
private: System::Void backgroundWorkerTuneCard_DoWork(System::Object^  sender, System::ComponentModel::DoWorkEventArgs^  e)
		 {
			 this->listBoxLockedFrequency->Items->Clear();
			 Class1^ cardTune = gcnew Class1;
			 errFlag = cardTune->controlAdapterInstance();	//inicializace karty
			 if(!errFlag)
			 {
				 errCardMsg = cardTune->getErrMessage();
				 cardTune->controlAdapterInstance();			//uvolneni karty
				 return;
			 }
			 //cardTune->setBandwidthMhz(bandwidthMHz);
			 int channelNumber = 21;
			 this->listBoxLockedFrequency->Items->Add("Bylo spuštěno skenování pro šířku pásma " + System::Convert::ToString(bandwidthMHz) + " MHz");
			 for (int m=474;m<859;m=m+bandwidthMHz)
			 {
				 //cardTune->setFrequencyMhz(m);
				 if (!cardTune->setTuner(m, bandwidthMHz))
				 {
					 errCardMsg = cardTune->getErrMessage();
					 if (errCardMsg == "0x90010115")				//chyba v pripade nezachyceni tuneru - zde ignorovano
					 {
						 this->listBoxLockedFrequency->Items->Add("Kanál číslo "+ System::Convert::ToString(channelNumber) + ", frekvence: " + System::Convert::ToString(m) + " MHz");
					 }
					 else
					 {
						 errFlag = false;							//nastala jina chyba - musi byt false aby se dale odchytla
						 cardTune->controlAdapterInstance();		//uvolneni karty
						 return;
					 }
				 }
				 else
				 {
					 lockedFlag = true;
					 this->listBoxLockedFrequency->Items->Add("Kanál číslo "+ System::Convert::ToString(channelNumber) + ", frekvence: " + System::Convert::ToString(m) + " MHz - ZACHYCENO");
				 }
				 channelNumber++;
			 }
			 cardTune->controlAdapterInstance();					//uvolneni karty
		 }
private: System::Void backgroundWorkerTuneCard_RunWorkerCompleted(System::Object^  sender, System::ComponentModel::RunWorkerCompletedEventArgs^  e)
		 {
			 if (!errFlag)
			 {
				 MessageBox::Show(errCardMsg, "Chyba");
			 }
			 else
			 {
				 if (lockedFlag)
				 {
					 this->listBoxLockedFrequency->Items->Add("Skenování bylo dokončeno.");
				 }
				 else
				 {
					 this->listBoxLockedFrequency->Items->Add("Skenování bylo dokončeno. Žádný signál nebyl zachycen.");
				 }
				 MessageBox::Show("Skenování v pásmu 474 - 858 MHz pro šířku pásma "+ System::Convert::ToString(bandwidthMHz) +" MHz bylo dokončeno.", "Skenování dokončeno");
			 }
			 settingsEnable(true);
		 }

//delegate void DataLoaderLoadDataDelegate();
//void DataLoaderLoadData()
//{
//	loadedData->loadData();
//}

private: System::Void backgroundWorkerAnalyze_DoWork(System::Object^  sender, System::ComponentModel::DoWorkEventArgs^  e)
		 {
			 loadedData->loadData();
		 }
private: System::Void backgroundWorkerAnalyze_RunWorkerCompleted(System::Object^  sender, System::ComponentModel::RunWorkerCompletedEventArgs^  e)
		 {
			settingsEnable(true);

			this->buttonAnalyze->Text = "Analyzovat data";
			this->statusBar->Text = "Připraven";
			if (loadedData == NULL)
			{
				MessageBox::Show("Nepodařilo se načíst soubor", "Analýza dokončena");
				return;
			}
			container = loadedData->getData();
			if(container == NULL)
			{
				MessageBox::Show("Nepodařilo se načíst data", "Analýza dokončena");
				return;
			}
			hourTimeOffset = 0;
			if (loadedData->getNumberOfTot() == 0)
			{
				MessageBox::Show("Soubor načten, časové údaje v EPG nemusí být správné, protože tabulka TOT nebyla nalezena", "Analýza dokončena"/*, MessageBoxIcon::Information*/);
			}
			else
			{
				MessageBox::Show("Soubor načten", "Analýza dokončena");
			}
			displayResults();
		 }

//vola fukce pro plneni formu z naplnenych objektu
private: void displayResults()
		 {
			 displayTdtTot(); //musi byt prvni protoze se zde inicializuje hourTimeOffset
			 displayAnalyzeResult();
			 displayPat();
			 iniComboBoxActualService();
			 iniComboBoxOtherService();
			 displayNitActual();
			 displayNitOther();
			 displayBat();
		 }

//promena rozlisuje puvod dat obsazenych v comboBoxech aktualniho muxu
private: bool selectServiceFromSdt;
//plni comboBoxy SDT a EIT pro aktualni mux, nastavuje selectServiceFromSdt v zavislosti na puvodu dat - pracuje s PAT nebo SDT_ACTUAL
private: void iniComboBoxActualService() 
			{
				this->comboBoxPmt->Items->Clear();
				this->comboBoxSdtActual->Items->Clear();
				this->comboBoxEitActual->Items->Clear();
				if (loadedData->sdtActualLoaded)
				{
					if (container->SDT_ACTUAL.getServiceLoops().size() != 0)
					{
						for (unsigned int m=0;m<container->SDT_ACTUAL.getServiceLoops().size();m++) //prochazeni smycek programů
						{
							bool findServiceDescriptor = false; //nalezen tag 72 = false
							if (container->SDT_ACTUAL.getServiceLoops().at(m).getServiceLoopDescriptors().size() != 0)
							{
								for (unsigned int n=0;n<container->SDT_ACTUAL.getServiceLoops().at(m).getServiceLoopDescriptors().size();n++)	//prochazeni deskriptoru
								{
									if (container->SDT_ACTUAL.getServiceLoops().at(m).getServiceLoopDescriptors().at(n).getTag() == 0x48)  //jestli je tag 72
									{
										//nacti service ID + nazev
										this->comboBoxEitActual->Items->Add(String::Concat(System::Convert::ToString(container->SDT_ACTUAL.getServiceLoops().at(m).getServiceID())," - ", gcnew String(container->SDT_ACTUAL.getServiceLoops().at(m).getServiceLoopDescriptors().at(n).getServiceName().c_str())));
										this->comboBoxSdtActual->Items->Add(String::Concat(System::Convert::ToString(container->SDT_ACTUAL.getServiceLoops().at(m).getServiceID())," - ", gcnew String(container->SDT_ACTUAL.getServiceLoops().at(m).getServiceLoopDescriptors().at(n).getServiceName().c_str())));
										this->comboBoxPmt->Items->Add(String::Concat(System::Convert::ToString(container->SDT_ACTUAL.getServiceLoops().at(m).getServiceID())," - ", gcnew String(container->SDT_ACTUAL.getServiceLoops().at(m).getServiceLoopDescriptors().at(n).getServiceName().c_str())));
										selectServiceFromSdt = true;
										//
										findServiceDescriptor = true;	//nalezen tag 72 = true
										break;
									}
								}
							}
							if (findServiceDescriptor == false)  //tag 72 = false
							{
								//nacti jen service ID bez nazvu
								this->comboBoxEitActual->Items->Add(String::Concat(System::Convert::ToString(container->SDT_ACTUAL.getServiceLoops().at(m).getServiceID())));
								this->comboBoxSdtActual->Items->Add(String::Concat(System::Convert::ToString(container->SDT_ACTUAL.getServiceLoops().at(m).getServiceID())));
								this->comboBoxPmt->Items->Add(String::Concat(System::Convert::ToString(container->SDT_ACTUAL.getServiceLoops().at(m).getServiceID())));
								selectServiceFromSdt = true;
								//
							}
						}
					}
				}
				else
				{
					if (!loadedData->patLoaded){return;}
					if (container->PAT.getProgramNumbersWithoutNit().size() == 0){return;}
					for (unsigned int m=0;m<container->PAT.getProgramNumbersWithoutNit().size();m++) //prochazeni smycek programů
					{
						this->comboBoxEitActual->Items->Add(System::Convert::ToString(container->PAT.getProgramNumbersWithoutNit().at(m)));
						this->comboBoxSdtActual->Items->Add(System::Convert::ToString(container->PAT.getProgramNumbersWithoutNit().at(m)));
						this->comboBoxPmt->Items->Add(System::Convert::ToString(container->PAT.getProgramNumbersWithoutNit().at(m)));
						selectServiceFromSdt = false;
					}
				}
				if (comboBoxEitActual->Items->Count != 0)  //ptat se jestli se neco naplnilo
				{
					this->comboBoxEitActual->SelectedIndex = 0;//jo - nastavit prvni
					this->comboBoxSdtActual->SelectedIndex = 0;
					this->comboBoxPmt->SelectedIndex = 0;
					return;
				}
				//ne - no programs - nastavit jako prvni
			}
//plni comboBoxy SDT a EIT pro jiny mux - pracuje s SDT_OTHER
private: void iniComboBoxOtherService()
			{
				if (!loadedData->sdtOtherLoaded){return;}
				//docasne
				this->comboBoxEitOther->Items->Add("sdtOther byla nalezena (jeji nalazeni souvisi mimo jine i s EIT)");
				this->comboBoxSdtOther->Items->Add("sdtOther byla nalezena");
			}

//plni zalosku vysledky analyzy - pracuje s DataLoader.loadedData
private: void displayAnalyzeResult()
		{
		this->statusBar->Text = "Analýza dat úspěšně dokončena. Připraven";
		this->VnumbTsPacket->Text = System::Convert::ToString(loadedData->getNumberOfTsPacket());
		this->VnumbErrTsPacket->Text = System::Convert::ToString(loadedData->getNumberOfErrorTsPacket());
		this->VnumbLostTsPacket->Text = System::Convert::ToString(loadedData->getNumberOfLostTsPacket());
		 
		this->labelVNumberOfPat->Text = System::Convert::ToString(loadedData->getNumberOfPat());
		this->labelVNumberOfPmt->Text = System::Convert::ToString(loadedData->getNumberOfPmts());
		this->labelVNumberOfNitActual->Text = System::Convert::ToString(loadedData->getNumberOfNitActual());
		this->labelVNumberOfNitOther->Text = System::Convert::ToString(loadedData->getNumberOfNitOther());
		this->labelVNumberOfSdtActual->Text = System::Convert::ToString(loadedData->getNumberOfSdtActual());
		this->labelVNumberOfSdtOther->Text = System::Convert::ToString(loadedData->getNumberOfSdtOther());
		this->labelVNumberOfBat->Text = System::Convert::ToString(loadedData->getNumberOfBat());
		this->labelVNumberOfEitActualP->Text = System::Convert::ToString(loadedData->getNumberOfEitActualP());
		this->labelVNumberOfEitActualS->Text = System::Convert::ToString(loadedData->getNumberOfEitActualS());
		this->labelVNumberOfEitOtherP->Text = System::Convert::ToString(loadedData->getNumberOfEitOtherP());
		this->labelVNumberOfEitOtherS->Text = System::Convert::ToString(loadedData->getNumberOfEitOtherS());
		this->labelVNumberOfTdt->Text = System::Convert::ToString(loadedData->getNumberOfTdt());
		this->labelVNumberOfTot->Text = System::Convert::ToString(loadedData->getNumberOfTot());

		this->labelVNumberOfCat->Text = System::Convert::ToString(loadedData->getNumberOfCat());
		this->labelVNumberOfTsdt->Text = System::Convert::ToString(loadedData->getNumberOfTsdt());
		this->labelVNumberOfCit->Text = System::Convert::ToString(loadedData->getNumberOfCit());
		this->labelVNumberOfRst->Text = System::Convert::ToString(loadedData->getNumberOfRst());
		this->labelVNumberOfSt->Text = System::Convert::ToString(loadedData->getNumberOfSt());
		this->labelVNumberOfSyncNetwork->Text = System::Convert::ToString(loadedData->getNumberOfSyncNetwork());
		this->labelVNumberOfRnt->Text = System::Convert::ToString(loadedData->getNumberOfRnt());
		this->labelVNumberOfMetaData->Text = System::Convert::ToString(loadedData->getNumberOfMetaData());
		this->labelVNumberOfMeasurement->Text = System::Convert::ToString(loadedData->getNumberOfMeasurement());
		this->labelVNumberOfDit->Text = System::Convert::ToString(loadedData->getNumberOfDit());
		this->labelVNumberOfSit->Text = System::Convert::ToString(loadedData->getNumberOfSit());
		}

//tiskne pat - pracuje s PAT
private: void displayPat()
		 {
			this->listBoxPat->Items->Clear();
			if (!loadedData->patLoaded)
			{
			 	this->listBoxPat->Items->Add("Tabulka PAT nebyla nalezena");
			 	return;
			}
			this->listBoxPat->Items->Add("Tabulka PAT, PID: 0x00, ID tabulky: 0x00");
			for (unsigned int m=0;m<container->PAT.getProgramNumbers().size();m++)
			{
				this->listBoxPat->Items->Add(" ");
				this->listBoxPat->Items->Add(String::Concat("Číslo programu: ",System::Convert::ToString(container->PAT.getProgramNumbers().at(m))));
				this->listBoxPat->Items->Add(String::Concat("PID PMT tabulky: ",System::Convert::ToString(container->PAT.getPmtPIDs().at(m))));
			}
		}

//pri zmene vyberu programu se nastavi vybrany index a volaji se funkce pro zobrazovani s parametrem vybraneho indexu - pracuje s PMTs
private: System::Void PmtServiceChange(System::Object^  sender, System::EventArgs^  e)
		 {
			 displayPmt(comboBoxPmt->SelectedIndex);
		 }
//hleda shodne service ID s program number v pmt tabulce, vola pmt tabulku se spravnym serviceIndexem
private: void displayPmt(int serviceIndex)
		 {
			this->listBoxPmt->Items->Clear();
			if (!loadedData->pmtLoaded)
			{
			 	this->listBoxPmt->Items->Add("Tabulky PMT nebyly nalezeny");
			 	return;
			}
			//podle vybraneho programu
			unsigned int m = 0;
			bool displayOK = false;
			for (m=0;m<container->PMT.size();m++)		//prochazi vsechny programy
			{
				if (selectServiceFromSdt == true)
				{
					if (System::Convert::ToString(container->PMT.at(m).getProgramNumber()) == System::Convert::ToString(container->SDT_ACTUAL.getServiceLoops().at(serviceIndex).getServiceID()))	//porovnava service ID s hodnotami v SDT_ACTUAL
					{
						displayOK = true;
						displayPmtOneStream(m);
						break;
					}
				}
				else
				{
					if (System::Convert::ToString(container->PMT.at(m).getProgramNumber()) == System::Convert::ToString(container->PAT.getProgramNumbersWithoutNit().at(serviceIndex)))	//porovnava service ID s hodnotami v PAT
					{
						displayOK = true;
						displayPmtOneStream(m);
						break;
					}
				}
			}
			if (!displayOK)
			{
				//vypis ze se neporadrilo najit shodu ve vyse napsane programove smycce
				this->listBoxPmt->Items->Add("Tabulka PMT pro tento program byla poškozena nebo nebyla nalezena");
			}
		}
//tiskne zvolenou pmt tabulku - pracuje s PMTs
private: void displayPmtOneStream(int m)
		 {
			 this->listBoxPmt->Items->Add(String::Concat("Tabulka PMT, PID: ",System::Convert::ToString(container->PMT.at(m).getPmtPID()),", ID tabulky: ",System::Convert::ToString(container->PMT.at(m).getTableId())));
			 this->listBoxPmt->Items->Add(" ");
			 this->listBoxPmt->Items->Add(String::Concat("Číslo programu: ", System::Convert::ToString(container->PMT.at(m).getProgramNumber())));
			 this->listBoxPmt->Items->Add(String::Concat("PCR PID: ", System::Convert::ToString(container->PMT.at(m).getPcrPID())));
			 this->listBoxPmt->Items->Add(" ");
			 displayPmtDescriptors(m);
			 displayPmtStreamLoops(m);
		 }
//zobrazi vsechny deskriptory v hlavicce pmt - pracuje s PMT
private: void displayPmtDescriptors(int m)
		 {
			 for (unsigned int n=0;n<container->PMT.at(m).getPmtDescriptors().size();n++)
			 {
				 this->listBoxPmt->Items->Add("-----------------------------------------------------------------");
				 switch(container->PMT.at(m).getPmtDescriptors().at(n).getTag())
				 {
				 case DN_TELETEXT:
					 this->listBoxPmt->Items->Add("Teletext descriptor:");
					 this->listBoxPmt->Items->Add(String::Concat("   Tag deskriptoru: ", System::Convert::ToString(container->PMT.at(m).getPmtDescriptors().at(n).getTag())));
					 for (unsigned int k=0;k<container->PMT.at(m).getPmtDescriptors().at(n).getLanguageCode().size();k++)
					 {
						 this->listBoxPmt->Items->Add(String::Concat("      Kód země: ", gcnew String(container->PMT.at(m).getPmtDescriptors().at(n).getLanguageCode().at(k).c_str())));
						 this->listBoxPmt->Items->Add(String::Concat("      Typ teletextu: ", switchTeletextType(container->PMT.at(m).getPmtDescriptors().at(n).getTeletextType().at(k))));
						 this->listBoxPmt->Items->Add(String::Concat("      Magazine number: ", System::Convert::ToString(container->PMT.at(m).getPmtDescriptors().at(n).getTeletextMagazineNumber().at(k))));
						 this->listBoxPmt->Items->Add(String::Concat("      Číslo stránky: ", System::Convert::ToString(container->PMT.at(m).getPmtDescriptors().at(n).getTeletextPageNumber().at(k))));
					 }
					 this->listBoxPmt->Items->Add(" ");
					 break;
				 case DN_APPLICATION_SIGNALLING:
					 this->listBoxPmt->Items->Add("Application signalling descriptor:");
					 this->listBoxPmt->Items->Add(String::Concat("   Tag deskriptoru: ", System::Convert::ToString(container->PMT.at(m).getPmtDescriptors().at(n).getTag())));
					 for (unsigned int k=0;k<container->PMT.at(m).getPmtDescriptors().at(n).getApplicationType().size();k++)
					 {
						 this->listBoxPmt->Items->Add(String::Concat("      Application type: ", System::Convert::ToString(container->PMT.at(m).getPmtDescriptors().at(n).getApplicationType().at(k))));
						 this->listBoxPmt->Items->Add(String::Concat("      AIT číslo verze: ", System::Convert::ToString(container->PMT.at(m).getPmtDescriptors().at(n).getAitVersionNumber().at(k))));
					 }
					 this->listBoxPmt->Items->Add(" ");
					 break;
				 case 0x0A:
					 this->listBoxPmt->Items->Add("ISO 639 language descriptor:");
					 this->listBoxPmt->Items->Add(String::Concat("   Jazyk: ", gcnew String(container->PMT.at(m).getPmtDescriptors().at(n).getRawData().c_str())));
					 this->listBoxPmt->Items->Add(" ");
					 break;
				 default:
					 this->listBoxPmt->Items->Add("Neznamy descriptor:");
					 this->listBoxPmt->Items->Add(String::Concat("   Tag deskriptoru: ", System::Convert::ToString(container->PMT.at(m).getPmtDescriptors().at(n).getTag())));
					 //this->listBoxPmt->Items->Add(String::Concat("  Data deskriptoru: ", gcnew String(kontejner.PMT.at(m).getPmtDescriptors().at(n).getRawData().c_str())));
					 this->listBoxPmt->Items->Add(" ");
				 }
			 }
		 }
//zobrazi vsechny smycky pmt vcetne deskriptorů - pracuje s PMT
private: void displayPmtStreamLoops(int m)
		 {
			 for (unsigned int n=0;n<container->PMT.at(m).getStreamLoops().size();n++)
			 {
				 this->listBoxPmt->Items->Add("-----------------------------------------------------------------");
				 this->listBoxPmt->Items->Add(String::Concat("Typ streamu: ", switchStreamType(container->PMT.at(m).getStreamLoops().at(n).getStreamType())));
				 this->listBoxPmt->Items->Add(String::Concat("Elemetary PID: ", System::Convert::ToString(container->PMT.at(m).getStreamLoops().at(n).getElementaryPID())));
				 for (unsigned int j=0;j<container->PMT.at(m).getStreamLoops().at(n).getStreamLoopDescriptors().size();j++)
				 {
					 switch(container->PMT.at(m).getStreamLoops().at(n).getStreamLoopDescriptors().at(j).getTag())
					 {
					 case DN_TELETEXT:
						 this->listBoxPmt->Items->Add("   Teletext descriptor:");
						 this->listBoxPmt->Items->Add(String::Concat("      Tag deskriptoru: ", System::Convert::ToString(container->PMT.at(m).getStreamLoops().at(n).getStreamLoopDescriptors().at(j).getTag())));
						 for (unsigned int k=0;k<container->PMT.at(m).getStreamLoops().at(n).getStreamLoopDescriptors().at(j).getLanguageCode().size();k++)
						 {
							 this->listBoxPmt->Items->Add(String::Concat("      Kód země: ", gcnew String(container->PMT.at(m).getStreamLoops().at(n).getStreamLoopDescriptors().at(j).getLanguageCode().at(k).c_str())));
							 this->listBoxPmt->Items->Add(String::Concat("      Typ teletextu: ", switchTeletextType(container->PMT.at(m).getStreamLoops().at(n).getStreamLoopDescriptors().at(j).getTeletextType().at(k))));
							 this->listBoxPmt->Items->Add(String::Concat("      Magazine number: ", System::Convert::ToString(container->PMT.at(m).getStreamLoops().at(n).getStreamLoopDescriptors().at(j).getTeletextMagazineNumber().at(k))));
							 this->listBoxPmt->Items->Add(String::Concat("      Číslo stránky: ", System::Convert::ToString(container->PMT.at(m).getStreamLoops().at(n).getStreamLoopDescriptors().at(j).getTeletextPageNumber().at(k))));
						 }
						 this->listBoxPmt->Items->Add(" ");
						 break;
					 case DN_APPLICATION_SIGNALLING:
						 this->listBoxPmt->Items->Add("   Application signalling descriptor:");
						 this->listBoxPmt->Items->Add(String::Concat("     Tag deskriptoru: ", System::Convert::ToString(container->PMT.at(m).getStreamLoops().at(n).getStreamLoopDescriptors().at(j).getTag())));
						 for (unsigned int k=0;k<container->PMT.at(m).getStreamLoops().at(n).getStreamLoopDescriptors().at(j).getApplicationType().size();k++)
						 {
							 this->listBoxPmt->Items->Add(String::Concat("      Application type: ", System::Convert::ToString(container->PMT.at(m).getStreamLoops().at(n).getStreamLoopDescriptors().at(j).getApplicationType().at(k))));
							 this->listBoxPmt->Items->Add(String::Concat("      AIT číslo verze: ", System::Convert::ToString(container->PMT.at(m).getStreamLoops().at(n).getStreamLoopDescriptors().at(j).getAitVersionNumber().at(k))));
						 }
						 this->listBoxPmt->Items->Add(" ");
						 break;
					 case 0x0A:
						 this->listBoxPmt->Items->Add("   ISO 639 language descriptor:");
						 this->listBoxPmt->Items->Add(String::Concat("      Jazyk: ", gcnew String(container->PMT.at(m).getStreamLoops().at(n).getStreamLoopDescriptors().at(j).getRawData().c_str())));
						 this->listBoxPmt->Items->Add(" ");
						 break;
					 default:
						 this->listBoxPmt->Items->Add("   Neznamy descriptor:");
						 this->listBoxPmt->Items->Add(String::Concat("      Tag deskriptoru: ", System::Convert::ToString(container->PMT.at(m).getStreamLoops().at(n).getStreamLoopDescriptors().at(j).getTag())));
						 //this->listBoxPmt->Items->Add(String::Concat("  Data deskriptoru: ", gcnew String(kontejner.PMT.at(m).getStreamLoops().at(n).getStreamLoopDescriptors().at(j).getRawData().c_str())));
						 this->listBoxPmt->Items->Add(" ");
					 }
				 }
			 }
		 }

//zobrazi tabulku nitActual - pracuje s NIT_ACTUAL
private: void displayNitActual()
		 {
			this->listBoxNitActual->Items->Clear();
			if (!loadedData->nitActualLoaded)
			{
			 	this->listBoxNitActual->Items->Add("Tabulka NIT pro tento multiplex nebyla nalezena");
			 	return;
			}
			this->listBoxNitActual->Items->Add("Tabulka NIT, PID: 0x10, ID tabulky: 0x40");
			this->listBoxNitActual->Items->Add(" ");
			this->listBoxNitActual->Items->Add(String::Concat("ID sítě: ", System::Convert::ToString(container->NIT_ACTUAL.getNetworkID())));
			 			 
			displayNitActualDescriptors();
			displayNitActualTransportStreamLoops();
		}
//zobrazi vsechny deskriptory v hlavicce nitActual - pracuje s NIT_ACTUAL
private: void displayNitActualDescriptors()
		 {
			for (unsigned int m=0;m<container->NIT_ACTUAL.getNitDescriptors().size();m++)
			{
				switch(container->NIT_ACTUAL.getNitDescriptors().at(m).getTag())
				{
				case DN_NETWORK_NAME:
			 		this->listBoxNitActual->Items->Add("-----------------------------------------------------------------");
			 		this->listBoxNitActual->Items->Add("Network name descriptor:");
			 		this->listBoxNitActual->Items->Add(String::Concat("  Tag deskriptoru: ", System::Convert::ToString(container->NIT_ACTUAL.getNitDescriptors().at(m).getTag())));
			 		this->listBoxNitActual->Items->Add(String::Concat("  Nazev site: ", gcnew String(container->NIT_ACTUAL.getNitDescriptors().at(m).getNetworkName().c_str())));
			 		this->listBoxNitActual->Items->Add(" ");
			 		break;
				case DN_SERVICE_LIST:
			 		this->listBoxNitActual->Items->Add("-----------------------------------------------------------------");
			 		this->listBoxNitActual->Items->Add("Service list descriptor:");
			 		//kod
			 		this->listBoxNitActual->Items->Add(" ");
			 		break;
				case DN_TERRESTRIAL_DELIVERY_SYSTEM:
			 		this->listBoxNitActual->Items->Add("-----------------------------------------------------------------");
			 		this->listBoxNitActual->Items->Add("Terrestrial delivery system descriptor:");
			 		//kod
			 		this->listBoxNitActual->Items->Add(" ");
			 		break;
				case DN_FREQUENCY_LIST:
			 		this->listBoxNitActual->Items->Add("-----------------------------------------------------------------");
			 		this->listBoxNitActual->Items->Add("Frequency list descriptor:");
			 		//kod
			 		this->listBoxNitActual->Items->Add(" ");
			 		break;
				default:
			 		this->listBoxNitActual->Items->Add("-----------------------------------------------------------------");
			 		this->listBoxNitActual->Items->Add("Neznamy descriptor:");
			 		this->listBoxNitActual->Items->Add(String::Concat("  Tag deskriptoru: ", System::Convert::ToString(container->NIT_ACTUAL.getNitDescriptors().at(m).getTag())));
			 		//this->listBoxNitActual->Items->Add(String::Concat("  Data deskriptoru: ", gcnew String(container->NIT_ACTUAL.getNitDescriptors().at(m).getRawData().c_str())));
			 		this->listBoxNitActual->Items->Add(" ");
				}
			}
		}
//zobrazi vsechny smycky nitActual vcetne deskriptorů - pracuje s NIT_ACTUAL
private: void displayNitActualTransportStreamLoops()
		{
			for (unsigned int m=0;m<container->NIT_ACTUAL.getTrasportStreamLoops().size();m++)
			{
			 	this->listBoxNitActual->Items->Add("-----------------------------------------------------------------");
			 	this->listBoxNitActual->Items->Add("Transport stream:");
			 	this->listBoxNitActual->Items->Add(String::Concat("   Transport stream ID: ", System::Convert::ToString(container->NIT_ACTUAL.getTrasportStreamLoops().at(m).getTransportStreamID())));
			 	this->listBoxNitActual->Items->Add(String::Concat("   Original network ID: ", System::Convert::ToString(container->NIT_ACTUAL.getTrasportStreamLoops().at(m).getOriginalNetworkID())));
			 	this->listBoxNitActual->Items->Add(" ");
			 	for (unsigned int n=0;n<container->NIT_ACTUAL.getTrasportStreamLoops().at(m).getTransportStreamLoopDescriptors().size();n++)
			 	{
			 		switch(container->NIT_ACTUAL.getTrasportStreamLoops().at(m).getTransportStreamLoopDescriptors().at(n).getTag())
			 		{
			 		case DN_NETWORK_NAME:
			 			this->listBoxNitActual->Items->Add("   Network name descriptor:");
			 			this->listBoxNitActual->Items->Add(String::Concat("      Tag deskriptoru: ", System::Convert::ToString(container->NIT_ACTUAL.getTrasportStreamLoops().at(m).getTransportStreamLoopDescriptors().at(n).getTag())));
			 			this->listBoxNitActual->Items->Add(String::Concat("      Nazev site: ", gcnew String(container->NIT_ACTUAL.getTrasportStreamLoops().at(m).getTransportStreamLoopDescriptors().at(n).getNetworkName().c_str())));
			 			this->listBoxNitActual->Items->Add(" ");
			 			break;
			 		case DN_SERVICE_LIST:
			 			this->listBoxNitActual->Items->Add("   Service list descriptor:");
			 			//kod
			 			this->listBoxNitActual->Items->Add(" ");
			 			break;
			 		case DN_TERRESTRIAL_DELIVERY_SYSTEM:
			 			this->listBoxNitActual->Items->Add("   Terrestrial delivery system descriptor:");
			 			this->listBoxNitActual->Items->Add(String::Concat("      Tag deskriptoru: ", System::Convert::ToString(container->NIT_ACTUAL.getTrasportStreamLoops().at(m).getTransportStreamLoopDescriptors().at(n).getTag())));
			 			this->listBoxNitActual->Items->Add(String::Concat("      Centre frequency: ", System::Convert::ToString(container->NIT_ACTUAL.getTrasportStreamLoops().at(m).getTransportStreamLoopDescriptors().at(n).getCentreFrequency().at(0)/100000)," MHz"));
			 			this->listBoxNitActual->Items->Add(String::Concat("      Bandwidth: ", switchBandwidth(container->NIT_ACTUAL.getTrasportStreamLoops().at(m).getTransportStreamLoopDescriptors().at(n).getBandwidth())));
			 			this->listBoxNitActual->Items->Add(String::Concat("      Priority: ", switchPriority(container->NIT_ACTUAL.getTrasportStreamLoops().at(m).getTransportStreamLoopDescriptors().at(n).getPriority())));
			 			this->listBoxNitActual->Items->Add(String::Concat("      Time slicing: ", switchTimeSlicing(container->NIT_ACTUAL.getTrasportStreamLoops().at(m).getTransportStreamLoopDescriptors().at(n).getTimeSlicing())));
			 			this->listBoxNitActual->Items->Add(String::Concat("      MPE-FEC: ", boolToUsed(container->NIT_ACTUAL.getTrasportStreamLoops().at(m).getTransportStreamLoopDescriptors().at(n).getMpeFec())));
			 			this->listBoxNitActual->Items->Add(String::Concat("      Constellation: ", switchConstellation(container->NIT_ACTUAL.getTrasportStreamLoops().at(m).getTransportStreamLoopDescriptors().at(n).getConstellation())));
			 			this->listBoxNitActual->Items->Add(String::Concat("      Hierarchy information: ", switchHierarchyInfo(container->NIT_ACTUAL.getTrasportStreamLoops().at(m).getTransportStreamLoopDescriptors().at(n).getHierarchyInformation())));
			 			this->listBoxNitActual->Items->Add(String::Concat("      Code rate (HP stream): ", switchCodeRate(container->NIT_ACTUAL.getTrasportStreamLoops().at(m).getTransportStreamLoopDescriptors().at(n).getCodeRateHP())));
			 			this->listBoxNitActual->Items->Add(String::Concat("      Code rate (LP stream): ", switchCodeRate(container->NIT_ACTUAL.getTrasportStreamLoops().at(m).getTransportStreamLoopDescriptors().at(n).getCodeRateLP())));
			 			this->listBoxNitActual->Items->Add(String::Concat("      Guard interval: ", switchGuardInterval(container->NIT_ACTUAL.getTrasportStreamLoops().at(m).getTransportStreamLoopDescriptors().at(n).getGuardInterval())));
			 			this->listBoxNitActual->Items->Add(String::Concat("      Transmission mode: ", switchTransmissionMode(container->NIT_ACTUAL.getTrasportStreamLoops().at(m).getTransportStreamLoopDescriptors().at(n).getTransmissionMode())));
			 			this->listBoxNitActual->Items->Add(String::Concat("      Other frequency: ", boolToUsed(container->NIT_ACTUAL.getTrasportStreamLoops().at(m).getTransportStreamLoopDescriptors().at(n).getOtherFrequency())));
			 			this->listBoxNitActual->Items->Add(" ");
			 			break;
			 		case DN_FREQUENCY_LIST:
			 			this->listBoxNitActual->Items->Add("   Frequency list descriptor:");
			 			this->listBoxNitActual->Items->Add(String::Concat("      Tag deskriptoru: ", System::Convert::ToString(container->NIT_ACTUAL.getTrasportStreamLoops().at(m).getTransportStreamLoopDescriptors().at(n).getTag())));
			 			this->listBoxNitActual->Items->Add(String::Concat("      Coding type: ", switchCodingType(container->NIT_ACTUAL.getTrasportStreamLoops().at(m).getTransportStreamLoopDescriptors().at(n).getCodingType())));
			 			for (unsigned int j=0;j<container->NIT_ACTUAL.getTrasportStreamLoops().at(m).getTransportStreamLoopDescriptors().at(n).getCentreFrequency().size();j++)
			 			{
			 				this->listBoxNitActual->Items->Add(String::Concat("      Centre frequency: ", System::Convert::ToString(container->NIT_ACTUAL.getTrasportStreamLoops().at(m).getTransportStreamLoopDescriptors().at(n).getCentreFrequency().at(j)/100000)," MHz"));
			 			}
			 			this->listBoxNitActual->Items->Add(" ");
			 			break;
			 		default:
			 			this->listBoxNitActual->Items->Add("   Neznamy descriptor:");
			 			this->listBoxNitActual->Items->Add(String::Concat("      Tag deskriptoru: ", System::Convert::ToString(container->NIT_ACTUAL.getTrasportStreamLoops().at(m).getTransportStreamLoopDescriptors().at(n).getTag())));
			 			//this->listBoxNitActual->Items->Add(String::Concat("      Data deskriptoru: ", gcnew String(container->NIT_ACTUAL.getTrasportStreamLoops().at(m).getTransportStreamLoopDescriptors().at(n).getRawData().c_str())));
			 			this->listBoxNitActual->Items->Add(" ");
			 		}
			 	}
			}
		}

//zobrazi tabulku nitOther - pracuje s NIT_OTHER
private: void displayNitOther()
		 {
			 this->listBoxNitOther->Items->Clear();
			 if (!loadedData->nitOtherLoaded)
			 {
				 this->listBoxNitOther->Items->Add("Tabulka NIT pro jiný multiplex nebyla nalezena");
				 return;
			 }
			 this->listBoxNitOther->Items->Add("Tabulka NIT, PID: 0x10, ID tabulky: 0x41");
			 this->listBoxNitOther->Items->Add(" ");
		 }
//zobrazi vsechny deskriptory v hlavicce nitOther - pracuje s NIT_OTHER
	//private: void displayNitOtherDescriptors()
//zobrazi vsechny smycky nitOther vcetne deskriptorů - pracuje s NIT_OTHER
	//private: void displayNitOtherTransportStreamLoops()

//pri zmene vyberu programu se nastavi vybrany index a volaji se funkce pro zobrazovani s parametrem vybraneho indexu - pracuje s SDT_ACTUAL
private: System::Void SdtActualServiceChange(System::Object^  sender, System::EventArgs^  e)
		 {
			 displaySdtActual(comboBoxSdtActual->SelectedIndex);
		 }
//zobrazi tabulku sdtActual vybraneho programu podle serviceIndexu- pracuje s SDT_ACTUAL
private: void displaySdtActual(int serviceIndex)
		 {
			 this->listBoxSdtActual->Items->Clear();
			 if (!loadedData->sdtActualLoaded)
			 {
				 this->listBoxSdtActual->Items->Add("Tabulka SDT pro tento multiplex nebyla nalezena");
				 return;
			 }
			 this->listBoxSdtActual->Items->Add("Tabulka SDT, PID: 0x11, ID tabulky: 0x42");
			 this->listBoxSdtActual->Items->Add(" ");
			 this->listBoxSdtActual->Items->Add(String::Concat("Transport stream ID: ", System::Convert::ToString(container->SDT_ACTUAL.getTransportStreamID())));
			 this->listBoxSdtActual->Items->Add(String::Concat("Original network ID: ", System::Convert::ToString(container->SDT_ACTUAL.getOriginalNetworkID())));
			 this->listBoxSdtActual->Items->Add(" ");
			 //podle vybraneho programu
			 unsigned int m = 0;
			 bool displayOK = false;
			 for (m=0;m<container->SDT_ACTUAL.getServiceLoops().size();m++)		//prochazi vsechny programy
			 {
				 if (selectServiceFromSdt == true)
				 {
					 if (System::Convert::ToString(container->SDT_ACTUAL.getServiceLoops().at(m).getServiceID()) == System::Convert::ToString(container->SDT_ACTUAL.getServiceLoops().at(serviceIndex).getServiceID()))	//porovnava service ID
					 {
						 displayOK = true;
						 displaySdtActualServiceLoops(m);
						 break;
					 }
				 }
				 else
				 {
					 if (System::Convert::ToString(container->SDT_ACTUAL.getServiceLoops().at(m).getServiceID()) == System::Convert::ToString(container->PAT.getProgramNumbersWithoutNit().at(serviceIndex)))	//porovnava service ID
					 {
						 displayOK = true;
						 displaySdtActualServiceLoops(m);
						 break;
					 }
				 }
			 }
			 if (!displayOK)
			 {
				 this->listBoxSdtActual->Items->Add("Smyčka dat v tabulce SDT s daty tohoto programu byla poškozena nebo nebyla nalezena");
			 }
		 }
//zobrazi vsechny smycky sdtActual vcetne deskriptorů - pracuje s SDT_ACTUAL
private: void displaySdtActualServiceLoops(int m)
		 {
			this->listBoxSdtActual->Items->Add("-----------------------------------------------------------------");
			this->listBoxSdtActual->Items->Add("Service:");
			this->listBoxSdtActual->Items->Add(String::Concat("   Service ID: ", System::Convert::ToString(container->SDT_ACTUAL.getServiceLoops().at(m).getServiceID())));
			this->listBoxSdtActual->Items->Add(String::Concat("   EIT schedule: ", boolToUsed(container->SDT_ACTUAL.getServiceLoops().at(m).getEitScheduleFlag())));
			this->listBoxSdtActual->Items->Add(String::Concat("   EIT present/following: ", boolToUsed(container->SDT_ACTUAL.getServiceLoops().at(m).getEitPresentFollowingFlag())));
			this->listBoxSdtActual->Items->Add(String::Concat("   Running status: ", switchRunningStatus(container->SDT_ACTUAL.getServiceLoops().at(m).getRunningStatus())));
			this->listBoxSdtActual->Items->Add(String::Concat("   Free/CA mode: ", switchFreeOrCaMode(container->SDT_ACTUAL.getServiceLoops().at(m).getFreeOrCaMode())));
			this->listBoxSdtActual->Items->Add(" ");
			for (unsigned int n=0;n<container->SDT_ACTUAL.getServiceLoops().at(m).getServiceLoopDescriptors().size();n++)
			{
				switch(container->SDT_ACTUAL.getServiceLoops().at(m).getServiceLoopDescriptors().at(n).getTag())
				{
				case DN_SERVICE:
					this->listBoxSdtActual->Items->Add("   Service descriptor:");
					this->listBoxSdtActual->Items->Add(String::Concat("      Tag deskriptoru: ", System::Convert::ToString(container->SDT_ACTUAL.getServiceLoops().at(m).getServiceLoopDescriptors().at(n).getTag())));
					this->listBoxSdtActual->Items->Add(String::Concat("      Typ služby: ", switchServiceType(container->SDT_ACTUAL.getServiceLoops().at(m).getServiceLoopDescriptors().at(n).getServiceType().at(0))));
					this->listBoxSdtActual->Items->Add(String::Concat("      Poskytovatel: ", gcnew String(container->SDT_ACTUAL.getServiceLoops().at(m).getServiceLoopDescriptors().at(n).getServiceProviderName().c_str())));
					this->listBoxSdtActual->Items->Add(String::Concat("      Nazev služby: ", gcnew String(container->SDT_ACTUAL.getServiceLoops().at(m).getServiceLoopDescriptors().at(n).getServiceName().c_str())));
					this->listBoxSdtActual->Items->Add(" ");
					break;
				case DN_COMPONENT:
					this->listBoxSdtActual->Items->Add("   Component descriptor:");
					//kod
					this->listBoxSdtActual->Items->Add(" ");
					break;
				default:
					this->listBoxSdtActual->Items->Add("	Neznamy descriptor:");
					this->listBoxSdtActual->Items->Add(String::Concat("      Tag deskriptoru: ", System::Convert::ToString(container->SDT_ACTUAL.getServiceLoops().at(m).getServiceLoopDescriptors().at(n).getTag())));
					this->listBoxSdtActual->Items->Add(String::Concat("      Data deskriptoru: ", gcnew String(container->SDT_ACTUAL.getServiceLoops().at(m).getServiceLoopDescriptors().at(n).getRawData().c_str())));
					this->listBoxSdtActual->Items->Add(" ");
				}
			}
		 }

//pri zmene vyberu programu se nastavi vybrany index a volaji se funkce pro zobrazovani s parametrem vybraneho indexu - pracuje s SDT_OTHER
private: System::Void SdtOtherServiceChange(System::Object^  sender, System::EventArgs^  e)
		 {
			 displaySdtOther(comboBoxSdtOther->SelectedIndex);
		 }
//zobrazi tabulku sdtOther vybraneho programu podle serviceIndexu- pracuje s SDT_OTHER
private: void displaySdtOther(int serviceIndex)
		 {
			 this->listBoxSdtOther->Items->Clear();
			 if (!loadedData->sdtOtherLoaded)
			 {
				 this->listBoxSdtOther->Items->Add("Tabulka SDT pro jiný multiplex nebyla nalezena");
				 return;
			 }
			 this->listBoxSdtOther->Items->Add("Tabulka SDT, PID: 0x11, ID tabulky: 0x46");
			 this->listBoxSdtOther->Items->Add(" ");
		 }
//zobrazi vsechny smycky sdtOther vcetne deskriptorů - pracuje s SDT_OTHER
//private: void displaySdtOtherServiceLoops()

//zobrazi tabulku bat - pracuje s BAT
private: void displayBat()
		 {
			 this->listBoxBat->Items->Clear();
			 if (!loadedData->batLoaded)
			 {
				 this->listBoxBat->Items->Add("Tabulka BAT nebyla nalezena");
				 return;
			 }
			 this->listBoxBat->Items->Add("Tabulka BAT, PID: 0x11, ID tabulky: 0x4A");
			 this->listBoxBat->Items->Add(" ");
		 }

//pri zmene vyberu programu se nastavi vybrany index a volaji se funkce pro zobrazovani s parametrem vybraneho indexu - pracuje s EIT_ACTUAL_P a EIT_ACTUAL_S 
private: System::Void EitActualServiceChange(System::Object^  sender, System::EventArgs^  e) 
		 {
			 displayEitActualP(comboBoxEitActual->SelectedIndex);
			 displayEitActualS(comboBoxEitActual->SelectedIndex);
		 }

//zobrazi tabulku eitActualP vybraneho programu podle serviceIndexu - pracuje s EIT_ACTUAL_P
private: void displayEitActualP(int serviceIndex)
		 {
			 this->listBoxEitActualP->Items->Clear();
			 this->listBoxEitActualEpg->Items->Clear();
			 //tato zakomentovana podminka zpusobila ze se v pripade neuplnych dat EIT pro vsechny programy nevypise toto EIT ani u zadneho programu prestoze je nacten
			 //if (!loadedData.eitActualPLoaded)
			 //{
			 //	 this->listBoxEitActualP->Items->Add("Tabulka EIT pro tento multiplex nebyla nalezena");
			 //	 return;
			 //}

			 this->listBoxEitActualP->Items->Add("Tabulky EIT, PID: 0x12, ID tabulek: 0x4E");
			 this->listBoxEitActualP->Items->Add(" ");
			 //podle vybraneho programu
			 unsigned int m = 0;
			 bool displayOK = false;
			 for (m=0;m<container->EIT_ACTUAL_P.size();m++)		//prochazi vsechny programy
			 {
				 if (selectServiceFromSdt == true)
				 {
					 if (System::Convert::ToString(container->EIT_ACTUAL_P.at(m).at(0).getServiceID()) == System::Convert::ToString(container->SDT_ACTUAL.getServiceLoops().at(serviceIndex).getServiceID()))	//porovnava service ID s hodnotami v SDT_ACTUAL
					 {
						 displayOK = true;
						 displayServiceEitActualP(m);
						 break;
					 }
				 }
				 else
				 {
					 if (System::Convert::ToString(container->EIT_ACTUAL_P.at(m).at(0).getServiceID()) == System::Convert::ToString(container->PAT.getProgramNumbersWithoutNit().at(serviceIndex)))	//porovnava service ID s hodnotami v PAT
					 {
						 displayOK = true;
						 displayServiceEitActualP(m);
						 break;
					 }
				 }
			 }
			 if (!displayOK)
			 {
				 this->listBoxEitActualP->Items->Add("Tabulka EIT pro tento program byla poškozena nebo nebyla nalezena");
			 }
		 }
//zobrazi EIT_ACTUAL_P pro zvoleny program, vola funkce offsetFirstSectionEitActualP a displayEitActualPSection
private: void displayServiceEitActualP(int m)
		 {
			 this->listBoxEitActualP->Items->Add("-----------------------------------------------------------------");
			 this->listBoxEitActualP->Items->Add("Service:");
			 this->listBoxEitActualP->Items->Add(String::Concat("Service ID: ", System::Convert::ToString(container->EIT_ACTUAL_P.at(m).at(0).getServiceID())));
			 this->listBoxEitActualP->Items->Add(String::Concat("Transport stream ID: ", System::Convert::ToString(container->EIT_ACTUAL_P.at(m).at(0).getTransportStreamID())));
			 this->listBoxEitActualP->Items->Add(String::Concat("Original network ID: ", System::Convert::ToString(container->EIT_ACTUAL_P.at(m).at(0).getOriginalNetworkID())));
			 this->listBoxEitActualP->Items->Add("Events:");
			 //zde mozna jeste info o poctu obsazenych sekci

			 int positionFirstSection = offsetFirstSectionEitActualP(m/*, kontejner.EIT_ACTUAL_P.at(m).size()*/); //vraci offset 
			 for (unsigned int n=0;n<container->EIT_ACTUAL_P.at(m).size();n++)	//prochazi vsechny sekce
			 {
				 displayEitActualPSection(m, n+positionFirstSection);
				 if (n+positionFirstSection+1 == container->EIT_ACTUAL_P.at(m).size())
				 {
					 positionFirstSection = 0-n-1;
				 }
			 }
		 }
//hleda a nastavuje offset na prvni sekci - pracuje s EIT_ACTUAL_P
private: unsigned int offsetFirstSectionEitActualP(unsigned int service/*, unsigned int numbOfSection*/)
		 {
			 int temp = container->EIT_ACTUAL_P.at(service).at(0).getSectionNumber();
			 if (container->EIT_ACTUAL_P.at(service).size() == 1){return 0;}	//kdyz je tam jen jedna sekce tak vrati 0
			 unsigned int offset = 0;
			 for (unsigned int n=1;n<container->EIT_ACTUAL_P.at(service).size();n++)	//prochazeni vsech skci krome prvni (ta uz je v tempu)
			 {
				if (temp > container->EIT_ACTUAL_P.at(service).at(n).getSectionNumber()) //kdyz je mensi - uloz do tempu a zvetsi offset
				{
					temp = container->EIT_ACTUAL_P.at(service).at(n).getSectionNumber();
					offset = n;
				}
			 }
			 return offset;
		 }
//zobrazi jednu sekci EIT_ACTUAL_P
private: void displayEitActualPSection(int m, int n)
		 {
			 //m - service, n - section, j - eventa
			 for (unsigned int j=0;j<container->EIT_ACTUAL_P.at(m).at(n).getEventLoops().size();j++) //cyklus pro vypsani jedne eventy - jeden radek v EPG
			 {
				 this->listBoxEitActualP->Items->Add(String::Concat("   Event ID: ", System::Convert::ToString(container->EIT_ACTUAL_P.at(m).at(n).getEventLoops().at(j).getEventID())));
				 //prehozeno kvuli korekci data pri prechodu prez pulnoc
				 String^ oneLineEpgStartTime = timeToString(timeCorrection(container->EIT_ACTUAL_P.at(m).at(n).getEventLoops().at(j).getStartHour()),container->EIT_ACTUAL_P.at(m).at(n).getEventLoops().at(j).getStartMinute(),container->EIT_ACTUAL_P.at(m).at(n).getEventLoops().at(j).getStartSecond());
				 String^ oneLineEpgDate = dateToString(container->EIT_ACTUAL_P.at(m).at(n).getEventLoops().at(j).getStartDay()+dayCorrector,container->EIT_ACTUAL_P.at(m).at(n).getEventLoops().at(j).getStartMonth(),container->EIT_ACTUAL_P.at(m).at(n).getEventLoops().at(j).getStartYear());
				 
				 String^ oneLineEpgEventName;
				 String^ oneLineEpgShortText;
				 String^ oneLineEpgExtendedText;
				 String^ oneLineEpgExtendedTextTemp;
				 this->listBoxEitActualP->Items->Add(String::Concat("   Start date: ", oneLineEpgDate/*System::Convert::ToString(kontejner.EIT_ACTUAL_P.at(m).at(n).getEventLoops().at(j).getStartDay()),".",System::Convert::ToString(kontejner.EIT_ACTUAL_P.at(m).at(n).getEventLoops().at(j).getStartMonth()),".",System::Convert::ToString(kontejner.EIT_ACTUAL_P.at(m).at(n).getEventLoops().at(j).getStartYear())*/));
				 this->listBoxEitActualP->Items->Add(String::Concat("   Start time: ", oneLineEpgStartTime/*elementTimeToString(kontejner.EIT_ACTUAL_P.at(m).at(n).getEventLoops().at(j).getStartHour()),":",elementTimeToString(kontejner.EIT_ACTUAL_P.at(m).at(n).getEventLoops().at(j).getStartMinute()),":",elementTimeToString(kontejner.EIT_ACTUAL_P.at(m).at(n).getEventLoops().at(j).getStartSecond())*/));
				 String^ oneLineEpgDuration = timeToString(container->EIT_ACTUAL_P.at(m).at(n).getEventLoops().at(j).getDurationHour(),container->EIT_ACTUAL_P.at(m).at(n).getEventLoops().at(j).getDurationMinute(),container->EIT_ACTUAL_P.at(m).at(n).getEventLoops().at(j).getDurationSecond());
				 this->listBoxEitActualP->Items->Add(String::Concat("   Duration: ", oneLineEpgDuration/*elementTimeToString(kontejner.EIT_ACTUAL_P.at(m).at(n).getEventLoops().at(j).getDurationHour()),":",elementTimeToString(kontejner.EIT_ACTUAL_P.at(m).at(n).getEventLoops().at(j).getDurationMinute()),":",elementTimeToString(kontejner.EIT_ACTUAL_P.at(m).at(n).getEventLoops().at(j).getDurationSecond())*/));
				 this->listBoxEitActualP->Items->Add(String::Concat("   Running status: ", switchRunningStatus(container->EIT_ACTUAL_P.at(m).at(n).getEventLoops().at(j).getRunningStatus())));
				 this->listBoxEitActualP->Items->Add(String::Concat("   Free/CA mode: ", switchFreeOrCaMode(container->EIT_ACTUAL_P.at(m).at(n).getEventLoops().at(j).getFreeOrCaMode())));
				 for (unsigned int k=0;k<container->EIT_ACTUAL_P.at(m).at(n).getEventLoops().at(j).getEventLoopDescriptors().size();k++)
				 {
					 switch(container->EIT_ACTUAL_P.at(m).at(n).getEventLoops().at(j).getEventLoopDescriptors().at(k).getTag())
					 {
					 case DN_SHORT_EVENT:
						 this->listBoxEitActualP->Items->Add("   Short event descriptor:");
						 this->listBoxEitActualP->Items->Add(String::Concat("      Tag deskriptoru: ", System::Convert::ToString(container->EIT_ACTUAL_P.at(m).at(n).getEventLoops().at(j).getEventLoopDescriptors().at(k).getTag())));
						 this->listBoxEitActualP->Items->Add(String::Concat("      Kod země: ", gcnew String(container->EIT_ACTUAL_P.at(m).at(n).getEventLoops().at(j).getEventLoopDescriptors().at(k).getLanguageCode().at(0).c_str())));
						 oneLineEpgEventName = gcnew String(container->EIT_ACTUAL_P.at(m).at(n).getEventLoops().at(j).getEventLoopDescriptors().at(k).getEventName().c_str());
						 this->listBoxEitActualP->Items->Add(String::Concat("      Event name: ", oneLineEpgEventName/*gcnew String(kontejner.EIT_ACTUAL_P.at(m).at(n).getEventLoops().at(j).getEventLoopDescriptors().at(k).getEventName().c_str())*/));
						 oneLineEpgShortText = gcnew String(container->EIT_ACTUAL_P.at(m).at(n).getEventLoops().at(j).getEventLoopDescriptors().at(k).getText().c_str());
						 this->listBoxEitActualP->Items->Add(String::Concat("      Text: ", oneLineEpgShortText/*gcnew String(kontejner.EIT_ACTUAL_P.at(m).at(n).getEventLoops().at(j).getEventLoopDescriptors().at(k).getText().c_str())*/));
						 this->listBoxEitActualP->Items->Add(" ");
						 break;
					 case DN_EXTENDED_EVENT:
						 this->listBoxEitActualP->Items->Add("   Extended event descriptor:");
						 this->listBoxEitActualP->Items->Add(String::Concat("      Tag deskriptoru: ", System::Convert::ToString(container->EIT_ACTUAL_P.at(m).at(n).getEventLoops().at(j).getEventLoopDescriptors().at(k).getTag())));
						 this->listBoxEitActualP->Items->Add(String::Concat("      Číslo deskriptoru: ", System::Convert::ToString(container->EIT_ACTUAL_P.at(m).at(n).getEventLoops().at(j).getEventLoopDescriptors().at(k).getDescriptorNumber())));
						 this->listBoxEitActualP->Items->Add(String::Concat("      Číslo posledního deskriptoru: ", System::Convert::ToString(container->EIT_ACTUAL_P.at(m).at(n).getEventLoops().at(j).getEventLoopDescriptors().at(k).getLastDescriptorNumber())));
						 this->listBoxEitActualP->Items->Add(String::Concat("      Kod země: ", gcnew String(container->EIT_ACTUAL_P.at(m).at(n).getEventLoops().at(j).getEventLoopDescriptors().at(k).getLanguageCode().at(0).c_str())));
						 for (unsigned int l=0;l<container->EIT_ACTUAL_P.at(m).at(n).getEventLoops().at(j).getEventLoopDescriptors().at(k).getItemDescription().size();l++)
						 {
							 this->listBoxEitActualP->Items->Add(String::Concat("      Popis položky: ", gcnew String(container->EIT_ACTUAL_P.at(m).at(n).getEventLoops().at(j).getEventLoopDescriptors().at(k).getItemDescription().at(l).c_str())));
						 }
						 for (unsigned int l=0;l<container->EIT_ACTUAL_P.at(m).at(n).getEventLoops().at(j).getEventLoopDescriptors().at(k).getItem().size();l++)
						 {
							 this->listBoxEitActualP->Items->Add(String::Concat("      Položka: ", gcnew String(container->EIT_ACTUAL_P.at(m).at(n).getEventLoops().at(j).getEventLoopDescriptors().at(k).getItem().at(l).c_str())));
						 }
						 oneLineEpgExtendedTextTemp = String::Empty;
						 oneLineEpgExtendedTextTemp = gcnew String(container->EIT_ACTUAL_P.at(m).at(n).getEventLoops().at(j).getEventLoopDescriptors().at(k).getText().c_str());
						 this->listBoxEitActualP->Items->Add(String::Concat("      Text: ", oneLineEpgExtendedTextTemp/*gcnew String(kontejner.EIT_ACTUAL_P.at(m).at(n).getEventLoops().at(j).getEventLoopDescriptors().at(k).getText().c_str())*/));
						 oneLineEpgExtendedText = String::Concat(oneLineEpgExtendedText,oneLineEpgExtendedTextTemp);
						 this->listBoxEitActualP->Items->Add(" ");
						 break;
					case DN_COMPONENT:
						 this->listBoxEitActualP->Items->Add("   Component descriptor:");
						 this->listBoxEitActualP->Items->Add(String::Concat("      Tag deskriptoru: ", System::Convert::ToString(container->EIT_ACTUAL_P.at(m).at(n).getEventLoops().at(j).getEventLoopDescriptors().at(k).getTag())));
						 this->listBoxEitActualP->Items->Add(String::Concat("      Obsah streamu: ", switchContentComponent(container->EIT_ACTUAL_P.at(m).at(n).getEventLoops().at(j).getEventLoopDescriptors().at(k).getStreamContent(),container->EIT_ACTUAL_P.at(m).at(n).getEventLoops().at(j).getEventLoopDescriptors().at(k).getComponentType())));
						 this->listBoxEitActualP->Items->Add(String::Concat("      Komponenta: ", switchComponentTag(container->EIT_ACTUAL_P.at(m).at(n).getEventLoops().at(j).getEventLoopDescriptors().at(k).getComponentTag())));
						 this->listBoxEitActualP->Items->Add(String::Concat("      Kod země: ", gcnew String(container->EIT_ACTUAL_P.at(m).at(n).getEventLoops().at(j).getEventLoopDescriptors().at(k).getLanguageCode().at(0).c_str())));
						 this->listBoxEitActualP->Items->Add(String::Concat("      Text: ", gcnew String(container->EIT_ACTUAL_P.at(m).at(n).getEventLoops().at(j).getEventLoopDescriptors().at(k).getText().c_str())));
						 this->listBoxEitActualP->Items->Add(" ");
						 break;
					case DN_CONTENT:
						 this->listBoxEitActualP->Items->Add("   Content descriptor:");
						 this->listBoxEitActualP->Items->Add(String::Concat("      Tag deskriptoru: ", System::Convert::ToString(container->EIT_ACTUAL_P.at(m).at(n).getEventLoops().at(j).getEventLoopDescriptors().at(k).getTag())));
						 for (unsigned int l=0;l<container->EIT_ACTUAL_P.at(m).at(n).getEventLoops().at(j).getEventLoopDescriptors().at(k).getContentNible1().size();l++)
						 {
							 this->listBoxEitActualP->Items->Add(String::Concat("      Obsah: ", switchContentNibles(container->EIT_ACTUAL_P.at(m).at(n).getEventLoops().at(j).getEventLoopDescriptors().at(k).getContentNible1().at(l),container->EIT_ACTUAL_P.at(m).at(n).getEventLoops().at(j).getEventLoopDescriptors().at(k).getContentNible2().at(l))));
							 this->listBoxEitActualP->Items->Add(String::Concat("      Uživatelský bajt: ", System::Convert::ToString(container->EIT_ACTUAL_P.at(m).at(n).getEventLoops().at(j).getEventLoopDescriptors().at(k).getUserByte().at(l))));
						 }
						 this->listBoxEitActualP->Items->Add(" ");
						 break;
					 default:
						 this->listBoxEitActualP->Items->Add("   Neznamy descriptor:");
						 this->listBoxEitActualP->Items->Add(String::Concat("      Tag deskriptoru: ", System::Convert::ToString(container->EIT_ACTUAL_P.at(m).at(n).getEventLoops().at(j).getEventLoopDescriptors().at(k).getTag())));
						 //this->listBoxEitActualP->Items->Add(String::Concat("    Data deskriptoru: ", gcnew String(kontejner.EIT_ACTUAL_P.at(m).at(n).getEventLoopDescriptors().at(j).getRawData().c_str())));
						 this->listBoxEitActualP->Items->Add(" ");
					 }
				 }
				 //na konci cyklu vypsani jedne eventy mam naplnene vsechy veci z teto eveny, spojim je a vypisu jeden radek v EPG
				 this->listBoxEitActualEpg->Items->Add(String::Concat(oneLineEpgDate," ",oneLineEpgStartTime," ", oneLineEpgEventName," (",oneLineEpgDuration,") ", oneLineEpgShortText, oneLineEpgExtendedText));
			 }
		 }

//pri zmene vyberu programu se nastavi vybrany index a volaji se funkce pro zobrazovani s parametrem vybraneho indexu - pracuje s EIT_OTHER_P a EIT_OTHER_S 
private: System::Void EitOtherServiceChange(System::Object^  sender, System::EventArgs^  e)
		 {
			 displayEitOtherP(comboBoxEitOther->SelectedIndex);
			 displayEitOtherS(comboBoxEitOther->SelectedIndex);
		 }

//zobrazi tabulku eitOtherP vybraneho programu podle serviceIndexu - pracuje s EIT_OTHER_P
private: void displayEitOtherP(int serviceIndex)
		 {
			 this->listBoxEitOtherP->Items->Clear();
			 if (!loadedData->eitOtherPLoaded)
			 {
				 this->listBoxEitOtherP->Items->Add("Tabulka EIT pro jiny multiplex nebyla nalezena");
				 return;
			 }
			 this->listBoxEitOtherP->Items->Add("Tabulka EIT, PID: 0x12, ID tabulky: 0x4F");
			 this->listBoxEitOtherP->Items->Add(" ");
		 }

//zobrazi tabulku eitActualS vybraneho programu podle serviceIndexu - pracuje s EIT_ACTUAL_S
private: void displayEitActualS(int serviceIndex)
		 {
			//this->listBoxEitActualEpg->Items->Clear(); - nesmi tu byt jinak maze udaje s aktualniho vysilani

			//tato zakomentovana podminka zpusobila ze se v pripade neuplnych dat EPG nevypise toto EPG u zadneho programu ani u tech u kterych je nacten
			//if (!loadedData.eitActualSLoaded)
			//{
			//	 this->listBoxEitActualEpg->Items->Add("Tabulka EIT s plánovaným vysílaním pro tento multiplex nebyla nalezena");
			//	 return;
			//}

			 this->listBoxEitActualEpg->Items->Add(" ");
			 this->listBoxEitActualEpg->Items->Add("Tabulka EIT s plánovaným vysílaním, PID: 0x12, ID tabulky: 0x50 - 0x5F");
			 //podle vybraneho programu
			 unsigned int m = 0;
			 bool displayOK = false;
			 for (m=0;m<container->EIT_ACTUAL_S.size();m++)		//prochazi vsechny programy
			 {
				 if (selectServiceFromSdt == true)
				 {
					 if (System::Convert::ToString(container->EIT_ACTUAL_S.at(m).at(0).at(0).getServiceID()) == System::Convert::ToString(container->SDT_ACTUAL.getServiceLoops().at(serviceIndex).getServiceID()))	//porovnava service ID s hodnotami v SDT_ACTUAL
					 {
						 displayOK = true;
						 displayServiceEitActualS(m);
						 break;
					 }
				 }
				 else
				 {
					 if (System::Convert::ToString(container->EIT_ACTUAL_S.at(m).at(0).at(0).getServiceID()) == System::Convert::ToString(container->PAT.getProgramNumbersWithoutNit().at(serviceIndex)))	//porovnava service ID s hodnotami v PAT
					 {
						 displayOK = true;
						 displayServiceEitActualS(m);
						 break;
					 }
				 }
			 }
			 if (!displayOK)
			 {
				 this->listBoxEitActualEpg->Items->Add("Tabulka EIT s plánovaným vysílaním pro tento program byla poškozena nebo nebyla nalezena");
			 }
		 }
//zobrazi EIT_ACTUAL_S (EPG) vybraneho programu m - vola nize uveden funkce 
private: void displayServiceEitActualS(int m)
		 {
			 //musi se vybrat spravny vektor s nejnizsim table ID
			 int positionFirstTableID = offsetFirstTableIDEitActualS(m); //vraci offset 
			 for (unsigned int n=0;n<container->EIT_ACTUAL_S.at(m).size();n++)	//prochazi vsechny tabulky
			 {
				 displayEitActualSTable(m, n+positionFirstTableID);		//zavolat funkci pro výpis jedne table ID
				 if (n+positionFirstTableID+1 == container->EIT_ACTUAL_S.at(m).size())
				 {
					 positionFirstTableID = 0-n-1;
				 }
			 }
		 }
//hleda a nastavuje offset na prvni tabulku podle table ID - pracuje s EIT_ACTUAL_P
private: unsigned int offsetFirstTableIDEitActualS(unsigned int service)
		 {
			 int temp = container->EIT_ACTUAL_S.at(service).at(0).at(0).getTableId();
			 if (container->EIT_ACTUAL_S.at(service).size() == 1){return 0;}	//je tam jen jedna tabulka
			 unsigned int offset = 0;
			 for (unsigned int n=1;n<container->EIT_ACTUAL_S.at(service).size();n++)
			 {
				 if (temp > container->EIT_ACTUAL_S.at(service).at(n).at(0).getTableId()) //kdyz je mensi - uloz do tempu a zvetsi offset
				 {
					 temp = container->EIT_ACTUAL_S.at(service).at(n).at(0).getTableId();
					 offset = n;
				 }
			 }
			 return offset;
		 }
//vola funkce pro zobrazovani prvni tabulky
private: void displayEitActualSTable(int m, int n)
		 {
			 //musi se vybrat spravny vektor section v danem programu m a v dane table n
			 int positionFirstSectionEitActualS = offsetFirstSectionEitActualS(m, n); //vraci offset 
			 for (unsigned int j=0;j<container->EIT_ACTUAL_S.at(m).at(n).size();j++)	//prochazi vsechny section jedne tabulky
			 {
				 displayEitActualSSection(m, n, j+positionFirstSectionEitActualS);		//zavolat funkci pro výpis jedne table ID
				 if (j+positionFirstSectionEitActualS+1 == container->EIT_ACTUAL_S.at(m).at(n).size())
				 {
					 positionFirstSectionEitActualS = 0-j-1;
				 }
			 }
		 }
//hleda a nastavuje offset na prvni sectin v programu m a tabulce n, vola seřazene sekce
private: unsigned int offsetFirstSectionEitActualS(unsigned int service, unsigned int tableID)
		 {
			 int temp = container->EIT_ACTUAL_S.at(service).at(tableID).at(0).getSectionNumber();
			 if (container->EIT_ACTUAL_S.at(service).at(tableID).size() == 1){return 0;}	//je tam jen jedna tabulka
			 unsigned int offset = 0;
			 for (unsigned int j=1;j<container->EIT_ACTUAL_S.at(service).at(tableID).size();j++)
			 {
				 if (temp > container->EIT_ACTUAL_S.at(service).at(tableID).at(j).getSectionNumber()) //kdyz je mensi - uloz do tempu a zvetsi offset
				 {
					 temp = container->EIT_ACTUAL_S.at(service).at(tableID).at(j).getSectionNumber();
					 offset = j;
				 }
			 }
			 return offset;
		 }
//zobrazuje jednu sekci eit programu m tabulky n sekci j - vypisuje vsechny eventy teto sekce
private: void displayEitActualSSection(int m, int n, int j)
		 {
			 for (unsigned int k=0;k<container->EIT_ACTUAL_S.at(m).at(n).at(j).getEventLoops().size();k++)	//cyklus pro vypsani jedne eventy
			 {
				 //prehozeno kvuli korekci data pri prechodu prez pulnoc
				 String^ oneLineEpgStartTime = timeToString(timeCorrection(container->EIT_ACTUAL_S.at(m).at(n).at(j).getEventLoops().at(k).getStartHour()),container->EIT_ACTUAL_S.at(m).at(n).at(j).getEventLoops().at(k).getStartMinute(),container->EIT_ACTUAL_S.at(m).at(n).at(j).getEventLoops().at(k).getStartSecond());
				 String^ oneLineEpgDate = dateToString(container->EIT_ACTUAL_S.at(m).at(n).at(j).getEventLoops().at(k).getStartDay()+dayCorrector,container->EIT_ACTUAL_S.at(m).at(n).at(j).getEventLoops().at(k).getStartMonth(),container->EIT_ACTUAL_S.at(m).at(n).at(j).getEventLoops().at(k).getStartYear());

				 String^ oneLineEpgDuration = timeToString(container->EIT_ACTUAL_S.at(m).at(n).at(j).getEventLoops().at(k).getDurationHour(),container->EIT_ACTUAL_S.at(m).at(n).at(j).getEventLoops().at(k).getDurationMinute(),container->EIT_ACTUAL_S.at(m).at(n).at(j).getEventLoops().at(k).getDurationSecond());
				 String^ oneLineEpgEventName;
				 oneLineEpgEventName = String::Empty;
				 String^ oneLineEpgShortText;
				 oneLineEpgShortText = String::Empty;
				 String^ oneLineEpgExtendedText;
				 oneLineEpgExtendedText = String::Empty;
				 for (unsigned int l=0;l<container->EIT_ACTUAL_S.at(m).at(n).at(j).getEventLoops().at(k).getEventLoopDescriptors().size();l++)	//cyklus pro vypsani jednoho deskriptoru
				 {
					 switch(container->EIT_ACTUAL_S.at(m).at(n).at(j).getEventLoops().at(k).getEventLoopDescriptors().at(l).getTag())
					 {
					 case DN_SHORT_EVENT:
						 oneLineEpgEventName = gcnew String(container->EIT_ACTUAL_S.at(m).at(n).at(j).getEventLoops().at(k).getEventLoopDescriptors().at(l).getEventName().c_str());
						 oneLineEpgShortText = gcnew String(container->EIT_ACTUAL_S.at(m).at(n).at(j).getEventLoops().at(k).getEventLoopDescriptors().at(l).getText().c_str());
						 break;
					 case DN_EXTENDED_EVENT:
						 oneLineEpgExtendedText = String::Concat(oneLineEpgExtendedText, gcnew String(container->EIT_ACTUAL_S.at(m).at(n).at(j).getEventLoops().at(k).getEventLoopDescriptors().at(l).getText().c_str()));
						 break;
					 case DN_CONTENT:
						 //kod
						 break;
					 default:
						 //ostatni deskriptory se nevypisuji - nedela se nic
						 break;
					 }
				 }
				 //na konci cyklu vypsani jedne eventy mam naplnene vsechy veci z teto eveny, spojim je a vypisu jeden radek v EPG
				 this->listBoxEitActualEpg->Items->Add(String::Concat(oneLineEpgDate," ",oneLineEpgStartTime," ", oneLineEpgEventName,/*content,*/" (",oneLineEpgDuration,") ", oneLineEpgShortText, oneLineEpgExtendedText));
			 }
		 }

//zobrazi tabulku eitOtherS vybraneho programu podle serviceIndexu - pracuje s EIT_OTHER_S
private: void displayEitOtherS(int serviceIndex)
		 {
			 //this->listBoxEitActualEpg->Items->Clear(); - nesmi tu byt jinak maze udaje s aktualniho vysilani
			 if (!loadedData->eitOtherSLoaded)
			 {
				 this->listBoxEitOtherEpg->Items->Add("Tabulka EIT s plánovaným vysílaním pro jiný multiplex nebyla nalezena");
				 return;
			 }
			 this->listBoxEitOtherEpg->Items->Add(" ");
			 this->listBoxEitOtherEpg->Items->Add("Tabulka EIT s plánovaným vysílaním, PID: 0x12, ID tabulky: 0x60 - 0x6F");
		 }

//zobrazi tabulku tdt a tot - pracuje s TDT a TOT
private: void displayTdtTot()
		 {
			 this->listBoxTdtTot->Items->Clear();
			 //TOT
			 if (!loadedData->totLoaded)
			 {
				 this->listBoxTdtTot->Items->Add("Tabulka TOT nebyla nalezena");
				 return;
			 }
			 this->listBoxTdtTot->Items->Add("----------------------------------------------------------------------------------------------------------------------------------");
			 this->listBoxTdtTot->Items->Add("Tabulka TOT, PID: 0x14, ID tabulky: 0x73");
			 this->listBoxTdtTot->Items->Add(" ");
			 this->listBoxTdtTot->Items->Add(String::Concat("Datum: ", System::Convert::ToString(container->TOT.getDay()),".",System::Convert::ToString(container->TOT.getMonth()),".",System::Convert::ToString(container->TOT.getYear())));
			 this->listBoxTdtTot->Items->Add(String::Concat("UTC čas: ", elementTimeToString(container->TOT.getHour()),":",elementTimeToString(container->TOT.getMinute()),":",elementTimeToString(container->TOT.getSecond())));
			 displayTotDescriptors();

			 //TDT - je zde vypisovan az po vypsani TOT kvuli inicializaci korekce casu
			 this->listBoxTdtTot->Items->Insert(0," ");
			 if (!loadedData->tdtLoaded)
			 {
				 this->listBoxTdtTot->Items->Insert(0,"Tabulka TDT nebyla nalezena");
			 }
			 else
			 {
				 this->listBoxTdtTot->Items->Insert(0,String::Concat("Aktuální čas: ", elementTimeToString(timeCorrection(container->TDT.getHour())),":",elementTimeToString(container->TDT.getMinute()),":",elementTimeToString(container->TDT.getSecond())));
				 this->listBoxTdtTot->Items->Insert(0,String::Concat("Den v týdnu: ", switchDayOfWeek(container->TDT.getDayOfWeek())));
				 this->listBoxTdtTot->Items->Insert(0,String::Concat("Datum: ", System::Convert::ToString(container->TDT.getDay()+dayCorrector),".",System::Convert::ToString(container->TDT.getMonth()),".",System::Convert::ToString(container->TDT.getYear())));
				 this->listBoxTdtTot->Items->Insert(0," ");
				 this->listBoxTdtTot->Items->Insert(0,"Tabulka TDT, PID: 0x14, ID tabulky: 0x70");			 
			 }
		 }
private: int hourTimeOffset;
private: void displayTotDescriptors()
		 {
			 for (unsigned int m=0;m<container->TOT.getTotDescriptors().size();m++)
			 {
				 if (container->TOT.getTotDescriptors().at(m).getTag() == DN_LOCAL_TIME_OFFSET)
				 {
					 this->listBoxTdtTot->Items->Add("-----------------------------------------------------------------");
					 this->listBoxTdtTot->Items->Add("Local time offset descriptor:");
					 this->listBoxTdtTot->Items->Add(String::Concat("   Tag deskriptoru: ", System::Convert::ToString(container->TOT.getTotDescriptors().at(m).getTag())));
					 for (unsigned int n=0;n<container->TOT.getTotDescriptors().at(m).getCountryLoops().size();n++)
					 {
						 this->listBoxTdtTot->Items->Add(String::Concat("   Kod země: ", gcnew String(container->TOT.getTotDescriptors().at(m).getCountryLoops().at(n).languageCode.c_str())));
						 if (container->TOT.getTotDescriptors().at(m).getCountryLoops().at(n).countryRegionId == 0){this->listBoxTdtTot->Items->Add("   Číslo časové zóny (v rámci státu): časové zóny nejsou použity");} 
						 else{this->listBoxTdtTot->Items->Add(String::Concat("   Číslo časové zóny: ", System::Convert::ToString(container->TOT.getTotDescriptors().at(m).getCountryLoops().at(n).countryRegionId)));}
						 this->listBoxTdtTot->Items->Add("   Polarita offsetu od UTC času: " + boolToTimeOffsetPolarity(container->TOT.getTotDescriptors().at(m).getCountryLoops().at(n).localTimeOffsetPolarity));
						 this->listBoxTdtTot->Items->Add("   Místní časový posun: " + elementTimeToString(container->TOT.getTotDescriptors().at(m).getCountryLoops().at(n).localTimeOffsetHour) + ":" + elementTimeToString(container->TOT.getTotDescriptors().at(m).getCountryLoops().at(n).localTimeOffsetMinute) + ":0");
						 hourTimeOffset = calculateTimeOffset(container->TOT.getTotDescriptors().at(m).getCountryLoops().at(n).localTimeOffsetPolarity, container->TOT.getTotDescriptors().at(m).getCountryLoops().at(n).localTimeOffsetHour);

						 String^ dateChange;
						 String^ timeBeforeChange;
						 String^ timeAfterChange;
						 dateChange = String::Concat(System::Convert::ToString(container->TOT.getTotDescriptors().at(m).getCountryLoops().at(n).TimeToChangeDay),".",System::Convert::ToString(container->TOT.getTotDescriptors().at(m).getCountryLoops().at(n).TimeToChangeMonth),".",System::Convert::ToString(container->TOT.getTotDescriptors().at(m).getCountryLoops().at(n).TimeToChangeYear));
						 timeBeforeChange = String::Concat(elementTimeToString(container->TOT.getTotDescriptors().at(m).getCountryLoops().at(n).TimeToChangeHour+hourTimeOffset),":",elementTimeToString(container->TOT.getTotDescriptors().at(m).getCountryLoops().at(n).TimeToChangeMinute),":",elementTimeToString(container->TOT.getTotDescriptors().at(m).getCountryLoops().at(n).TimeToChangeSecond));
						 timeAfterChange = elementTimeToString(calculateTimeOffset(container->TOT.getTotDescriptors().at(m).getCountryLoops().at(n).localTimeOffsetPolarity, container->TOT.getTotDescriptors().at(m).getCountryLoops().at(n).nextTimeOffsetHour+1/*hourTimeOffset*/)) + ":" + elementTimeToString(container->TOT.getTotDescriptors().at(m).getCountryLoops().at(n).nextTimeOffsetMinute) + ":0";
						 this->listBoxTdtTot->Items->Add("   Změna času: " + dateChange + "  " + timeBeforeChange + " => " + timeAfterChange);
					 }
				 } 
				 else
				 {
					 this->listBoxTdtTot->Items->Add("-----------------------------------------------------------------");
					 this->listBoxTdtTot->Items->Add("Neznamy descriptor:");
					 this->listBoxTdtTot->Items->Add(String::Concat("  Tag deskriptoru: ", System::Convert::ToString(container->TOT.getTotDescriptors().at(m).getTag())));
					 this->listBoxTdtTot->Items->Add(String::Concat("  Data deskriptoru: ", gcnew String(container->TOT.getTotDescriptors().at(m).getRawData().c_str())));
					 this->listBoxTdtTot->Items->Add(" ");
				 }
			 }
		 }
private: int calculateTimeOffset(bool polarity, int offsetHour)
		 {
			 int timeOffset, sign;
			 if (polarity){sign = -1;}
			 else{sign = 1;}
			 return timeOffset = sign*offsetHour;
		 }
private: int dayCorrector;
private: int timeCorrection(int uncorrectTime)
		 {
			 int correctTime = uncorrectTime + hourTimeOffset;
			 dayCorrector = 0;
			 if (correctTime > 0x23)
			 {
				 correctTime = correctTime - 0x24;
				 dayCorrector = 1;
			 }
			 return correctTime;
		 }

//funkce prevodu tabulkovych hodnot na stringy
private: String^ boolToUsed(bool boolInput)
			{
				String^ stringOutput;
				if (boolInput)
				{
					return stringOutput = "used";
				}
				return stringOutput = "not used";
			}
private: String^ boolToTimeOffsetPolarity(bool boolInput)
			{
				String^ res;

				if (boolInput){res = "místní časový posun se odečítá od UTC času";} 
				else{res = "místní časový posun se přičítá k UTC času";}
				return res;
			}
private: String^ dateToString(int day, int month, int year)
			{
				String^ date = String::Concat(System::Convert::ToString(day),".",System::Convert::ToString(month),".",System::Convert::ToString(year));
				return date;
			}
private: String^ timeToString(int hour, int minute, int second)
			{
				String^ time = String::Concat(elementTimeToString(hour),":",elementTimeToString(minute),":",elementTimeToString(second));
				return time;
			}
private: String^ elementTimeToString(int timeData)
			{
				String^ stringTimeData;
				int temp = int(timeData/16)*10;
				temp = temp+(timeData-16*temp/10);
				stringTimeData = System::Convert::ToString(temp);
				return stringTimeData;
			}
private: String^ switchTeletextType(int teletextType)
			{
				String^ stringTeletextType;
				switch (teletextType)
				{
				case 0x01:
					return stringTeletextType = "initial Teletext page";
					break;
				case 0x02:
					return stringTeletextType = "Teletext subtitle page";
					break;
				case 0x03:
					return stringTeletextType = "additional information page";
					break;
				case 0x04:
					return stringTeletextType = "programme schedule page";
					break;
				case 0x05:
					return stringTeletextType = "Teletext subtitle page for hearing impaired people";
					break;
				default:
					return stringTeletextType = "neplatna hodnota";
				}
			}
private: String^ switchStreamType(int streamType)
			{
				String^ stringStreamType;
				switch (streamType)
				{
				case 0x01:
					return stringStreamType = "MPEG-1 video";
					break;
				case 0x02:
					return stringStreamType = "MPEG-2 video";
					break;
				case 0x03:
					return stringStreamType = "MPEG-1 audio";
					break;
				case 0x04:
					return stringStreamType = "MPEG-2 audio";
					break;
				case 0x05:
					return stringStreamType = "private sections";
					break;
				case 0x06:
					return stringStreamType = "PES packets containing private data";
					break;
				case 0x07:
					return stringStreamType = "MHEG";
					break;
				case 0x08:
					return stringStreamType = "DSM-CC";
					break;
				case 0x09:
					return stringStreamType = "ITU-T H.222.1";
					break;
				case 0x0A:
					return stringStreamType = "DSM-CC type A";
					break;
				case 0x0B:
					return stringStreamType = "DSM-CC type B";
					break;
				case 0x0C:
					return stringStreamType = "DSM-CC type C";
					break;
				case 0x0D:
					return stringStreamType = "DSM-CC type D";
					break;
				case 0x0E:
					return stringStreamType = "auxiliary";
					break;
				default:
					return stringStreamType = "neplatna hodnota";
				}
			}
private: String^ switchContentNibles(int contentNible1, int contentNible2)
			{
				String^ stringContentNibles;
				switch(contentNible1)
				{
				case 0x00:
					return stringContentNibles = "undefined content\n";
					break;
				case 0x01:
					switch(contentNible2)
					{
					case 0x00:
						return stringContentNibles = "movie/drama (general)\n";
						break;
					case 0x01:
						return stringContentNibles = "detective/thriller\n";
						break;
					case 0x02:
						return stringContentNibles = "adventure/western/war\n";
						break;
					case 0x03:
						return stringContentNibles = "science fiction/fantasy/horror\n";
						break;
					case 0x04:
						return stringContentNibles = "comedy\n";
						break;
					case 0x05:
						return stringContentNibles = "soap/melodrama/folkloric\n";
						break;
					case 0x06:
						return stringContentNibles = "romance\n";
						break;
					case 0x07:
						return stringContentNibles = "serious/classical/religious/historical movie/drama\n";
						break;
					case 0x08:
						return stringContentNibles = "adult movie/drama\n";
						break;
					default:
						return stringContentNibles = "unknown\n";
					}
					break;
				case 0x02:
					switch(contentNible2)
					{
					case 0x00:
						return stringContentNibles = "news/current affairs (general)\n";
						break;
					case 0x01:
						return stringContentNibles = "news/weather report\n";
						break;
					case 0x02:
						return stringContentNibles = "news magazine\n";
						break;
					case 0x03:
						return stringContentNibles = "documentary\n";
						break;
					case 0x04:
						return stringContentNibles = "discussion/interview/debate\n";
						break;
					default:
						return stringContentNibles = "unknown\n";
					}
					break;
				case 0x03:
					switch(contentNible2)
					{
					case 0x00:
						return stringContentNibles = "show/game show (general)\n";
						break;
					case 0x01:
						return stringContentNibles = "game show/quiz/contest\n";
						break;
					case 0x02:
						return stringContentNibles = "variety show\n";
						break;
					case 0x03:
						return stringContentNibles = "talk show\n";
						break;
					default:
						return stringContentNibles = "unknown\n";
					}
					break;
				case 0x04:
					switch(contentNible2)
					{
					case 0x00:
						return stringContentNibles = "sports (general)\n";
						break;
					case 0x01:
						return stringContentNibles = "special events (Olympic Games, World Cup, etc.)\n";
						break;
					case 0x02:
						return stringContentNibles = "sports magazines\n";
						break;
					case 0x03:
						return stringContentNibles = "football/soccer\n";
						break;
					case 0x04:
						return stringContentNibles = "tennis/squash\n";
						break;
					case 0x05:
						return stringContentNibles = "team sports (excluding football)\n";
						break;
					case 0x06:
						return stringContentNibles = "athletics\n";
						break;
					case 0x07:
						return stringContentNibles = "motor sport\n";
						break;
					case 0x08:
						return stringContentNibles = "water sport\n";
						break;
					case 0x09:
						return stringContentNibles = "winter sports\n";
						break;
					case 0x0A:
						return stringContentNibles = "equestrian\n";
						break;
					case 0x0B:
						return stringContentNibles = "martial sports\n";
						break;
					default:
						return stringContentNibles = "unknown\n";
					}
					break;
				case 0x05:
					switch(contentNible2)
					{
					case 0x00:
						return stringContentNibles = "children's/youth programmes (general)\n";
						break;
					case 0x01:
						return stringContentNibles = "pre-school children's programmes\n";
						break;
					case 0x02:
						return stringContentNibles = "entertainment programmes for 6 to 14\n";
						break;
					case 0x03:
						return stringContentNibles = "entertainment programmes for 10 to 16\n";
						break;
					case 0x04:
						return stringContentNibles = "informational/educational/school programmes\n";
						break;
					case 0x05:
						return stringContentNibles = "cartoons/puppets\n";
						break;
					default:
						return stringContentNibles = "unknown\n";
					}
					break;
				case 0x06:
					switch(contentNible2)
					{
					case 0x00:
						return stringContentNibles = "music/ballet/dance (general)\n";
						break;
					case 0x01:
						return stringContentNibles = "rock/pop\n";
						break;
					case 0x02:
						return stringContentNibles = "serious music/classical music\n";
						break;
					case 0x03:
						return stringContentNibles = "folk/traditional music\n";
						break;
					case 0x04:
						return stringContentNibles = "jazz\n";
						break;
					case 0x05:
						return stringContentNibles = "musical/opera\n";
						break;
					case 0x06:
						return stringContentNibles = "ballet\n";
						break;
					default:
						return stringContentNibles = "unknown\n";
					}
					break;
				case 0x07:
					switch(contentNible2)
					{
					case 0x00:
						return stringContentNibles = "arts/culture (without music, general)\n";
						break;
					case 0x01:
						return stringContentNibles = "performing arts\n";
						break;
					case 0x02:
						return stringContentNibles = "fine arts\n";
						break;
					case 0x03:
						return stringContentNibles = "religion\n";
						break;
					case 0x04:
						return stringContentNibles = "popular culture/traditional arts\n";
						break;
					case 0x05:
						return stringContentNibles = "literature\n";
						break;
					case 0x06:
						return stringContentNibles = "film/cinema\n";
						break;
					case 0x07:
						return stringContentNibles = "experimental film/video\n";
						break;
					case 0x08:
						return stringContentNibles = "broadcasting/press\n";
						break;
					case 0x09:
						return stringContentNibles = "new media\n";
						break;
					case 0x0A:
						return stringContentNibles = "arts/culture magazines\n";
						break;
					case 0x0B:
						return stringContentNibles = "fashion\n";
						break;
					default:
						return stringContentNibles = "unknown\n";
					}
					break;
				case 0x08:
					switch(contentNible2)
					{
					case 0x00:
						return stringContentNibles = "social/political issues/economics (general)\n";
						break;
					case 0x01:
						return stringContentNibles = "magazines/reports/documentary\n";
						break;
					case 0x02:
						return stringContentNibles = "economics/social advisory\n";
						break;
					case 0x03:
						return stringContentNibles = "remarkable people\n";
						break;
					default:
						return stringContentNibles = "unknown\n";
					}
					break;
				case 0x09:
					switch(contentNible2)
					{
					case 0x00:
						return stringContentNibles = "education/science/factual topics (general)\n";
						break;
					case 0x01:
						return stringContentNibles = "nature/animals/environment\n";
						break;
					case 0x02:
						return stringContentNibles = "technology/natural sciences\n";
						break;
					case 0x03:
						return stringContentNibles = "medicine/physiology/psychology\n";
						break;
					case 0x04:
						return stringContentNibles = "foreign countries/expeditions\n";
						break;
					case 0x05:
						return stringContentNibles = "social/spiritual sciences\n";
						break;
					case 0x06:
						return stringContentNibles = "further education\n";
						break;
					case 0x07:
						return stringContentNibles = "languages\n";
						break;
					default:
						return stringContentNibles = "unknown\n";
					}
					break;
				case 0x0A:
					switch(contentNible2)
					{
					case 0x00:
						return stringContentNibles = "leisure hobbies (general)\n";
						break;
					case 0x01:
						return stringContentNibles = "tourism/travel\n";
						break;
					case 0x02:
						return stringContentNibles = "handicraft\n";
						break;
					case 0x03:
						return stringContentNibles = "motoring\n";
						break;
					case 0x04:
						return stringContentNibles = "fitness and health\n";
						break;
					case 0x05:
						return stringContentNibles = "cooking\n";
						break;
					case 0x06:
						return stringContentNibles = "advertisement/shopping\n";
						break;
					case 0x07:
						return stringContentNibles = "gardening\n";
						break;
					default:
						return stringContentNibles = "unknown\n";
					}
					break;
				case 0x0B:
					switch(contentNible2)
					{
					case 0x00:
						return stringContentNibles = "original language\n";
						break;
					case 0x01:
						return stringContentNibles = "black and white\n";
						break;
					case 0x02:
						return stringContentNibles = "unpublished\n";
						break;
					case 0x03:
						return stringContentNibles = "live broadcast\n";
						break;
					case 0x04:
						return stringContentNibles = "plano-stereoscopic\n";
						break;
					case 0x05:
						return stringContentNibles = "local or regional\n";
						break;
					default:
						return stringContentNibles = "unknown\n";
					}
					break;
				default:
					return stringContentNibles = "unknown\n";	
				}
			}
private: String^ switchContentComponent(int streamContent, int componentType)
			{
				String^ stringContentComponent;
				switch(streamContent)
				{
				case 0x01:
					switch(componentType)
					{
					case 0x01:
						return stringContentComponent = "MPEG-2 video, 4:3 aspect ratio, 25 Hz\n";
						break;
					case 0x02:
						return stringContentComponent = "MPEG-2 video, 16:9 aspect ratio with pan vectors, 25 Hz\n";
						break;
					case 0x03:
						return stringContentComponent = "MPEG-2 video, 16:9 aspect ratio without pan vectors, 25 Hz\n";
						break;
					case 0x04:
						return stringContentComponent = "MPEG-2 video, > 16:9 aspect ratio, 25 Hz\n";
						break;
					case 0x05:
						return stringContentComponent = "MPEG-2 video, 4:3 aspect ratio, 30 Hz\n";
						break;
					case 0x06:
						return stringContentComponent = "MPEG-2 video, 16:9 aspect ratio with pan vectors, 30 Hz\n";
						break;
					case 0x07:
						return stringContentComponent = "MPEG-2 video, 16:9 aspect ratio without pan vectors, 30 Hz\n";
						break;
					case 0x08:
						return stringContentComponent = "MPEG-2 video, > 16:9 aspect ratio, 30 Hz\n";
						break;
					case 0x09:
						return stringContentComponent = "MPEG-2 high definition video, 4:3 aspect ratio, 25 Hz\n";
						break;
					case 0x0A:
						return stringContentComponent = "MPEG-2 high definition video, 16:9 aspect ratio with pan vectors, 25 Hz\n";
						break;
					case 0x0B:
						return stringContentComponent = "MPEG-2 high definition video, 16:9 aspect ratio without pan vectors, 25 Hz\n";
						break;
					case 0x0C:
						return stringContentComponent = "MPEG-2 high definition video, > 16:9 aspect ratio, 25 Hz\n";
						break;
					case 0x0D:
						return stringContentComponent = "MPEG-2 high definition video, 4:3 aspect ratio, 30 Hz\n";
						break;
					case 0x0E:
						return stringContentComponent = "MPEG-2 high definition video, 16:9 aspect ratio with pan vectors, 30 Hz\n";
						break;
					case 0x0F:
						return stringContentComponent = "MPEG-2 high definition video, 16:9 aspect ratio without pan vectors, 30 Hz\n";
						break;
					case 0x10:
						return stringContentComponent = "MPEG-2 high definition video, > 16:9 aspect ratio, 30 Hz\n";
						break;
					default:
						return stringContentComponent = "unknown\n";
					}
					break;
				case 0x02:
					switch(componentType)
					{
					case 0x01:
						return stringContentComponent = "MPEG-1 Layer 2 audio, single mono channel\n";
						break;
					case 0x02:
						return stringContentComponent = "MPEG-1 Layer 2 audio, dual mono channel\n";
						break;
					case 0x03:
						return stringContentComponent = "MPEG-1 Layer 2 audio, stereo (2 channel)\n";
						break;
					case 0x04:
						return stringContentComponent = "MPEG-1 Layer 2 audio, multi-lingual, multi-channel\n";
						break;
					case 0x05:
						return stringContentComponent = "MPEG-1 Layer 2 audio, surround sound\n";
						break;
					case 0x40:
						return stringContentComponent = "MPEG-1 Layer 2 audio description for the visually impaired\n";
						break;
					case 0x41:
						return stringContentComponent = "MPEG-1 Layer 2 audio for the hard of hearing\n";
						break;
					case 0x42:
						return stringContentComponent = "receiver-mixed supplementary audio as per annex E of TS 101 154 [9]\n";
						break;
					case 0x47:
						return stringContentComponent = "MPEG-1 Layer 2 audio, receiver mix audio description\n";
						break;
					case 0x48:
						return stringContentComponent = "MPEG-1 Layer 2 audio, broadcaster mix audio description\n";
						break;
					default:
						return stringContentComponent = "unknown\n";
					}
					break;
				case 0x03:
					switch(componentType)
					{
					case 0x01:
						return stringContentComponent = "EBU Teletext subtitles\n";
						break;
					case 0x02:
						return stringContentComponent = "associated EBU Teletext\n";
						break;
					case 0x03:
						return stringContentComponent = "VBI data\n";
						break;
					case 0x10:
						return stringContentComponent = "DVB subtitles (normal) with no monitor aspect ratio criticality\n";
						break;
					case 0x11:
						return stringContentComponent = "DVB subtitles (normal) for display on 4:3 aspect ratio monitor\n";
						break;
					case 0x12:
						return stringContentComponent = "DVB subtitles (normal) for display on 16:9 aspect ratio monitor\n";
						break;
					case 0x13:
						return stringContentComponent = "DVB subtitles (normal) for display on 2.21:1 aspect ratio monitor\n";
						break;
					case 0x14:
						return stringContentComponent = "DVB subtitles (normal) for display on a high definition monitor\n";
						break;
					case 0x15:
						return stringContentComponent = "DVB subtitles (normal) with plano-stereoscopic disparity for display on a high definition monitor\n";
						break;
					case 0x20:
						return stringContentComponent = "DVB subtitles (for the hard of hearing) with no monitor aspect ratio criticality\n";
						break;
						//ZDE JESTE DODELAT Z EN 300468 STR 40
					default:
						return stringContentComponent = "unknown\n";
					}
					break;
				default:
					return stringContentComponent = "unknown\n";
				}
			}
private: String^ switchComponentTag(int componentTag)
			{
				String^ stringComponentTag = System::Convert::ToString(componentTag);
				return stringComponentTag;
			}
private: String^ switchServiceType(int serviceType)
			{
				String^ stringServiceType;
				switch (serviceType)
				{
				case 0x01:
					return stringServiceType = "digital television service";
					break;
				case 0x02:
					return stringServiceType = "digital radio sound service";
					break;
				case 0x03:
					return stringServiceType = "Teletext service";
					break;
				case 0x04:
					return stringServiceType = "NVOD reference service";
					break;
				case 0x05:
					return stringServiceType = "NVOD time-shifted service";
					break;
				case 0x06:
					return stringServiceType = "mosaic service";
					break;
				case 0x07:
					return stringServiceType = "FM radio service";
					break;
				case 0x08:
					return stringServiceType = "DVB SRM service";
					break;
				case 0x0A:
					return stringServiceType = "advanced codec digital radio sound service";
					break;
				case 0x0B:
					return stringServiceType = "advanced codec mosaic service";
					break;
				case 0x0C:
					return stringServiceType = "data broadcast service";
					break;
				case 0x0D:
					return stringServiceType = "reserved for Common Interface Usage";
					break;
				case 0x0E:
					return stringServiceType = "RCS Map";
					break;
				case 0x0F:
					return stringServiceType = "RCS FLS";
					break;
				case 0x10:
					return stringServiceType = "DVB MHP service";
					break;
				case 0x11:
					return stringServiceType = "MPEG-2 HD digital television service";
					break;
				case 0x16:
					return stringServiceType = "advanced codec SD digital television service";
					break;
				case 0x17:
					return stringServiceType = "advanced codec SD NVOD time-shifted service";
					break;
				case 0x18:
					return stringServiceType = "advanced codec SD NVOD reference service";
					break;
				case 0x19:
					return stringServiceType = "advanced codec HD digital television service";
					break;
				case 0x1A:
					return stringServiceType = "advanced codec HD NVOD time-shifted service";
					break;
				case 0x1B:
					return stringServiceType = "advanced codec HD NVOD reference service";
					break;
				case 0x1C:
					return stringServiceType = "advanced codec frame compatible plano-stereoscopic HD digital television service";
					break;
				case 0x1D:
					return stringServiceType = "advanced codec frame compatible plano-stereoscopic HD NVOD time-shifted service";
					break;
				case 0x1E:
					return stringServiceType = "advanced codec frame compatible plano-stereoscopic HD NVOD reference service";
					break;
				default:
					return stringServiceType = "neplatna hodnota";
				}
			}
private: String^ switchFreeOrCaMode(bool freeOrCaMode)
			{
				String^ stringFreeOrCaMode;
				if (freeOrCaMode)
				{
					return stringFreeOrCaMode = "one or more streams may be controlled by a CA system";
				}
				return stringFreeOrCaMode = "all streams free";
			}
private: String^ switchRunningStatus(int runningStatus)
			{
				String^ stringRunningStatus;
				switch (runningStatus)
				{
				case 0:
					return stringRunningStatus = "undefined";
					break;
				case 1:
					return stringRunningStatus = "not running";
					break;
				case 2:
					return stringRunningStatus = "starts in a few seconds";
					break;
				case 3:
					return stringRunningStatus = "pausing";
					break;
				case 4:
					return stringRunningStatus = "running";
					break;
				case 5:
					return stringRunningStatus = "service off-air";
					break;
				default:
					return stringRunningStatus = "neplatna hodnota";
				}
			}
private: String^ switchBandwidth(int bandwidth)
			{
				String^ stringBandwidth;
				switch (bandwidth)
				{
				case 0:
					return stringBandwidth = "8 MHz";
					break;
				case 1:
					return stringBandwidth = "7 MHz";
					break;
				case 2:
					return stringBandwidth = "6 MHz";
					break;
				case 3:
					return stringBandwidth = "5 MHz";
					break;
				default:
					return stringBandwidth = "neplatna hodnota";
				}
			}
private: String^ switchCodingType(int codingType)
			{
				String^ stringCodingType;
				switch (codingType)
				{
				case 0:
					return stringCodingType = "neni definovan";
					break;
				case 1:
					return stringCodingType = "satelitni";
					break;
				case 2:
					return stringCodingType = "kabelovy";
					break;
				case 3:
					return stringCodingType = "pozemni";
					break;
				default:
					return stringCodingType = "neplatna hodnota";
				}
			}
private: String^ switchPriority(bool priority)
			{
				String^ stringPriority;
				if (priority)
				{
					return stringPriority = "HP (high priority)";
				}
				return stringPriority = "LP (low priority)";
			}
private: String^ switchTimeSlicing(bool timeSlicing)
			{
				String^ stringTimeSlicing;
				if (timeSlicing)
				{
					return stringTimeSlicing = "used";
				}
				return stringTimeSlicing = "not used";
			}
private: String^ switchConstellation(int constellation)
			{
				String^ stringConstellation;
				switch (constellation)
				{
				case 0:
					return stringConstellation = "QPSK";
					break;
				case 1:
					return stringConstellation = "16-QAM";
					break;
				case 2:
					return stringConstellation = "64-QAM";
					break;
				default:
					return stringConstellation = "neplatna hodnota";
				}
			}
private: String^ switchHierarchyInfo(int hierarchyInfo)
			{
				String^ stringHierarchyInfo;
				switch (hierarchyInfo)
				{
				case 0:
					return stringHierarchyInfo = "non-hierarchical, native interleaver";
					break;
				case 1:
					return stringHierarchyInfo = "α = 1, native interleaver";
					break;
				case 2:
					return stringHierarchyInfo = "α = 2, native interleaver";
					break;
				case 3:
					return stringHierarchyInfo = "α = 4, native interleaver";
					break;
				case 4:
					return stringHierarchyInfo = "non-hierarchical, in-depth interleaver";
					break;
				case 5:
					return stringHierarchyInfo = "α = 1, in-depth interleaver";
					break;
				case 6:
					return stringHierarchyInfo = "α = 2, in-depth interleaver";
					break;
				case 7:
					return stringHierarchyInfo = "α = 4, in-depth interleaver";
					break;
				default:
					return stringHierarchyInfo = "neplatna hodnota";
				}
			}
private: String^ switchCodeRate(int codeRate)
			{
				String^ stringCodeRate;
				switch (codeRate)
				{
				case 0:
					return stringCodeRate = "1/2";
					break;
				case 1:
					return stringCodeRate = "2/3";
					break;
				case 2:
					return stringCodeRate = "3/4";
					break;
				case 3:
					return stringCodeRate = "5/6";
					break;
				case 4:
					return stringCodeRate = "7/8";
					break;
				default:
					return stringCodeRate = "neplatna hodnota";
				}
			}
private: String^ switchGuardInterval(int guardInterval)
			{
				String^ stringGuardInterval;
				switch (guardInterval)
				{
				case 0:
					return stringGuardInterval = "1/32";
					break;
				case 1:
					return stringGuardInterval = "1/16";
					break;
				case 2:
					return stringGuardInterval = "1/8";
					break;
				case 3:
					return stringGuardInterval = "1/4";
					break;
				default:
					return stringGuardInterval = "neplatna hodnota";
				}
			}
private: String^ switchTransmissionMode(int transmissionMode)
			{
				String^ stringTransmissionMode;
				switch (transmissionMode)
				{
				case 0:
					return stringTransmissionMode = "2k mode";
					break;
				case 1:
					return stringTransmissionMode = "8k mode";
					break;
				case 2:
					return stringTransmissionMode = "4k mode";
					break;
				default:
					return stringTransmissionMode = "neplatna hodnota";
				}
			}
private: String^ switchDayOfWeek(int dayOfWeek)
			{
				String^ stringDayOfWeek;
				switch (dayOfWeek)
				{
				case 1:
					return stringDayOfWeek = "pondeli";
					break;
				case 2:
					return stringDayOfWeek = "utery";
					break;
				case 3:
					return stringDayOfWeek = "streda";
					break;
				case 4:
					return stringDayOfWeek = "ctvrtek";
					break;
				case 5:
					return stringDayOfWeek = "patek";
					break;
				case 6:
					return stringDayOfWeek = "sobota";
					break;
				case 7:
					return stringDayOfWeek = "nedele";
					break;
				default:
					return stringDayOfWeek = "neplatna hodnota";
				}
			}

};
};
